
/*
//массив schema для формирования таблицы данных forming_table()
// 0 - тип значения: 
// - number_str - номер строчки
// - checkbox - поле input -> checkbox, значением будет 2-ой элемент, названием будет 4-ый элемент
// - value - значение поля
// - valueText - значение поля закодированное функцией jsCodeHtmlChars()
// - assoc_value - значение будет браться из ассоциативного массива в 4 элементе, ключом будет значением поля (указанное в элементе 2),
//   при этом, занчением по умолчанию будет значение с ключем "_default"
// - date - значение поля будет преобразовано в дату с помощью функции preobDateOclock()
// - ftn - значением будет результат функции заданной в 4 элементе, 
//   функции будет передано 3 параметра: номер строчки, значение поля, данные всей строчки,
//   если функция возвращает массив со структурными данными, то массив должен быть заключев в еще один массив, то есть [массив со стр. данными]
// - act_link - ссылка, название и функция, которая будет вызываться при клике, должно быть в 4 элементе - [название ссылки, функция],
// при этом, если название ссылки не указано, то будет указано значение поля
// - list_elm - список элементов, вложенные элементы указываются в 4 элементе
// 1 - название, для вложенных элементов не обязательно
// 2 - имя поля (ключа), не всегда обязательно указывать, зависит от типа значения
// 3 - опции, задают стили CSS для вывода. Поддерживаются следующие опции
// - compact_bk - в мобильном (компактном) варианте название параметра будет иметь блочное отображение (display: block),
// - view_bk - значение будет дополнительно заключено в элемент имеющий блочное отображение (display: block),
// - center_fv - при стандартом (не компактном) отображении значение будет центрироваться,
// 4 - зависит от типа значения, нужно см. описание элемента номер 0,
// 5 - условие вывода элемента - функция должна выводить true или false. Необязательный элемент.
//
// Пояснение по функциям. Всем функциям будет передано 3 параметра: номер строчки, значение поля, данные всей строчки.
*/

var eng_scheme_comp={
  
  forming_table:function (data_v,schema,init_form)
    {
      var st_data=[];
      var st_table = ["table",[["class","table_control_t3"],["cellspacing","0"],["cellpadding","0"]],[]];
      
      var st_thead = ["thead",false,[]];
      var st_thead_tr=["tr",false,[]];
      var st_tbody = ["tbody",false,[]];
      
      // формируем st_thead
      var one_schema=[];
      for (var n=0;n<schema.length;n++)
        {
          one_schema=schema[n];
          if (one_schema)
            st_thead_tr[2].push(["td",false,one_schema[1]]);
        }
      st_thead[2].push(st_thead_tr);
      st_table[2].push(st_thead);
      
      // формируем st_tbody
      
      for (var i=0;i<data_v.length;i++)
        {
          var mas_td=this._forming_mas_td(i,data_v[i],schema);
          st_tbody[2].push(["tr",false,mas_td]);
          
        }
      st_table[2].push(st_tbody);
      
      st_data=st_table;
      
      if (init_form)
        {
          var name_form=init_form.name || "";
          st_data=["form",[["name",name_form],["action",""],["onsubmit","return (false);"],["method","post"]],[st_data]];
          if (init_form["id"])
            st_data[1].push(["id",init_form["id"]]);
        }
      
      return (st_data);
    },
  
  _forming_mas_td:function(i,row,schema)
    {
      var mas_td=[];
      var one_td=[];
      for (var n=0;n<schema.length;n++)
        {
          one_td=this._forming_one_td(i,row,schema,n);
          mas_td.push(one_td);
        }
      
      return (mas_td);
    },
  
  _forming_one_td:function(i,row,schema,n)
    {
      //wconsole(one_data);
      
      var one_schema=schema[n];
      var mas_atr=false;
      
      var v="";
      
      var opts=this._get_option_st(one_schema[3]);
      
      if (opts["center_fv"])
        {
          mas_atr=[["class","table_control_t3_center_fv"]];
        }
      
      var one_td=["td",mas_atr,"0"];
      
      v=this._forming_elm_st(i,row,one_schema,n);
      
      one_td[2]=v;
      
      return (one_td);
    },
  
  _forming_elm_st:function(i,row,one_schema,n)
    {
      var v="";
      
      var name_key=one_schema[2];
      var v_data="";
      var on_name_compact=true;
      var opts={};
      
      if (name_key && typeof (row[name_key]) != "undefined")
        {
          v_data = row[name_key];
        }
      
      if (typeof(one_schema[5]) != "undefined")
        {
          if (!one_schema[5](i,v_data,row))
            {
              return (v);
            }
        }
      
      opts=this._get_option_st(one_schema[3]);
      
      if (one_schema[0]=="list_elm")
        {
          v=[];
          var mm="";
          if (one_schema[4] && typeof(one_schema[4])=="object")
            {
              for (var k=0;k<one_schema[4].length;k++)
                {
                  mm=this._forming_elm_st(i,row,one_schema[4][k],k);
                  if (typeof(mm)=="object")
                    v=v.concat(mm);
                   else
                     v.push(mm);
                }
            }
        }
       else
        {
          
          
          if (one_schema[0] == "number_str")
            {
              v = i + 1;
            }
          else if (one_schema[0] == "value")
            {
              v = v_data;//one_data[name_key];
            }
          else if (one_schema[0] == "valueText")
            {
              v = jsCodeHtmlChars(v_data);
            }
          else if (one_schema[0] == "assoc_value")
            {
              
              if (one_schema[4])
                {
                  if (typeof (one_schema[4][v_data]) != "undefined")
                    {
                      v = one_schema[4][v_data];
                    }
                  else if (typeof (one_schema[4]["_default"]) != "undefined")
                    {
                      v = one_schema[4]["_default"];
                    }
                }
              //one_td[2]=v;
            }
          else if (one_schema[0] == "date")
            {
              v = (v_data == 0 ? "нет" : preobDateOclock(v_data));
              //one_td[2]=v;
            }
          else if (one_schema[0] == "ftn")
            {
              v = one_schema[4](i,v_data, row);
              //one_td[2]=v;
            }
          else if (one_schema[0] == "checkbox")
            {
              on_name_compact=false;
              v = [];
              var elm_ch=["input", [["type", "checkbox"], ["value", v_data]], false];
              if (one_schema[4]) elm_ch[1].push(["name",one_schema[4]]);
              v.push(["label", [["class", "elm_lbl_ckbox_only"]], [
                elm_ch
              ]]);
              //one_td[2]=v;
            }
          else if (one_schema[0] == "act_link")
            {
              let name_cl="elem_link_t1";
              if (opts["link_attention"]) name_cl="elm_action_link_attention";
              v =[["span",[["class",name_cl]],(one_schema[4][0] ? one_schema[4][0]:(v_data ? v_data:"")),[["click",function(){ one_schema[4][1](i,v_data,row); }]]]];
            }
          
          if (opts["view_bk"])
            {
              v=[["span",[["class","table_control_t3_view_bk"]],v]];
            }
        }
      
      if (on_name_compact && one_schema[1])
        {
          var class_name=(opts["compact_bk"] ? "table_control_t3_name_compact_bk":"table_control_t3_name_compact");
          var elm_name=["span", [["class", class_name]], one_schema[1] + ":"];
          if (typeof(v)=="object")
            {
              v=[].concat([elm_name],v);
            }
           else
            {
              v = [elm_name, v];
            }
        }
      
      return (v);
    },
  
  _get_option_st:function(opt_str)
    {
      var opts_assoc={};
      
      if (opt_str)
        {
          var opts_mas=opt_str.split(",");
          for (var n = 0; n < opts_mas.length; n++)
            {
              opts_assoc[opts_mas[n]] = true;
            }
        }
      
      return (opts_assoc);
    },
  
  
  forming_block_btn_oper:function(schema,num1,num2)
    {
      /*
      schema - массив с параметрами
      - form_name:"" - задает атрибут name для тега form. Если данный параметр не задан, то блок не будет в форме form.
      - parts - должен содержать информацию об составных частях управляющего блока, каждый элемент должен содержать:
       - title - заголовок части блока, необязательный элемент,
       - opts - опции, необязательный элемент, поддерживается опция line_bottom - у данной части будет с низу линия, 
       - elms - массив, описывающий элементы, каждый элемент должен содержать
       0 - тип, button - кнопка, act_link - активная ссылка, select - выпадающий список
       1 - название кнопки или ссылки
       2 - значение атрибута name для кнопок и списков. К значению будут добавлены параметры num1 и num2 - name="value_num1_num2"
       3 - список значений для select, массив каждый элемент должен в виде [значение, название]
       или [_optgroup, название группы, массив, каждый элемент должен быть в виде [значение, название]] 
       4 - функция, которая будет вызываться по клику по кнопке или ссылке. Функции будут переданы параметры num1, num2  
      
      num1 и num2 - дополнительные параметры, рекомендуется задавать в виде чисел. Не обязательно указывать.
      Эти параметры будут добавлены к названию атрибута name у кнопок и списков (через нижнюю черту "_"), 
      а также переданы в функции, вызываемые по клику по кнопкам и ссылкам
       */
      if (typeof(num1) == "undefined") num1="";
      if (typeof(num2) == "undefined") num2="";
      
      var st_mng=[];
      var st_vv=[];
      var st_parts=[];
      var one_part={};
      var st_part=[];
      var delim=false;
      var one_elm=[];
      var st_elm=[];
      var opts_part={};
      
      for (var i=0;i<schema.parts.length;i++)
        {
          one_part=schema.parts[i];
          
          opts_part={};
          if (one_part.opts)
            opts_part=this._get_option_st(one_part.opts);
          
          st_part=["div",[["class","control_oper_part"+(opts_part["line_bottom"] ? " control_oper_part_line_bottom":"")]],[]];
          
          if (one_part["title"])
            st_part[2].push(["div",[["class","control_oper_part_name"]],one_part["title"]]);
          
          for (var j=0;j<one_part["elms"].length;j++)
            {
              one_elm=one_part["elms"][j];
              if (delim) st_part[2].push(" ");
              
              st_elm=this._forming_btn_oper_elm(one_elm,num1,num2);
              
              if (st_elm)
                st_part[2].push(st_elm);
              
              delim=true;
            }
          
          st_parts.push(st_part);
        }
      
      if (schema["form_name"])
        {
          st_vv=[
           ["form",[["name",schema["form_name"]],["action",""],["onsubmit","return (false);"],["method","post"]],st_parts]
          ];
        }
       else
        {
          st_vv=st_parts;
        }
      
      st_mng=["div",[["class","control_oper_base"]],st_vv];
      
      return (st_mng);
    },
  
  _forming_btn_oper_elm:function(one_elm,num1,num2)
    {
      
      var st_elm=false;
      var name="";
      if (one_elm[2])
        {
          name=one_elm[2];
          name+=(num1 ?"_"+num1:"")+(num2 ?"_"+num2:"");
        }
      
      if (one_elm[0]=="button")
        {
          st_elm=["input",[["type","button"],["value",one_elm[1]],["class","control_oper_btn"],name?["name",name]:false],false,[["click",function(){ one_elm[4](num1,num2); }]]];
        }
       else if (one_elm[0]=="act_link")
         {
           st_elm=["span",[["class","control_oper_elm_link"]],one_elm[1],[["click",function(){ one_elm[4](num1,num2); }]]];
         }
       else if (one_elm[0]=="select")
         {
           var mas_opts=[];
           var item=[];
           var mas_opts_group=[];
           for (var i=0; i<one_elm[3].length; i++)
             {
               item=one_elm[3][i];
               if (item[0] == "_optgroup")
                 {
                   mas_opts_group=[];
                   for (var j=0; j<item[2].length; j++)
                     {
                       mas_opts_group.push(["option",[["value",item[2][j][0]]],item[2][j][1]]);
                     }
                   mas_opts.push(["optgroup",[["label",item[1]]],mas_opts_group]);
                 }
                else
                 {
                   mas_opts.push(["option", [["value", item[0]]], item[1]]);
                 }
             }
           st_elm=["select",[["name",name],["class","control_oper_select"]],mas_opts];
         }
      
      return (st_elm);
    },
  
  
  forming_list_num_pages:function(schema)
    {
      /* параметры schema: 
       num_all_items - количество записей;
       num_page - номер текущей страницы;
       num_all_pages - количество всех страниц;
       ftn - функция, которая должна выполняться, при клике на номер страницы. Функции передается номер страницы.
       */
      var st_data=[];
      
      var data_st_list = jsDataInitListNumbersPages(schema.num_page,schema.num_all_pages,function(n){ schema.ftn(n); });
      st_data = ["div",[["class","nav_list_page_main"]],[
        ["div",[["class","nav_list_page_info"]],"Всего записей: "+schema.num_all_items+", всего страниц: "+schema.num_all_pages],
        ["div",[["class","nav_list_page_pointer"]],['Показано: ',data_st_list] ]
       ]];
      
      return (st_data);
    },
  
  
  forming_form_filter:function(schema,num1,num2)
    {
      /*
      schema - массив с параметрами для формирования формы для фильтра данных:
      - form_name - имя формы,
      - elms - массив, описывающий поля формы, каждый элемент должен содержать:
       0 - тип: select, text или act_link,
       1 - название параметра,
       2 - значение атрибута name или id (для act_link),
       3 - параметр зависит от типа: для select - список значений ([ [значение, название],... ]), для других - false,
       4 - значение по умолчанию или текст (первоначальный) для act_link,
       5 - пояснение для input (placeholder),
       6 - дополнительное (одно) поле input -> checkbox, массив с элементами
        0 - название (пояснение),1 - значение атрибута name,2 - значение поля,3 - установлен флажок или нет (checked -> true или false).
       7 - функция, которая должна быть вызвана при каком-либо действии (к примеру, onchange у select, onclick у act_link).
           Функции будут переданы параметры num1 и num2. 
      - column - количество столбцов, можно указать 3 или 4, не обязательно указывать, по умолчанию 4.
      - numb_line - максимальное количество полей в одной части, можно указать 1 или 2, не обязательно указывать, по умолчанию 1.
      - btns - массив содержащий данные об кнопках формы, каждый элемент должен содержать:
       0 - текст на кнопке,
       1 - значение атрибута name кнопки,
       2 - функция, которая будет вызывана при клике по кнопке. Функции будут переданы параметры num1 и num2.
      - checks - массив содержащий данные об флажках (input->checkbox), которые будут расположены возле кнопок, каждый элемент должен содержать:
       0 - текст (пояснение),
       1 - значение атрибута name,
       2 - значение поля (значение атрибута value),
       3 - определяет установлен или нет влажок по умолчанию - true или false.
      - hids - массив содержащий данные об скрытых полях формы (input -> hidden), каждый элемент должен содержать:
       0 - значение атрибута name,
       1 - значение поля (значение атрибута value). 
      
      
      num1 и num2 - дополнительные параметры, рекомендуется задавать в виде чисел. Не обязательно указывать.
      Эти параметры будут добавлены к id у ссылки act_link (через нижнюю черту "_"), 
      а также переданы в функции, вызываемые по клику по кнопке или событию onchange списка select
       */
      if (typeof(num1) == "undefined") num1="";
      if (typeof(num2) == "undefined") num2="";
      
      var st_data=[];
      var st_form=[];
      var st_base=[];
      var st_part=[];
      
      
      var st_btns=[];
      var st_hids=[];
      var st_one_part=[];
      var one_st=[];
      var one_schema=[];
      var name_add=(num1 ?"_"+num1:"")+(num2 ?"_"+num2:"");
      var column = ( schema.column && (schema.column == 3 || schema.column == 4) ? schema.column:4);
      
      if (schema.elms)
        {
          var numb_line=(schema.numb_line && schema.numb_line == 2 ? schema.numb_line: 1);
          var mas_elms=[];
          for (var i=0;i<schema.elms.length;i++)
            {
              //убираем неиспользуемые элементы (которые равны false)
              if (schema.elms[i] != false)
                mas_elms.push(schema.elms[i]);
            }
          
          var size=mas_elms.length;
          var num_part=0;
          var numb_current=numb_line;
          var count=0;
          var need=0;
          var quantity=0;
          
          for (var i=0;i<size;i++)
            {
              one_schema=mas_elms[i];
              /*if (one_schema == false)
                {
                  continue;
                }*/
              //num_part++;
              
              one_st=this._forming_form_filter_elm(one_schema,num1,num2);
              if (one_st)
                {
                  st_one_part.push(one_st);
                  one_st=[];
                }
              
              if (numb_current > 1)
                {
                  count=size-i-1;
                  //need= (column * numb_line - num_part*numb_line - st_one_part.length);
                  need= (column * 1 - num_part*1)*1 + 1;
                  quantity=st_one_part.length+count;
                  //wconsole(column +"-"+ num_part+" + 1");
                  //wconsole("num_part "+num_part+" n "+i+" осталось "+count+" необходимо "+need +" количество "+quantity);
                  if (quantity < need) numb_current=1;
                }
              
              if (st_one_part.length >= numb_current || (st_one_part.length > 0 && i == (size-1) ))
                {
                  st_part.push(["li", false, st_one_part]);
                  st_one_part=[];
                  num_part++;
                }
              
              if (num_part >= column) num_part=0;
            }
        }
      
      st_base=["ul",[["class","gn_filter_base"+((column == 3 || column == 4) ? " gn_filter_base_"+column:"")]],st_part];//gn_filter_base_4
      
      if (schema.checks && schema.checks.length > 0)
        {
          
          for (var i=0;i<schema.checks.length;i++)
            {
              one_schema=schema.checks[i];
              
              one_st=["span",[["class","gn_filter_bottom_chk_elm"]],[
                ["label",false,[
                  ["input",[["type","checkbox"],["name",one_schema[1]],["value",one_schema[2]], one_schema[3]?["checked","checked"]:false],false],
                  " "+one_schema[0]
                 ]]
               ]];
              st_btns.push(one_st);
            }
        }
      
      if (schema.btns && schema.btns.length > 0)
        {
          var delim=false;
          for (var i=0;i<schema.btns.length;i++)
            {
              one_schema=schema.btns[i];
              if (delim) st_btns.push(" ");
              
              one_st=this._forming_form_filter_btn(one_schema,num1,num2);
              delim=true;
              st_btns.push(one_st);
            }
        }
      
      if (schema.hids && schema.hids.length > 0)
        {
          for (var i=0;i<schema.hids.length;i++)
            {
              one_schema=schema.hids[i];
              one_st=["input",[["type","hidden"],["name",one_schema[0]],["value",one_schema[1]]],false];
              st_hids.push(one_st);
            }
        }
      
      st_form=["form",[["name",schema.form_name+name_add],["action",""],["onsubmit","return (false);"],["method","post"]],[]];
      if (st_base) st_form[2].push(st_base);
      if (st_btns.length > 0) st_form[2].push(["div",[["class","gn_filter_bottom"]],st_btns]);
      if (st_hids.length > 0) st_form[2]=st_form[2].concat(st_hids);
      
      st_data=["div",[["class","gn_filter_main marginTB10"]],[st_form]];
      
      return (st_data);
    },
  
  _forming_form_filter_elm:function(one_schema,num1,num2)
    {
      var st_elm=false;
      var st_pole=false;
      var name_add=(num1 ?"_"+num1:"")+(num2 ?"_"+num2:"");
      var st_param=false;//данные дополнительного параметра input->checkbox
      
      if (one_schema[0]=="select")
        {
          var mas_opts=[];
          var one_opt=[];
          for (var j=0;j<one_schema[3].length;j++)
            {
              one_opt=["option",[["value",one_schema[3][j][0]]],one_schema[3][j][1]];
              if (one_schema[4] && one_schema[3][j][0] == one_schema[4])
                one_opt[1].push(["selected","selected"]);
              mas_opts.push(one_opt);
            }
          
          st_pole=["select",[["name",one_schema[2]],["class","gn_filter_field_select"]],mas_opts];
          if (one_schema[7])
            st_pole[3]=[["change",function(){ one_schema[7](num1,num2); }]];
        }
      else if (one_schema[0]=="text")
        {
          st_pole=["input",[["type","text"],["name",one_schema[2]],["class","gn_filter_field_text"],["value",(one_schema[4]?jsCodeHtmlChars(one_schema[4]+""):"")],["placeholder",(one_schema[5]?one_schema[5]+"":"")]],false];
        }
      else if (one_schema[0]=="act_link")
        {
          st_pole=["span",[["class","gn_filter_link_t1"],["id",one_schema[2]+name_add]],one_schema[4],[["click",function(){ one_schema[7](num1,num2); }]]];
        }
      
      if (st_pole && one_schema[6])
        {
          var param_sch=one_schema[6];
          //<label><span class='text_nowrap gn_filter_chk_elm'><input type='checkbox' name='logical_and' value='on' checked='checked'> все слова</span></label>
          st_param=["label",false,[
            ["span",[["class","text_nowrap gn_filter_chk_elm"]],[
              ["input",[["type","checkbox"],["name",param_sch[1]],["value",param_sch[2]],param_sch[3]?["checked","checked"]:false],false],
              " "+param_sch[0]
             ]]
           ]];
        }
      
      if (st_pole)
        {
          var mas=[st_pole];
          if (st_param) mas.push(st_param);
          
          st_elm=["span",[["class","gn_filter_wrap"]],[
           ["span",[["class","gn_filter_name"]],one_schema[1]],
           ["span",[["class","gn_filter_wrap_field"]],mas]
          ]];
        }
      
      return (st_elm);
    },
  
  _forming_form_filter_btn:function(one_schema,num1,num2)
    {
      var st_elm=["input",[["type","button"],["name",one_schema[1]],["value",one_schema[0]],["class","gn_filter_btn"]],false,[["click",function(){ one_schema[2](num1,num2); }]]];
      
      return (st_elm);
    },
  
  
  forming_fields_form_setngs: function(scheme,act)
    {
      // scheme - массив с данными формы (данные как с настроек CMS) (дописать)
      
      //wconsole(scheme);
      
      var st_form=[];
      var st_field=[];
      var st_mas_elms=[];
      
      for (let i=0; i<scheme.length; i++)
        {
          st_field= this._forming_one_field_form_setngs(scheme[i]);
          st_mas_elms.push(st_field);
        }
      
      if (act && (act.btn_save || act.btn_cancel))
        {
          var st_act=[];
          if (act.btn_save)
            {
              st_act.push(["input",[["class","elm_btn"],["name","_btn_save"],["value","Сохранить"],["type","button"]],false,[["click",function(){ act.btn_save.fn_action(); }]]]);
            }
          st_act.push(" ");
          if (act.btn_cancel)
            {
              st_act.push(["input",[["class","elm_btn"],["name","_btn_cancel"],["value","Отмена"],["type","button"]],false,[["click",function(){ act.btn_cancel.fn_action(); }]]]);
            }
          
          st_mas_elms.push(["div",[["class","wrap_elm_btn"]],st_act]);
        }
      
      //st_form=["form",[["name",jsCodeHtmlChars(name_form)],["action",""],["onsubmit","return (false);"]],[["div",[["class","dt_entry_main"]],st_mas_elms]] ];
      
      return (st_mas_elms);
    },
  
  _forming_one_field_form_setngs: function(sc_field)
    {
      var st_elm=[],st_elm2=[],t_help="";
      //wconsole("схема формы",sc_field);
      
      if (sc_field[1] == "text" || sc_field[1] == "numeric")
        {
          st_elm.push( ["input",[["class","dt_entry_field_text"],["name",jsCodeHtmlChars(sc_field[0])],["value",""],["type","text"],["placeholder",""]]] );
        }
      else if (sc_field[1] == "select")
        {
          st_elm2=["select",[["name",jsCodeHtmlChars(sc_field[0])],["class","dt_entry_field_select"]],[]];
          for (let n=0; n<sc_field[2].length; n++)
            {
              st_elm2[2].push(["option",[["value",jsCodeHtmlChars(sc_field[2][n][0])]],jsCodeHtmlChars(sc_field[2][n][1])]);
            }
          st_elm.push(st_elm2);
        }
      else if (sc_field[1] == "checkbox")
        {
          st_elm.push( ["label",false,[
            ["input",[["class","dt_entry_field_chkbox"],["name",jsCodeHtmlChars(sc_field[0])],["value",jsCodeHtmlChars(sc_field[2][1])],["type","checkbox"]]],
            ["span",false," "+sc_field[4]]
          ]] );
        }
      
      if (sc_field[5]) t_help=sc_field[5];
      
      var st_field=["div",[["class","dt_entry_wrap"],["id","block_field_form_"+jsCodeHtmlChars(sc_field[0])]],[
        sc_field[1] != "checkbox" ? ["div",[["class","dt_entry_name"]],sc_field[4]] : false,
        ["div",[["class","dt_entry_wrap_field"]], st_elm ],
        ["div",[["data-dt_entry_one_err",jsCodeHtmlChars(sc_field[0])]],""],
        t_help ? ["div",[["class","dt_entry_help_small"]],t_help] : false
       ]];
      
      return (st_field);
    },
  
  
  convert_setngs_data_verific: function(scheme)
    {
      // Функция получает массив-схему описывающую настройки (поля формы) (структра данных описана в классе php eng_scheme_data::convert_setngs_data_verific() )
      // Вернет данные для проверки значений указанных в форме с помощью функции processing_data_form().
      
      var masVerif=[],elm=[],one_verif=[],type_field="text",type_value="text",must_v=false;
      var check_value=false,check_init="",default_value="";
      
      for (let n=0; n<scheme.length; n++)
        {
          elm=scheme[n];
          
          type_field="text";
          type_value="text";
          
          must_v=false;
          check_value=false;
          check_init="";
          default_value="";
          
          if (elm[1] == "text")
            {
              type_field="text";
              must_v=false;
            }
          else if (elm[1] == "numeric")
            {
              type_field="text";
              type_value="numeric";
              must_v=true;
              //check_value="";
            }
          else if (elm[1] == "select")
            {
              type_field="select";
              must_v=false;
            }
          else if (elm[1] == "checkbox")
            {
              type_field="checkbox";
              must_v=false;
              default_value=elm[2][0];
            }
          
          one_verif=[elm[0],elm[0],type_field,type_value,true,must_v,"",check_value,check_init,default_value,"Нужно указать значение","Значение указано неверно",elm[4]];
          
          masVerif.push(one_verif);
        }
      
      return (masVerif);
    },
  
  set_values_form_scheme: function (elm_form,scheme,values)
    {
      var obj_form = engine_elm_html.get_obj_form(elm_form);
      var one_elm = [],obj_field=false;
      
      for (let n = 0; n < scheme.length; n++)
        {
          one_elm = scheme[n];
          //wconsole("one scheme",one_elm);
          obj_field=obj_form.elements[one_elm[0]];
          
          if (!obj_field) continue;
          
          if (one_elm[1] == "text" || one_elm[1] == "numeric")
            {
              obj_field.value = values[one_elm[0]];
            }
          else if (one_elm[1] == "select")
            {
              set_value_pole_select(obj_field, values[one_elm[0]]);
            }
          else if (one_elm[1] == "checkbox")
            {
              obj_field.checked = (values[one_elm[0]] == one_elm[2][1] ? true : false);
            }
          
        }
      
      return (true);
    }
  
  
};

/*
   var schema_filter = {
     form_name: "filter_subs_users",
     column: 4,
     numb_line: 2,
     elms: [
      ["select","title","atr_name",[["value1","значение 1"],["value2","значение 2"]],false,"",false,false],
      ["select","Тест","atr_test",[["value1","значение 10"],["value2","значение 20"]]],
      ["select","Фильтр","type_users",[["all","Все"],["active","Активированные"],["inactive","Не активированные"]],"active","",false,function(num1,num2){ alert ("text"+num1+num2); }],
      ["text","Фильтр 2","num_users",false,"10","пояснение",false,false],
      ["text","Фильтр 3","name_users",false,"","Имя пользователя",
        ["Все слова","logical_and","on",true],false],
      ["act_link","Параметр","elm_param_filter",false,"Клик","",false,function(num1,num2){ alert(num1+"_"+num2); engine_elm_html.set_html("elm_param_filter_11_17","Выполнено"); }],
     ],
     btns: [
      ["Показать","action_view",function(){ alert("view"); alert( ([]) ? "true":"false" ); }],
      ["Добавить","action_add",function(){ alert("add"); }]
     ],
     checks:[
      ["Тут флажок","pole_flag","value_f1",true],
      ["Тут флажок 2","pole_flag2","value_f2",false]
     ],
     hids:[
      ["name_pl_1","value1"],
      ["name_pl_2","value2"]
     ]
   };
   */