
// функция для работы с гугл картами

function eng_master_google_maps(elm_block,opts)
  {
    this.elm_block = engine_elm_html.get_obj(elm_block);
    
    this.map = false;
    
    this.opts = {
      longitude: 1,
      latitude: 1,
      zoom: 12,
      on_zoom_point: false
    };
    
    this.drag_placemark = false;
    
    this.obj_clusterer = false;
    
    this.mas_init_icons={};
    
    this.init_data = function()
      {
        
        if (typeof(opts) != "undefined")
          {
            for (let n in this.opts)
              {
                if (typeof(opts[n]) != "undefined") this.opts[n]=opts[n];
              }
          }
        //wconsole("master google opts",this.opts);
      }
    
    this.create_maps = function()
      {
        this._create_maps(this.opts.latitude,this.opts.longitude,this.opts.zoom);
      }
    
    this._create_maps = function(set_latitude,set_longitude,num_zoom)
      {
        // Создаем карту
        engine_elm_html.set_html(this.elm_block, "");// очищаем блок (к примеру, визуальный редактор может добавлять пробелы)
        /*
        var myOptions = {
          center: [set_latitude, set_longitude],
          zoom: num_zoom,
          type: "yandex#map"
        };
        this.map = new ymaps.Map(this.elm_block, myOptions);
        //map.setCenter(new YMaps.GeoPoint(this.set_longitude, this.set_latitude), this.set_zoom);// долгота, широта | longitude - долгота, latitude - широта
        
        //map.setType(YMaps.MapType.MAP);//MAP , SATELLITE , HYBRID 
        this.map.controls.add("mapTools");//стандартный набор кнопок
        this.map.controls.add("zoomControl");// Добавление кнопки изменения масштаба 
        this.map.controls.add("typeSelector");// Добавление списка типов карты
        */
        var latlng = new google.maps.LatLng(set_latitude, set_longitude);
        var myOptions = {
          zoom: num_zoom,
          center: latlng,
          mapTypeId: google.maps.MapTypeId.ROADMAP,
          scrollwheel: false,
          zoomControl: true,
          zoomControlOptions: {style: google.maps.ZoomControlStyle.LARGE}
        };
        
        this.map = new google.maps.Map(engine_elm_html.get_obj(this.elm_block), myOptions);
        
        return (true);
      }
    
    this.add_mas_points_to_map = function(mas_points,on_open_first_point)
      {
        // Добавляем массив точек на карту
        // mas_points - массив с точками
        // on_open_first_point - true, если нужно открыть первую точку, иначе false
        
        if (typeof(on_open_first_point) == "undefined") on_open_first_point = false;
        
        var mas_add_points = [];
        
        var n, one_point, title="",marker=false,infowindow=false;
        for (n = 0; n < mas_points.length; n++)
          {
            one_point = mas_points[n];
            if (!one_point["longitude"] || !one_point["latitude"]) continue;
            
            title = decodeURIComponent(one_point["name"]);
            marker = new google.maps.Marker(
            {
              "position": new google.maps.LatLng(one_point["latitude"], one_point["longitude"]),
              "title": title,
              "map": this.map
            }
            );
            
            infowindow = new google.maps.InfoWindow({content: "<div style='font-weight: bold;'>" + title + "</div>"});
            
            google.maps.event.addListener(marker, 'click', function ()
            {
              infowindow.open(this.map, marker);
            });
            
            mas_add_points[mas_add_points.length] = {
              "marker": marker,
              "infowindow": infowindow
            };
            
          }
        
        if (on_open_first_point && mas_add_points.length > 0)
          {
            //mas_add_points[0].balloon.open();
            var one_data = mas_add_points[0];
            one_data["infowindow"].open(this.map, one_data["marker"]);
          }
        
        return (mas_add_points);
      }
    
    this.add_listener_click = function(back_fn)
      {
        
        google.maps.event.addListener(this.map, "click", function (e)
        {
          //wconsole("click event latLng",e.latLng.lat(),e.latLng.lng());
          back_fn([e.latLng.lat(),e.latLng.lng()])
        });
      }
    
    this.create_drag_placemark = function(coor_point,back_fn)
      {
        // Функция добавляет новую метку на карту, 
        // если метка уже есть, то поменяет координаты (к примеру, при клике в другое место на карте)
        var _this=this;
        //wconsole("create drag placemark - coor_point",coor_point);
        var setPointPlacemark = new google.maps.LatLng(coor_point[0], coor_point[1]);//[latitude, longitude];
        if (this.drag_placemark)
          {
            // Метка уже есть, устанавливаем новые координаты
            
            //setPointPlacemark = new google.maps.LatLng(latitude, longitude);//[latitude, longitude];
            this.drag_placemark.setPosition(setPointPlacemark);
            
          }
        else
          {
            // Добавляем новую метку на карту
            
            this.drag_placemark = new google.maps.Marker(
            {
              "position": setPointPlacemark,
              "title": "Перетащите эту метку в нужное место",
              draggable: true,
              "map": this.map
            }
            );
            
            google.maps.event.addListener(this.drag_placemark, 'drag', function (e)
            {
              var GeoKoor = e.latLng;
              //wconsole("координаты drag",GeoKoor.lat(),GeoKoor.lng());
              
              back_fn([GeoKoor.lat(),GeoKoor.lng()]);
            });
            
          }
        
        return (true);
      }
    
    this.query_search_address = function(v_adr,back_fn)
      {
        
        var geocoder = new google.maps.Geocoder();
        geocoder.geocode({'address': v_adr},
        function (results, status)
        {
          var point = false;
          if (status == google.maps.GeocoderStatus.OK)
            {
              var res=results[0].geometry.location;
              //wconsole("google search address",res);
              point = [res.lat(),res.lng()];
              
            }
          else
            {
              //wconsole("поиск адреса на google карте: ничего не найдено!")
            }
          back_fn(point);
        });
    
      }
    
    this.move_map_point = function(coor_point)
      {
        //this.map.panTo(coor_point);
        var setPoint = new google.maps.LatLng(coor_point[0], coor_point[1]);//[latitude, longitude];
        this.map.setCenter(setPoint);
      }
    
    this.close_map = function()
      {
        
        //if (this.map) this.map.destroy();
        this.drag_placemark = false;
        this.map=false;
      }
    
    
    
    this.add_listener_size_change = function(back_fn)
      {
        
        google.maps.event.addListener( this.map, 'bounds_changed', function(event){ back_fn( event ); });
      }
    
    this.get_coor_area_map = function()
      {
        
        var coor_view_maps = this.map.getBounds();
        
        var latitude_bottom = coor_view_maps.getSouthWest().lat();
        var latitude_top = coor_view_maps.getNorthEast().lat();
        
        var longitude_left = coor_view_maps.getNorthEast().lng();
        var longitude_right = coor_view_maps.getSouthWest().lng();
        var _center_maps = this.map.getCenter();
        //wconsole("_center maps google",_center_maps);
        var center=[_center_maps.lat(),_center_maps.lng()];
        
        var coor_bounds = [latitude_bottom, latitude_top, longitude_left, longitude_right];
        
        return ({"center": center, "bounds": coor_bounds});
      }
    
    this.create_claster = function()
      {
        //создадим кластер, карта уже должна быть создана
        
        if (!this.map) return (false);
        
        var opts_clusterer = {"imagePath":dir_http+"/addapplication/google/markerclusterer/images/m"};
        this.obj_clusterer = new MarkerClusterer(this.map, false, opts_clusterer);
        
        return (true);
      }
    
    this.add_mas_init_icons = function(mas)
      {
        this.mas_init_icons=mas;
      }
    
    this.add_mas_points_claster = function(mas_points)
      {
        
        var one_point, placemark, is_link, geo_object = [], preset_icon="", mas_id=[];
        var mas_markers=[],marker;
        
        for (var n = 0; n < mas_points.length; n++)
          {
            one_point = mas_points[n];
            //wconsole ( one_point["latitude"] + " " + one_point["longitude"] );
            if (!one_point["longitude"] || !one_point["latitude"]) continue;
            is_link = (one_point["link"] ? true : false);
            
            mas_id.push(one_point["id"]);
            marker = this.add_infowindow_marker(one_point);
            
            mas_markers.push(marker);
            
          }
        
        this.obj_clusterer.addMarkers(mas_markers);
        return (mas_id);
      }
    
    this.add_infowindow_marker = function (one_point)
      {
        var _this=this;
        var latLng = new google.maps.LatLng(one_point["latitude"], one_point["longitude"]);
        
        var marker = new google.maps.Marker({
          position: latLng,
          map: this.map,
          title: jsCodeHtmlChars(one_point["name"])
        });
        //wconsole(one_point["ballon_content"]);
        var infowindow = new google.maps.InfoWindow({content: one_point["ballon_content"]});
        
        google.maps.event.addListener(marker, 'click', function ()
        {
          infowindow.open(_this.map, marker);
        });
        
        return (marker);
      }
    
    this._get_preset_icon = function(type_icon)
      {
        var preset = "";// this.mas_init_icons["default"][0];
        //wconsole (type_icon);
        /*
        if (type_icon != "" && type_icon != "default" && typeof (this.mas_init_icons["icons"][type_icon]) != "undefined")
          {
            preset = this.mas_init_icons["icons"][type_icon][0];
            //wconsole (3333);
          }
        */
        return (preset);
      }
    
    this.cluster_clear_points = function()
      {
        
        this.obj_clusterer.clearMarkers();
      }
    
    this.init_data();
  }

