
// longitude - долгота (x) диапазон от -180 до 180
// latitude - широта (y) диапазон от -90 до 90

// функция для работы с яндекс картами

function eng_master_yandex_maps(elm_block,opts)
  {
    this.elm_block = engine_elm_html.get_obj(elm_block);
    
    this.map = false;
    
    this.opts = {
      longitude: 1,
      latitude: 1,
      zoom: 12,
      on_zoom_point: false
    };
    
    this.drag_placemark = false;
    
    this.obj_clusterer = false;
    
    this.mas_init_icons={};
    
    this.init_data = function()
      {
        
        if (typeof(opts) != "undefined")
          {
            for (let n in this.opts)
              {
                if (typeof(opts[n]) != "undefined") this.opts[n]=opts[n];
              }
          }
        //wconsole("master yandex opts",this.opts);
      }
    
    this.create_maps = function()
      {
        this._create_maps(this.opts.latitude,this.opts.longitude,this.opts.zoom);
      }
    
    this._create_maps = function(set_latitude,set_longitude,num_zoom)
      {
        // Создаем карту
        engine_elm_html.set_html(this.elm_block,"");// очищаем блок (к примеру, визуальный редактор может добавлять пробелы)
        
        var myOptions = {
          center: [set_latitude, set_longitude],
          zoom: num_zoom,
          type: "yandex#map"
        };
        this.map = new ymaps.Map(this.elm_block, myOptions);
        //map.setCenter(new YMaps.GeoPoint(this.set_longitude, this.set_latitude), this.set_zoom);// долгота, широта | longitude - долгота, latitude - широта
        
        //map.setType(YMaps.MapType.MAP);//MAP , SATELLITE , HYBRID 
        this.map.controls.add("mapTools");//стандартный набор кнопок
        this.map.controls.add("zoomControl");// Добавление кнопки изменения масштаба 
        this.map.controls.add("typeSelector");// Добавление списка типов карты
        
        return (true);
      }
    
    this.add_mas_points_to_map = function(mas_points,on_open_first_point)
      {
        // Добавляем массив точек на карту
        // mas_points - массив с точками
        // on_open_first_point - true, если нужно открыть первую точку, иначе false
        
        if (typeof(on_open_first_point) == "undefined") on_open_first_point = false;
        
        var mas_add_points = [];
        
        var n, one_point;
        for (n = 0; n < mas_points.length; n++)
          {
            one_point = mas_points[n];
            if (!one_point["longitude"] || !one_point["latitude"]) continue;
            
            var placemark = new ymaps.Placemark([one_point["latitude"], one_point["longitude"]], {
              //iconContent : "",
              balloonContent: "<div style='font-weight: bold;'>" + (one_point["name"]) + "</div>"//decodeURIComponent
            }, {
              draggable: false,
              hideIconOnBallon: false
            }
            );//, {draggable: true , hasBalloon: false});
            //placemark.name = "<p>"+ (one_point["name"])+"</p>";
            //var short_description =(one_point["short_description"]);
            //placemark.description = "";
            //map.addOverlay(placemark);
            
            this.map.geoObjects.add(placemark);
            
            mas_add_points[mas_add_points.length] = placemark;
            
          }
        
        if (on_open_first_point && mas_add_points.length > 0)
          {
            mas_add_points[0].balloon.open();
          }
        
        return (mas_add_points);
      }
    
    this.add_listener_click = function(back_fn)
      {
        this.map.events.add("click", function (e)
        {
          //wconsole(e.get("coorPosition"));
          back_fn(e.get("coordPosition"));
        });
      }
    
    this.create_drag_placemark = function(coor_point,back_fn)
      {
        // Функция добавляет новую метку на карту, 
        // если метка уже есть, то поменяет координаты (к примеру, при клике в другое место на карте)
        var _this=this;
        
        if (this.drag_placemark)
          {
            // Метка уже есть, устанавливаем новые координаты
            this.drag_placemark.geometry.setCoordinates(coor_point);
          }
        else
          {
            // Добавляем новую метку на карту
            this.drag_placemark = new ymaps.Placemark(coor_point,
            {hintContent: 'Перетащите эту метку в нужное место'},
            {draggable: true, hasBalloon: false, preset: 'twirl#violetDotIcon'}
            );
            //this.drag_placemark.name = "Метка";
            //this.drag_placemark.description = "Перетащите эту метку в нужное место";
            this.map.geoObjects.add(this.drag_placemark);
            
            this.drag_placemark.events.add("drag", function (e)
            {
              
              var GeoCoor = _this.drag_placemark.geometry.getCoordinates();
              
              //wconsole("новые координаты метки",GeoCoor);
              // GeoCoor[0] -> latitude
              // GeoCoor[1] -> longitude
              
              back_fn(GeoCoor)
            }
            );
          }
        
        return (true);
      }
    
    this.query_search_address = function(v_adr,back_fn)
      {
        ymaps.geocode(v_adr, {results: 10}).then(
        function (res)
        {
          var point=false;
          if (res.geoObjects.getLength())
            {
              point = res.geoObjects.get(0).geometry.getCoordinates();
              //this_obj.create_drag_placemark(1, 1, point);
              //this_obj.map.panTo(point);
            }
          else
            {
              //wconsole("поиск адреса на яндекс карте: ничего не найдено!")
            }
          back_fn(point);
        });
      }
    
    this.move_map_point = function(coor_point)
      {
        this.map.panTo(coor_point);
      }
    
    this.close_map = function()
      {
        if (this.map) this.map.destroy();
        this.drag_placemark = false;
      }
    
    
    this.add_listener_size_change = function(back_fn)
      {
        this.map.events.add('boundschange', function (event)
        {
          back_fn();
        });
      }
    
    this.get_coor_area_map = function()
      {
        var center = this.map.getCenter();
        var _coor_bounds = this.map.getBounds();
        
        var latitude_bottom = _coor_bounds[0][0];
        var latitude_top = _coor_bounds[1][0];
        
        var longitude_left = _coor_bounds[0][1];
        var longitude_right = _coor_bounds[1][1];
        
        var coor_bounds = [latitude_bottom,latitude_top,longitude_left,longitude_right];
        
        return ({"center":center,"bounds":coor_bounds});
      }
    
    this.create_claster = function()
      {
        //создадим кластер, карта уже должна быть создана
        
        if (!this.map) return (false);
        this.obj_clusterer = new ymaps.Clusterer();
        
        this.map.geoObjects.add(this.obj_clusterer);
        
        return (true);
      }
    
    this.add_mas_init_icons = function(mas)
      {
        this.mas_init_icons=mas;
      }
    
    this.add_mas_points_claster = function(mas_points)
      {
        
        var one_point, placemark, is_link, geo_object = [], preset_icon="", mas_id=[];
        
        for (var n = 0; n < mas_points.length; n++)
          {
            one_point = mas_points[n];
            //wconsole ( one_point["latitude"] + " " + one_point["longitude"] );
            if (!one_point["longitude"] || !one_point["latitude"]) continue;
            is_link = (one_point["link"] ? true : false);
            
            mas_id.push(one_point["id"]);
            
            preset_icon = this._get_preset_icon(one_point["type_icon"]);
            //wconsole (preset_icon);
            geo_object.push(new ymaps.GeoObject(
            {
              geometry: {type: "Point", coordinates: [one_point["latitude"], one_point["longitude"]]},
              properties: {
                clusterCaption: jsCodeHtmlChars(one_point["name"]),
                balloonContent: one_point["ballon_content"] //this.forming_ballon_content( one_point )
                /* "<div style='font-weight: bold;'>" 
                + (is_link ? '<a href="'+one_point['link']+'">' : "") + jsCodeHtmlChars(one_point["name"])
                + (is_link ? '</a>' : '')
                +"</div>" */
              }
            },
            {
              preset: preset_icon
            }
            ));
            
          }
        
        this.obj_clusterer.add(geo_object);
        
        return (mas_id);
      }
    
    this._get_preset_icon = function(type_icon)
      {
        var preset = this.mas_init_icons["default"][0];
        //wconsole (type_icon);
        if (type_icon != "" && type_icon != "default" && typeof (this.mas_init_icons["icons"][type_icon]) != "undefined")
          {
            preset = this.mas_init_icons["icons"][type_icon][0];
            //wconsole (3333);
          }
    
        return (preset);
      }
    
    this.cluster_clear_points = function()
      {
        this.obj_clusterer.removeAll();
      }
    
    this.init_data();
  }


// Общие функции для работы с картами в пользовательской части сайта и в ПУ, а также для поиска на карте

function gl_eng_manag_maps_cp(elm_block,opts,mas_points,elm_block_show,back_fn)//m_center,elm_form,opts_form//eng_yandex_maps_cp()
  {
    
    this.mas_setgs={
      "longitude": 0,
      "latitude": 0,
      "num_zoom": 12,
      "num_zoom_point": 14,
      "default_address": "",
      "name_maps": ""
    };
    
    this.obj_map = false;
    this.map = false;
    this.s_zoom_maps = 12;// s_zoom_yandex_maps;
    this.s_zoom_maps_point = 14;// s_zoom_yandex_maps_point;
    
    this.opts = {
      longitude: 0,// s_longitude_maps,
      latitude: 0,// s_latitude_maps,
      zoom: this.s_zoom_maps,
      on_zoom_point: false
    };
    /*
    this.opts_form = {
      elm_pf_search: false,
      elm_button_search: false,
      elm_pf_longitude: "longitude",
      elm_pf_latitude: "latitude"
    };
    */
    this.geoResult = [];
    this.m_center = false;
    this.mas_point_add_to_maps = new Array();
    this.drag_placemark = false;
    
    //this.go_function_begin_init_maps = false;
    //this.go_function_end_init_maps = false;
    
    //this.s_name_form_bind_maps = "";
    this.open_first_point_maps = false;
    this.set_zoom_maps_point = false;
    this.mas_points = [];
    
    this.elm_block_show = false;
    this.elm_block = false;
    //this.elm_form = false;
    this.back_fn = false;
    
    this.set_longitude = 0;
    this.set_latitude = 0;
    
    this.on_init_search_address = false;
    
    this.init_data = function()
      {
        var _mas_setgs=false;
        if (typeof(mas_setgs_maps_cp) != "undefined")
          {
            _mas_setgs=mas_setgs_maps_cp;
          }
        
        if (_mas_setgs)
          {
            for (let n in this.mas_setgs)
              {
                if (typeof(_mas_setgs[n]) != "undefined") this.mas_setgs[n]=_mas_setgs[n];
              }
          }
        //this.mas_setgs["default_address"]=decodeURIComponent(this.mas_setgs["default_address"]);
        //wconsole("mas setgs",this.mas_setgs);
        opts = (typeof(opts) != "undefined" ? opts : {});
        //m_center = (typeof(m_center) != "undefined" ? m_center : false);
        elm_block_show = (typeof(elm_block_show) != "undefined" ? elm_block_show : false);
        //elm_form = (typeof(elm_form) != "undefined" ? elm_form : false);
        //opts_form = (typeof(opts_form) != "undefined" ? opts_form : {});
        
        this.elm_block = elm_block;
        
        //mas_points = (typeof(mas_points) != "undefined" ? mas_points : []);
        this.mas_points = (typeof(mas_points) != "undefined" ? mas_points : []);
        
        this.opts.longitude = opts.longitude || this.mas_setgs.longitude;
        this.opts.latitude = opts.latitude || this.mas_setgs.latitude;
        this.opts.on_zoom_point = (typeof (opts.on_zoom_point) != "undefined" ? opts.on_zoom_point : this.opts.on_zoom_point);
        this.opts.zoom = opts.zoom || (this.opts.on_zoom_point ? this.mas_setgs.num_zoom_point : this.mas_setgs.num_zoom);
        //wconsole("init opts",this.opts);
        
        //this.m_center = m_center;// (typeof (m_center) != "undefined" ? m_center : false);
        this.elm_block_show = elm_block_show;// (typeof (elm_block_show) != "undefined" ? elm_block_show : false);
        //this.elm_form = elm_form;// (typeof (elm_form) != "undefined" ? elm_form : false);
        //opts_form = (typeof(opts_form) != "undefined" ? opts_form : {});
        /*
        this.opts_form.elm_pf_search = opts_form.elm_pf_search || this.opts_form.elm_pf_search;
        this.opts_form.elm_button_search = opts_form.elm_button_search || this.opts_form.elm_button_search;
        this.opts_form.elm_pf_longitude = opts_form.elm_pf_longitude || this.opts_form.elm_pf_longitude;
        this.opts_form.elm_pf_latitude = opts_form.elm_pf_latitude || this.opts_form.elm_pf_latitude;
        */
        
        this.back_fn = (typeof(back_fn) ? back_fn : false);
        
      }
    
    this.on_show_box_maps = function()
      {
        this._on_show_maps();
      }
    
    this.on_hide_box_maps = function()
      {
        this._on_hide_maps();
      }
    
    this._on_show_maps = function()
      {
        this._proc_view_block_box("view");
        //this._init_search_address_maps();
        this._create_maps();
      }
    
    this._on_hide_maps = function()
      {
        this._proc_view_block_box("hide");
        this.obj_map.close_map();
      }
    
    this.init_drag_point = function()
      {
        var _this = this;
        
        var coor_point = this._get_coor_point_from_mas_points();
        //wconsole("coor point get mas_points",coor_point);
        
        if (coor_point && coor_point[0] && coor_point[1])
          {
            this.create_drag_placemark(coor_point);
          }
        
        this.obj_map.add_listener_click( function(m){ _this.create_drag_placemark(m); } );
      }
    
    this.create_drag_placemark = function(coor_point)
      {
        //wconsole("создаем метку, координаты",coor_point);
        var _this=this;
        
        this.obj_map.create_drag_placemark(coor_point,function(m){ _this._set_coor_point_back(m); });
        
        this._set_coor_point_back(coor_point);
      }
    
    this.add_mas_point_to_maps = function(on_open_first_point)
      {
        this.obj_map.add_mas_points_to_map(this.mas_points,on_open_first_point);
      }
    
    this._create_maps = function()
      {
        var set_longitude = this.opts.longitude;
        var set_latitude = this.opts.latitude;
        var mas_coor=false;
        
        var m_center = this.m_center;
        if (!m_center && this.mas_points && this.mas_points.length > 0) m_center = "first_point";
        
        if (m_center)
          {
            mas_coor=this._get_coor_center(m_center);
            if (mas_coor && mas_coor[0] && mas_coor[1])
              {
                set_latitude = mas_coor[0];
                set_longitude = mas_coor[1];
              }
          }
        var _opts={
          "latitude":set_latitude,
          "longitude":set_longitude,
          "zoom":this.opts.zoom,
          "on_zoom_point":this.opts.on_zoom_point
        };
        //wconsole(this.mas_setgs);
        if (this.mas_setgs["name_maps"] == "yandex")
          {
            this.obj_map = new eng_master_yandex_maps(this.elm_block, _opts);
          }
        else if (this.mas_setgs["name_maps"] == "google")
          {
            this.obj_map = new eng_master_google_maps(this.elm_block, _opts);
          }
        this.obj_map.create_maps();
        
        return (true);
      }
    
    this._get_coor_center = function(method)
      {
        var mas_coor=false;
        
        // Функция вернет массив с координатами или false
        // mas_coor[0] -> latitude
        // mas_coor[1] -> longitude
        
        if (method)
          {
            if (method == "first_point")
              {
                mas_coor = this._get_coor_point_from_mas_points();
              }
            /*else if (method == "form")
              {
                mas_coor = this._get_coor_point_from_form();
              }
            */
          }
        
        return (mas_coor);
      }
    /*
    this._get_coor_point_from_form = function()
      {
        var obj_form = engine_elm_html.get_obj_form(this.elm_form);// (typeof(elm_form) == "string" ? document.forms[elm_form] : elm_form );
        var obj_pf_longitude = engine_elm_html.get_obj_pf(obj_form, this.opts_form.elm_pf_longitude);
        var obj_pf_latitude = engine_elm_html.get_obj_pf(obj_form, this.opts_form.elm_pf_latitude);
        var form_lng = parseFloat(obj_pf_longitude.value);
        var form_lat = parseFloat(obj_pf_latitude.value);
        
        return ([form_lat, form_lng]);
      }
    */
    this._get_coor_point_from_mas_points = function()
      {
        //должен быть определен массив точек this.mas_points, центрирование карты будет по первой точке
        
        var lng_geo = 0;
        var lat_geo = 0;
        
        if (this.mas_points && this.mas_points.length > 0)
          {
            lng_geo = this.mas_points[0]["longitude"];
            lat_geo = this.mas_points[0]["latitude"];
          }
        
        return ([lat_geo, lng_geo]);
      }
    
    this._set_coor_point_back = function(coor_point)
      {
        if (this.back_fn)
          {
            this.back_fn(coor_point);
          }
        /*
        var obj_form = engine_elm_html.get_obj_form(this.elm_form);
        
        var obj_pf_longitude = engine_elm_html.get_obj_pf(obj_form, this.opts_form.elm_pf_longitude);
        var obj_pf_latitude = engine_elm_html.get_obj_pf(obj_form, this.opts_form.elm_pf_latitude);
        obj_pf_longitude.value = coor_point[1];// longitude;
        obj_pf_latitude.value = coor_point[0];// latitude;
        */
      }
    
    this._proc_view_block_box = function(type_v)
      {
        if (this.elm_block_show)
          {
            var obj_block = engine_elm_html.get_obj(this.elm_block_show);
            obj_block.style.display = (type_v == "view" ? "block" : "none");
          }
      }
    /*
    this._init_search_address_maps = function()
      {
        var _this = this;
        if (!this.on_init_search_address)
          {
            if (this.elm_form && this.opts_form.elm_pf_search && this.opts_form.elm_button_search)
              {
                
                this.on_init_search_address = true;
                var obj_pf_search = engine_elm_html.get_obj_pf(this.elm_form, this.opts_form.elm_pf_search);
                obj_pf_search.value = this.mas_setgs["default_address"];
                
                var obj_button = engine_elm_html.get_obj_pf(this.elm_form, this.opts_form.elm_button_search);
                
                elmAddEventListener(obj_button, "click", function ()
                {
                  _this.action_search_address();
                });
                
              }
          }
      }
    */
    this.action_search_address = function(address)
      {
        //var obj_pf_search = engine_elm_html.get_obj_pf(this.elm_form, this.opts_form.elm_pf_search);
        //var v_adr = obj_pf_search.value;
        var v_adr=js_trim(address);
        if (!v_adr)
          {
            alert ("Укажите адрес места!");
            return (false);
          }
        var _this=this;
        
        this.obj_map.query_search_address(v_adr,function(point)
        {
          //wconsole("ответ search address yandex", point);
          
          if (point)
            {
              _this.create_drag_placemark(point);
              _this.obj_map.move_map_point(point);
            }
          else
            {
              alert ("Указанный адрес не найден! Проверьте указанный адрес!");
            }
        });
        
        return (true);
      }
    
    this.init_data();
    
  }

//gl_eng_manag_maps_cp = eng_yandex_maps_cp;//gl_engine_maps


function eng_gen_maps_st(elm_block,opts,mas_points,elm_block_show,back_fn)//elm_block_show,m_center,elm_form,opts_form,params_form//eng_yandex_maps_st()
  {
    
    this.mas_setgs={
      "longitude": 0,
      "latitude": 0,
      "num_zoom": 12,
      "num_zoom_point": 14,
      "default_address": "",
      "name_maps": ""
    };
    
    this.obj_map = false;
    this.map = false;
    this.s_zoom_maps = 12;// s_zoom_yandex_maps;
    this.s_zoom_maps_point = 14;// s_zoom_yandex_maps_point;
    
    this.opts = {
      longitude: 0,// s_longitude_maps,
      latitude: 0,// s_latitude_maps,
      zoom: this.s_zoom_maps,
      on_zoom_point: false,
      on_adr_search: false,
      on_add_points_maps: true,
      on_open_first_point: false,
      on_init_drag_point: false,
      on_point_default: false
    };
    /*
    this.opts_form = {
      elm_pf_search: false,
      elm_button_search: false,
      elm_pf_longitude: "longitude",
      elm_pf_latitude: "latitude"
    };
    */
    this.geoResult = [];
    this.m_center = false;
    this.mas_point_add_to_maps = new Array();
    this.drag_placemark = false;
    
    //this.go_function_begin_init_maps = false;
    //this.go_function_end_init_maps = false;
    
    //this.s_name_form_bind_maps = "";
    this.open_first_point_maps = false;
    this.set_zoom_maps_point = false;
    this.mas_points = [];
    
    this.elm_block_show = false;
    this.elm_block = false;
    //this.elm_form = false;
    this.back_fn=false;
    
    this.set_longitude = 0;
    this.set_latitude = 0;
    
    this.on_init_search_address = false;
    
    this.on_load_maps=false;
    this.on_access_write=false;
    this.on_write_map=false;
    
    this.init_data = function()
      {
        var _this=this;
        var _mas_setgs=false;
        if (typeof(mas_setgs_maps_st) != "undefined")
          {
            _mas_setgs=mas_setgs_maps_st;
          }
        
        if (_mas_setgs)
          {
            for (let n in this.mas_setgs)
              {
                if (typeof(_mas_setgs[n]) != "undefined") this.mas_setgs[n]=_mas_setgs[n];
              }
          }
        //this.mas_setgs["default_address"]=decodeURIComponent(this.mas_setgs["default_address"]);
        //wconsole("mas setgs",this.mas_setgs);
        
        opts = (typeof(opts) != "undefined" ? opts : {});
        
        this.elm_block = elm_block;
        /*
        this.opts.longitude = opts.longitude || this.mas_setgs.longitude;
        this.opts.latitude = opts.latitude || this.mas_setgs.latitude;
        //this.opts.on_zoom_point = (typeof (opts.on_zoom_point) != "undefined" ? opts.on_zoom_point : this.opts.on_zoom_point);
        this.opts.zoom = opts.zoom || (this.opts.on_zoom_point ? this.mas_setgs.num_zoom_point : this.mas_setgs.num_zoom);
        //this.opts.on_adr_search = opts.on_adr_search || this.opts.on_adr_search;
        //this.opts.on_add_points_maps = opts.hasOwnProperty("on_add_points_maps") ? opts.on_add_points_maps : this.opts.on_add_points_maps;
        //this.opts.on_open_first_point = opts.on_open_first_point || this.opts.on_open_first_point;
        //this.opts.on_init_drag_point = opts.on_init_drag_point || this.opts.on_init_drag_point;
        */
        
        for (let n in this.opts)
          {
            if (opts.hasOwnProperty(n)) this.opts[n]=opts[n];
          }
        
        this.opts.longitude = this.opts.longitude || this.mas_setgs.longitude;
        this.opts.latitude = this.opts.latitude || this.mas_setgs.latitude;
        this.opts.zoom = (this.opts.on_zoom_point ? this.mas_setgs.num_zoom_point : (this.opts.zoom || this.mas_setgs.num_zoom));
        //wconsole("init opts",this.opts);
        
        elm_block_show = (typeof(elm_block_show) != "undefined" ? elm_block_show : false);
        this.elm_block_show = elm_block_show;// (typeof (elm_block_show) != "undefined" ? elm_block_show : false);
        
        this.mas_points = (typeof(mas_points) != "undefined" ? mas_points : []);
        //wconsole("mas points",this.mas_points);
        
        this.back_fn = (typeof(back_fn) != "undefined" ? back_fn : false);
        /*
        params_form = (typeof(params_form) != "undefined" ? params_form : {});
        //wconsole("params_form",params_form);
        this.elm_form = params_form.elm_form || false;// (typeof (elm_form) != "undefined" ? elm_form : false);
        
        this.opts_form.elm_pf_search = params_form.elm_pf_search || this.opts_form.elm_pf_search;
        this.opts_form.elm_button_search = params_form.elm_button_search || this.opts_form.elm_button_search;
        this.opts_form.elm_pf_longitude = params_form.elm_pf_longitude || this.opts_form.elm_pf_longitude;
        this.opts_form.elm_pf_latitude = params_form.elm_pf_latitude || this.opts_form.elm_pf_latitude;
        */
        
      }
    
    this.init_load = function()
      {
        var _this=this;
        this.on_access_write=true;
        
        init_work_maps_load_page.add_fn( function(){ _this.action_load_maps(); } );
      }
    
    this.action_load_maps = function()
      {
        this.on_load_maps=true;
        if (this.on_access_write)
          this.on_show_box_maps();
      }
    
    this.on_show_box_maps = function()
      {
        this.on_acess_write=true;
        if(!this.on_load_maps) return (false);
        
        if (this.on_write_map) return (false);
        
        this._on_show_maps();
        return (true);
      }
    
    this.on_hide_box_maps = function()
      {
        this.on_access_write=false;
        
        if (!this.on_load_maps) return (false);
        
        if (!this.on_write_map) return (false);
        
        this._on_hide_maps();
        return (true);
      }
    
    this._on_show_maps = function()
      {
        this.on_write_map=true;
        this._proc_view_block_box("view");
        /*
        if (this.opts.on_adr_search)
          this._init_search_address_maps();
        */
        this._create_maps();
        
        if (this.opts.on_add_points_maps && (this.mas_points && this.mas_points.length > 0))
          this.add_mas_points_to_maps(this.opts.on_open_first_point);
        
        if (this.opts.on_init_drag_point) this.init_drag_point();
        
        if (this.opts.on_point_default) this._set_point_default();
        
      }
    
    this._on_hide_maps = function()
      {
        this.on_write_map=false;
        this._proc_view_block_box("hide");
        this.obj_map.close_map();
      }
    
    this.init_drag_point = function()
      {
        var _this = this;
        
        var coor_point = false;//[this.opts.latitude,this.opts.longitude];
        
        var mas_coor=this._get_coor_center("first_point");
        //wconsole("init drag point: полученные координаты центра",mas_coor);
        if (mas_coor && mas_coor[0] && mas_coor[1])
          {
            coor_point=mas_coor;
            /*set_latitude = mas_coor[0];
            set_longitude = mas_coor[1];*/
          }
        
        if (coor_point && coor_point[0] && coor_point[1])
          {
            this.create_drag_placemark(coor_point);
          }
        
        this.obj_map.add_listener_click( function(m){ _this.create_drag_placemark(m); } );
      }
    
    this.create_drag_placemark = function(coor_point)
      {
        //wconsole("создаем метку, координаты",coor_point);
        var _this=this;
        
        this.obj_map.create_drag_placemark(coor_point,function(m){ _this._set_coor_point_back(m); });
        
        this._set_coor_point_back(coor_point);
      }
    
    this.add_mas_points_to_maps = function(on_open_first_point)
      {
        this.obj_map.add_mas_points_to_map(this.mas_points,on_open_first_point);
      }
    
    this._create_maps = function()
      {
        var set_longitude = this.opts.longitude;
        var set_latitude = this.opts.latitude;
        var mas_coor=[];
        
        var m_center = this.m_center;
        if (!m_center && this.mas_points && this.mas_points.length > 0) m_center = "first_point";
        
        if (m_center)
          {
            mas_coor=this._get_coor_center(m_center);
            //wconsole("полученные координаты центра",mas_coor);
            if (mas_coor && mas_coor[0] && mas_coor[1])
              {
                set_latitude = mas_coor[0];
                set_longitude = mas_coor[1];
              }
          }
        /*else if (this.mas_points && this.mas_points.length > 0)
          {
            mas_coor=this._get_coor_point_from_mas_points();
            if (mas_coor && mas_coor[0] && mas_coor[1])
              {
                set_latitude = mas_coor[0];
                set_longitude = mas_coor[1];
              }
          }*/
        
        var _opts={
          "latitude":set_latitude,
          "longitude":set_longitude,
          "zoom":this.opts.zoom,
          "on_zoom_point":this.opts.on_zoom_point
        };
        //wconsole("_opts maps",_opts);
        //wconsole("mas setgs maps",this.mas_setgs);
        if (this.mas_setgs["name_maps"] == "yandex")
          {
            this.obj_map = new eng_master_yandex_maps(this.elm_block, _opts);
          }
        else if (this.mas_setgs["name_maps"] == "google")
          {
            this.obj_map = new eng_master_google_maps(this.elm_block, _opts);
          }
        this.obj_map.create_maps();
        
        return (true);
      }
    
    this._get_coor_center = function(method)
      {
        var mas_coor=false;
        
        // Функция вернет массив с координатами или false
        // mas_coor[0] -> latitude
        // mas_coor[1] -> longitude
        
        if (method)
          {
            if (method == "first_point")
              {
                mas_coor = this._get_coor_point_from_mas_points();
              }
            /*else if (method == "form")
              {
                mas_coor = this._get_coor_point_from_form();
              }
            */
          }
        
        return (mas_coor);
      }
    /*
    this._get_coor_point_from_form = function()
      {
        var obj_form = engine_elm_html.get_obj_form(this.elm_form);// (typeof(elm_form) == "string" ? document.forms[elm_form] : elm_form );
        var obj_pf_longitude = engine_elm_html.get_obj_pf(obj_form, this.opts_form.elm_pf_longitude);
        var obj_pf_latitude = engine_elm_html.get_obj_pf(obj_form, this.opts_form.elm_pf_latitude);
        var form_lng = parseFloat(obj_pf_longitude.value);
        var form_lat = parseFloat(obj_pf_latitude.value);
    
        return ([form_lat, form_lng]);
      }
    */
    this._get_coor_point_from_mas_points = function()
      {
        //должен быть определен массив точек this.mas_points, центрирование карты будет по первой точке
        
        var lng_geo = 0;
        var lat_geo = 0;
        
        if (this.mas_points && this.mas_points.length > 0)
          {
            lng_geo = this.mas_points[0]["longitude"];
            lat_geo = this.mas_points[0]["latitude"];
          }
        
        return ([lat_geo, lng_geo]);
      }
    
    this._set_coor_point_back = function(coor_point)
      {
        if (this.back_fn)
          {
            this.back_fn(coor_point);
          }
        /*
        var obj_form = engine_elm_html.get_obj_form(this.elm_form);
    
        var obj_pf_longitude = engine_elm_html.get_obj_pf(obj_form, this.opts_form.elm_pf_longitude);
        var obj_pf_latitude = engine_elm_html.get_obj_pf(obj_form, this.opts_form.elm_pf_latitude);
        obj_pf_longitude.value = coor_point[1];// longitude;
        obj_pf_latitude.value = coor_point[0];// latitude;
        */
        return (true);
      }
    
    this._proc_view_block_box = function(type_v)
      {
        if (this.elm_block_show)
          {
            var obj_block = engine_elm_html.get_obj(this.elm_block_show);
            obj_block.style.display = (type_v == "view" ? "block" : "none");
          }
      }
    /*
    this._init_search_address_maps = function()
      {
        var _this = this;
        if (!this.on_init_search_address)
          {
            if (this.elm_form && this.opts_form.elm_pf_search && this.opts_form.elm_button_search)
              {
                
                this.on_init_search_address = true;
                var obj_pf_search = engine_elm_html.get_obj_pf(this.elm_form, this.opts_form.elm_pf_search);
                obj_pf_search.value = this.mas_setgs["default_address"];
                
                var obj_button = engine_elm_html.get_obj_pf(this.elm_form, this.opts_form.elm_button_search);
                
                elmAddEventListener(obj_button, "click", function ()
                {
                  _this.action_search_address();
                });
                
              }
          }
      }
    */
    this.action_search_address = function(address)
      {
        //var obj_pf_search = engine_elm_html.get_obj_pf(this.elm_form, this.opts_form.elm_pf_search);
        //var v_adr = obj_pf_search.value;
        var v_adr = js_trim(address);
        if (!v_adr)
          {
            alert ("Укажите адрес места!");
            return (false);
          }
        var _this=this;
        
        this.obj_map.query_search_address(v_adr,function(point)
        {
          //wconsole("ответ search address yandex", point);
          
          if (point)
            {
              _this.create_drag_placemark(point);
              _this.obj_map.move_map_point(point);
            }
          else
            {
              alert ("Указанный адрес не найден! Проверьте указанный адрес!");
            }
        });
        
        return (true);
      }
    
    this._set_point_default = function()
      {
        //wconsole("set point default");
        var _point={"latitude":this.mas_setgs["latitude"],"longitude":this.mas_setgs["longitude"],"name":"Метка"};
        this.obj_map.add_mas_points_to_map([_point],false);
        
      }
    
    this.init_data();
    this.init_load();
    
  }


//eng_gen_maps_st = eng_yandex_maps_st;


// Функции необходимые для ожидания загрузки карт

function init_work_maps_load_serv()
  {
    //wconsole("init_work_maps_load_serv");
    init_work_maps_load_page.load_maps_serv();
    
  }

var init_work_maps_load_page = {
  
  "on_load_maps_serv": false,
  "on_load_page": false,
  //"on_listener_load_page": false,
  "mas_back_fn": [],
  
  "load_maps_serv": function()
    {
      this.on_load_maps_serv = true;
      this.launch_back_fn();
    },
  
  "load_page": function()
    {
      //wconsole("on load page");
      this.on_load_page=true;
      this.launch_back_fn();
    },
  
  "add_fn": function(back_fn)
    {
      if (this.on_load_page && this.on_load_maps_serv)
        {
          setTimeout(function(){ back_fn(); },10);
        }
      else
        {
          this.mas_back_fn.push([0, back_fn]);
        }
      
      return (true);
    },
  
  "launch_back_fn": function()
    {
      if (!this.on_load_page || !this.on_load_maps_serv) return (false);
      
      for (let n=0; n<this.mas_back_fn.length; n++)
        {
          if (this.mas_back_fn[n][0] == 0)
            {
              this.mas_back_fn[n][1]();
              this.mas_back_fn[n][0]=1;
            }
        }
      
      return (true);
    },
  
}

add_function_start_on_domcontent(function(){ init_work_maps_load_page.load_page(); });


// ---------------------------------
// ---------------------------------
// ---------------------------------


// Общая функция для поиска объектов на карте

function process_search_elms_maps()
  {
    
    this.mas_setgs={
      "longitude": 0,
      "latitude": 0,
      "num_zoom": 12,
      "num_zoom_point": 14,
      "default_address": "",
      "name_maps": ""
    };
    
    this.on_access=false;
    this.obj_mast_map = false;
    this.map = false;
    this.clusterer = false;
    
    this.mas_point = [];
    this.mas_id_point = [];
    
    this.delta_latitude = 1; // значение от 0 до 1
    this.delta_longitude = 0.7; // значение от 0 до 1
    
    this.mas_coor_view_section = [];
    
    this.obj_rectangle = false;
    this.obj_rectangle2 = false;
    
    this.link_function_back_agent = false;
    this.mas_init_icons = {};
    this.timer_change_maps = false;
    this.time_pause_proces_change = 1500;
    
    this.init_data = function()
      {
        var _mas_setgs = false;
        
        if (typeof (mas_setgs_maps_st) != "undefined")
          {
            _mas_setgs = mas_setgs_maps_st;
          }
        
        if (!(_mas_setgs && _mas_setgs.on_use == 1)) return (false);
        
        for (let n in this.mas_setgs)
          {
            if (typeof (_mas_setgs[n]) != "undefined") this.mas_setgs[n] = _mas_setgs[n];
          }
        
        //this.mas_setgs["default_address"] = decodeURIComponent(this.mas_setgs["default_address"]);
        this.on_access=true;
      }
    
    this.create_maps = function (id_block, latitude, longitude, zoom)
      {
        if (!this.on_access) return (false);
        
        if (typeof (latitude) == "undefined") latitude = false;
        if (typeof (longitude) == "undefined") longitude = false;
        if (typeof (zoom) == "undefined") zoom = false;
        
        this.set_longitude = longitude || this.mas_setgs["longitude"];
        this.set_latitude = latitude || this.mas_setgs["latitude"];
        this.set_zoom = zoom || this.mas_setgs["num_zoom"];
        
        var _opts={
          "latitude":this.set_latitude,
          "longitude":this.set_longitude,
          "zoom":this.set_zoom,
          //"on_zoom_point":this.opts.on_zoom_point
        };
        //wconsole("_opts maps search elms",_opts);
        if (this.mas_setgs["name_maps"] == "yandex")
          {
            this.obj_mast_map = new eng_master_yandex_maps(id_block, _opts);
          }
        else if (this.mas_setgs["name_maps"] == "google")
          {
            this.obj_mast_map = new eng_master_google_maps(id_block, _opts);
          }
        this.obj_mast_map.create_maps();
        
        //создадим кластер
        this.obj_mast_map.create_claster();
        
        /*
        var state = {
          center: [this.set_latitude, this.set_longitude],
          zoom: this.set_zoom,
          type: "yandex#map"
        };
        
        var options = {
          minZoom: 2,
          avoidFractionalZoom: false
        };
        
        this.map = new ymaps.Map(id_block, state, options);
        //map.setCenter(new YMaps.GeoPoint(set_longitude_yandex_maps, set_latitude_yandex_maps), set_zoom_yandex_maps);// долгота, широта | longitude - долгота, latitude - широта
        
        //map.setType(YMaps.MapType.MAP);//MAP , SATELLITE , HYBRID 
        this.map.controls.add("mapTools");//стандартный набор кнопок
        this.map.controls.add("zoomControl");// Добавление кнопки изменения масштаба 
        this.map.controls.add("typeSelector");// Добавление списка типов карты
        
        //map.addControl(new YMaps.ToolBar());       //панель инструментов
        
        //map.addControl(new YMaps.MiniMap());       //обзорная карта
        //map.addControl(new YMaps.ScaleLine());     //масштабная линейка
        */
        /*
        //создадим кластер
        this.clusterer = new ymaps.Clusterer();
        //clusterer.add(myGeoObjects);
        this.map.geoObjects.add(this.clusterer);
        */
        return (true);
      }
    
    this.first_init_event = function (mas_init_icons)
      {
        this.mas_init_icons = mas_init_icons;
        //wconsole("mas_init_icons",mas_init_icons);
        this.obj_mast_map.add_mas_init_icons(mas_init_icons);
        
        this.init_method_event();
        this.agent_change_maps();
      }
    
    this.init_method_event = function ()
      {
        
        var _this = this;
        this.obj_mast_map.add_listener_size_change( function(){ _this.agent_change_maps(); } );
        /*
        this.map.events.add('boundschange', function (event)
        {
          _this.agent_change_maps(event);
        });
        */
      }
    
    this.set_back_agent = function (link_function)
      {
        this.link_function_back_agent = link_function;
      }
    
    this.agent_change_maps = function ()
      {
        //wconsole("agen_change_maps");
        if (this.timer_change_maps)
          {
            clearTimeout(this.timer_change_maps);
            this.timer_change_maps = false;
          }
        var _this = this;
        this.timer_change_maps = setTimeout(function ()
        {
          _this.proces_agent_change_maps();
        }, this.time_pause_proces_change);
        
      }
    
    this.proces_agent_change_maps = function ()
      {
        //wconsole("proc_agen_change_maps");
        var coor_view_maps = this.get_view_coor();
        
        var coor_view_maps_load = this.set_coor_maps_load(coor_view_maps);
        
        var check_on_view_section = this.check_on_view_section(coor_view_maps);
        
        //this.view_info_coor(coor_view_maps,coor_view_maps_load,"");
        //this.create_rectangle(coor_view_maps,coor_view_maps_load);
        
        if (!check_on_view_section)
          {
            //this.create_rectangle(coor_view_maps,coor_view_maps_load);
            this.add_coor_in_view_section(coor_view_maps_load);
            this.loading_object(coor_view_maps_load, coor_view_maps);
          }
        
      }
    
    this.loading_object = function (coor_view_maps, t_coor)
      {
        //var coor_view_maps = this.get_view_coor();
        
        var latitude_bottom = coor_view_maps["bottom"];
        var latitude_top = coor_view_maps["top"];
        
        var longitude_left = coor_view_maps["left"];
        var longitude_right = coor_view_maps["right"];
        
        //this.view_info_coor(t_coor,coor_view_maps,2);
        
        this.link_function_back_agent(coor_view_maps, this.mas_id_point.join(","));
        
      }
    
    this.get_view_coor = function ()
      {
        var _coor = this.obj_mast_map.get_coor_area_map();
        var center = _coor["center"];// this.map.getCenter();
        var coor_view_maps = _coor["bounds"];// this.map.getBounds();
        
        var latitude_bottom = coor_view_maps[0];
        var latitude_top = coor_view_maps[1];
        
        var longitude_left = coor_view_maps[2];
        var longitude_right = coor_view_maps[3];
        
        if (!(longitude_left <= center[1] && center[1] <= longitude_right))
          {
            //wconsole (333);
            longitude_left = -180;
            longitude_right = 180;
            latitude_bottom = -90;
            latitude_top = 90;
          }
        
        return ({"bottom": latitude_bottom, "top": latitude_top, "left": longitude_left, "right": longitude_right});
      }
    
    this.set_coor_maps_load = function (coor_view_maps)
      {
        // расчитываем координаты области карты для загрузки меток
        var coor = {};//coor_view_maps;
        var s_latitude = Math.abs(coor_view_maps.top - coor_view_maps.bottom);
        var s_longitude = Math.abs(coor_view_maps.right - coor_view_maps.left);
        
        coor.bottom = coor_view_maps.bottom - this.delta_latitude * s_latitude;
        if (coor.bottom < -90) coor.bottom = -90;
        
        coor.top = coor_view_maps.top + this.delta_latitude * s_latitude;
        if (coor.top > 90) coor.top = 90;
        
        coor.left = coor_view_maps.left - this.delta_longitude * s_longitude;
        if (coor.left < -180) coor.left = -180;
        
        coor.right = coor_view_maps.right + this.delta_longitude * s_longitude;
        if (coor.right > 180) coor.right = 180;
        
        return (coor);
      }
    
    this.add_coor_in_view_section = function (coor_view_maps_load)
      {
        this.mas_coor_view_section.push(coor_view_maps_load);
      }
    
    this.check_on_view_section = function (coor_check)
      {
        var on_view = false;
        var one_section;
        for (var i = 0; i < this.mas_coor_view_section.length; i++)
          {
            one_section = this.mas_coor_view_section[i];
            
            if ((one_section.left <= coor_check.left) && (one_section.right >= coor_check.right)
            && (one_section.top >= coor_check.top) && (one_section.bottom <= coor_check.bottom)
            )
              {
                on_view = true;
                break;
              }
            
          }
        
        return (on_view);
      }
    
    this.add_object_map = function (mas_points)
      {
        this.mas_id_point = this.mas_id_point.concat(this.obj_mast_map.add_mas_points_claster(mas_points));
        
        /*
        var one_point, placemark, is_link, geo_object = [], preset_icon;
        
        for (var n = 0; n < mas_object.length; n++)
          {
            one_point = mas_object[n];
            //alert ( one_point["longitude"] + " " + one_point["latitude"] );
            if (!one_point["longitude"] || !one_point["latitude"]) continue;
            is_link = (one_point["link"] ? true : false);
            
            this.mas_id_point.push(one_point["id"]);
            
            preset_icon = this.get_preset_icon(one_point["type_icon"]);
            //alert (preset_icon);
            geo_object.push(new ymaps.GeoObject(
            {
              geometry: {type: "Point", coordinates: [one_point["latitude"], one_point["longitude"]]},
              properties: {
                clusterCaption: jsCodeHtmlChars(one_point["name"]),
                balloonContent: one_point["ballon_content"] /*this.forming_ballon_content( one_point )* / /* "<div style='font-weight: bold;'>" 
               + (is_link ? '<a href="'+one_point['link']+'">' : "") + jsCodeHtmlChars(one_point["name"])
               + (is_link ? '</a>' : '')
               +"</div>" * /
              }
            },
            {
              preset: preset_icon
            }
            ));
            
          }
        
        this.clusterer.add(geo_object);
        */
      }
    
    this.get_preset_icon = function (type_icon)
      {
        var preset = this.mas_init_icons["default"][0];
        //wconsole (type_icon);
        if (type_icon != "" && type_icon != "default" && typeof (this.mas_init_icons["icons"][type_icon]) != "undefined")
          {
            preset = this.mas_init_icons["icons"][type_icon][0];
            //wconsole (3333);
          }
        
        return (preset);
      }
    /*
    this.forming_ballon_content = function ( data_point )
      {
       var t = "";
       
       t += "<div>";
       t += "<table cellspacing='0' cellpadding='0' border='0'>";
       t += "<tr><td>";
       t += "<img src='"+data_point["image"]+"'>";
       t += "</td><td>";
       
       t += "<div style='padding: 0px 0px 0px 10px;'>";
       t += "<div>";
       t += "<a href='"+data_point["link"]+"' target='_blank'>"+jsCodeHtmlChars(data_point["name"])+"</a>";
       t += "</div>";
       
       t += "<div>";
       t += data_point["text"];
       t += "</div>";
       
       t += "<div>";
       t += "<a href='"+data_point["link"]+"' target='_blank'>Подробнее &raquo;&raquo;</a>";
       t += "</div>";
       
       t += "</div>";
       
       t += "</td></tr>";
       t += "</table>";
       t += "</div>";
       
       return (t);
      }
    */
    this.reset_data = function ()
      {
        this.mas_point = [];
        this.mas_id_point = [];
        this.mas_coor_view_section = [];
        
        this.obj_mast_map.cluster_clear_points();
        //this.clusterer.removeAll();
        
      }
    
    this.show_address_maps = function (address)
      {
        var v_adr=js_trim(address);
        if (!v_adr)
          {
            alert ("Не указан адрес!");
            return (false);
          }
        var _this=this;
        
        this.obj_mast_map.query_search_address(v_adr, function (point)
        {
          //wconsole("ответ search address yandex", point);
          
          if (point)
            {
              
              _this.obj_mast_map.move_map_point(point);
            }
          else
            {
              alert("Указанный адрес не найден! Проверьте указанный адрес!");
            }
        });
        /*
        var map = this.map;
        //alert (address);
        ymaps.geocode(address, {results: 100}).then(
        function (res)
        {
          if (res.geoObjects.getLength())
            {
              var point = res.geoObjects.get(0).geometry.getCoordinates();
              //create_drag_placemark(1, 1, point);
              map.panTo(point);
            }
          else
            {
              alert("Ничего не найдено!")
            }
        });
        */
      }
    
    this.num_info = 0;
    
    this.view_info_coor = function (coor, coor2, num_block)
      {
        
        var t = "";
        t += "<div> 1: "
        + "top: " + coor.top
        + ", bottom: " + coor.bottom
        + ", left: " + coor.left
        + ", right: " + coor.right
        + "</div>";
        t += "<div> 2: "
        + (coor2 ? "top: " + coor2.top
        + ", bottom: " + coor2.bottom
        + ", left: " + coor2.left
        + ", right: " + coor2.right
        + "</div>" : "---");
        this.view_info(t, num_block);
      }
    
    this.view_info = function (info, num_block)
      {
        if (num_block === 2) this.num_info++;
        document.getElementById("info_maps_canvas_search" + (num_block || num_block === 0 || num_block === "0" ? num_block : "")).innerHTML = "n->" + this.num_info + " " + info;
      }
    
    this.init_data();
  }



