<?php

//редактор настроек

class eng_edit_cfg
{
  protected $on_modul=false;
  protected $name_modul="";
  //protected $ident_cfg="";
  
  protected $mas_init_params=array();
  protected $mas_init_default=array();
  protected $actual_values=array();
  protected $default_values=array();
  
  function check_use_modul()
    {
      if (!empty($_POST["on_use_modul"]) && isset($_POST["name_use_modul"])  
         && ($_POST["on_use_modul"]=="on" || $_POST["on_use_modul"]=="off")
         && ($_POST["name_use_modul"] != "" && is_string($_POST["name_use_modul"]) && preg_match("#^[a-zA-Z0-9_]+$#",$_POST["name_use_modul"]))
        )
        {
          $this->on_modul=($_POST["on_use_modul"]=="on"?true:false);
          $this->name_modul=$_POST["name_use_modul"];
          //write_log_cms($this->name_modul,"config name modul");
          if ($this->on_modul)
            {
              //$this->name_modul = $_POST["name_use_modul"];
              
              if ($this->name_modul == "")
                {
                  //ошибка с данными - не указан модуль
                  return (false);
                }
            }
           /*else
             {
               $this->name_modul="configsite";
               //$this->ident_cfg="configsite";
             }*/
          
          
          
          return (true);
        }
      
      return (false);
    }
  
  function get_init_param()
    {
      $data_mas_config=array();
      $masDefConfig=array();
      
      if ($this->on_modul)
        {
          include_once (DIR_CMS . "/moduls/".$this->name_modul."/config_modul.php");
          include_once (DIR_CMS . "/moduls/".$this->name_modul."/config_set_default.php");
        }
       elseif ($this->name_modul == "main")
         {
           include_once (DIR_CMS . "/config/mas_set_config.php");
           include_once (DIR_CMS . "/config/config_set_main_default.php");
         }
       elseif ($this->name_modul == "tpl")
         {
           global $dir_template;
           $file1=$dir_template . "/param_init_cfg_tpl.php";
           $file2=$dir_template . "/param_default_cfg_tpl.php";
           if (file_exists($file1))
             {
               include_once($file1);
               include_once($file2);
             }
         }
      
      $this->mas_init_params=$data_mas_config;
      $this->mas_init_default=$masDefConfig;
      
      return (true);
    }
  
  function start_work_view()
    {
      $error=0;
      $error_text="no";
      $rez="";
      
      list($error,$error_text)=$this->list_step_view();
      
      if ($error == 0)
        {
          $rez=" data:{ init: ". encode_gen_mas_to_jointext($this->mas_init_params,true,true) 
          .", actualvs: ".encode_gen_mas_to_jointext($this->actual_values,true,true)
          .", defaultvs: ".encode_gen_mas_to_jointext($this->default_values,true,true)
          ."} ";
        }
      
      write_ajax_answer_jc($error,$error_text,$rez);
      
      return (true);
    }
  
  function list_step_view()
    {
      if (!$this->check_use_modul())
        {
          return (array(1,"Ошибка с данными!"));
        }
      
      session_admin::general_check_access("ajax",array($this->name_modul,"server","setting"));
      
      global $type_answer;
      eng_promote_safety::admin_check_code($type_answer);
      
      $this->get_init_param();
      
      //var_dump($this->mas_init_default);
      $this->build_collection_init();
      
      
      return (array(0,"no"));
    }
  
  function build_collection_init()
    {
      $this->actual_values=array();
      $this->default_values=array();
      
      global $masConfig;
      
      foreach ($this->mas_init_params as $one_group)
        {
          
          foreach ($one_group[1] as $one_init)
            {
              $actual_value="";
              $default_value="";
              $on_default_value=false;
              
              if (isset($this->mas_init_default[$one_init[0]]))
                {
                  $default_value=$this->mas_init_default[$one_init[0]];
                  $on_default_value=true;
                }
              
              if (isset($masConfig[$one_init[0]]))
                {
                  $actual_value=$masConfig[$one_init[0]];
                }
              else
                {
                  if ($on_default_value) $actual_value=$default_value;
                }
              
              $this->actual_values[$one_init[0]]=$actual_value;
              $this->default_values[$one_init[0]]=$default_value;
              
            }
          
        }
      
      return (true);
    }
  
  function start_work_save()
    {
      $error=0;
      $error_text="no";
      $rez="";
      
      list($error,$error_text)=$this->list_step_save();
      /*
      if ($error == 0)
        {
          $rez=" data:{ init: ". encode_gen_mas_to_jointext($this->mas_init_params,true,true) 
          .", actualvs: ".encode_gen_mas_to_jointext($this->actual_values,true,true)
          .", defaultvs: ".encode_gen_mas_to_jointext($this->default_values,true,true)
          ."} ";
        }
      */
      write_ajax_answer_jc($error,$error_text,$rez);
      
      return (true);
    }
  
  function list_step_save()
    {
      $error=0;
      $error_text="no";
      
      if (!$this->check_use_modul())
        {
          return (array(1,"Ошибка с данными!"));
        }
      
      session_admin::general_check_access("ajax",array($this->name_modul,"server","write"));
      
      global $type_answer;
      eng_promote_safety::admin_check_code($type_answer);
      
      $this->get_init_param();
      
      /* Проверяем данные и формируем код для записи */
      
      $text_code="";
      
      foreach ($this->mas_init_params as $one_group)
        {
          foreach ($one_group[1] as $one_init)
            {
              
              if (!isset($_POST[$one_init[0]]))//( || $_POST[$one_init[0]]=="")
                {
                  //$error = 1;
                  //$error_text = "ошибка с данными!";
                  //break;
                  return (array(1,"Ошибка с данными!"));
                }
              
              if ($one_init[1] == "numeric" && !is_numeric($_POST[$one_init[0]]))
                {
                  //$error = 1;
                  //$error_text = "ошибка: неверный формат данных!";
                  //break;
                  return (array(1,"Ошибка: неверный формат данных!"));
                }
              
              if ($one_init[1] != "array" && strpos($_POST[$one_init[0]], "'") !== false)
                {
                  //$error = 1;
                  //$error_text = "ошибка: неверный формат данных!";
                  //break;
                  return (array(1,"Ошибка: неверный формат данных!"));
                }
              
              $one_value = $_POST[$one_init[0]];
              
              $name_param = "";
              $value_param = "";
              //$check_param = "";
              $save_param = true;
              
              if ($one_init[1] == "numeric")
                {
                  $name_param = $one_init[0];
                  $value_param = $one_value;
                  //$text_file_php.="define('".$one_init[0]."',".$one_value.");\n";
                }
              elseif ($one_init[1] == "text")
                {
                  $name_param = $one_init[0];
                  $value_param = "'".stripslashes($one_value)."'";
                  //$text_file_php.="define('".$one_init[0]."','".stripslashes($one_value)."');\n";
                }
              elseif ($one_init[1] == "select")
                {
                  $d_search=search_mas_2level($one_init[2],0,$one_value,false);
                  if ($d_search[0])
                    {
                      if (is_numeric($one_value))
                        {
                          $name_param = $one_init[0];
                          $value_param = $one_value;
                          //$text_file_php.="define('".$one_init[0]."',".$one_init[2][$one_value][0].");\n";
                        }
                      else
                        {
                          $name_param = $one_init[0];
                          $value_param = "'".$one_value."'";//"'".$one_init[2][$one_value][0]."'";
                          //$text_file_php.="define('".$one_init[0]."','".$one_init[2][$one_value][0]."');\n";
                        }
                    }
                  else
                    {
                      //$error = 1;
                      //$error_text = "ошибка: заданы неверные данные!";
                      //break;
                      return (array(1,"Ошибка: неверно указаны данные!"));
                    }
                }
              elseif ($one_init[1] == "array")
                {
                  $save_param = false;
                  $name_param = $one_init[0];
                  $value_param = " array(\n";
                  
                  if ($one_value && is_array($one_value))
                    {
                      
                      //$mas_list = explode("|",$one_value);
                      $sep1 = "";
                      
                      foreach ($one_value as $one_list)
                        {
                          $sep2 = "";
                          $value_param .= $sep1."  array( ";
                          
                          if ($one_list && is_array($one_list))
                            {
                              //$mas_elem = explode(",",$one_list);
                              $n = 0;
                              foreach ($one_init[2] as $init_elem)
                                {
                                  if (!isset($one_list[$n]))
                                    {
                                      //$error = 1;
                                      //$error_text = "ошибка с данными!";
                                      //break;
                                      return (array(1,"Ошибка со структурой данных!"));
                                    }
                                  $one_elem = $one_list[$n];
                                  if ($init_elem[0] == "numeric")
                                    {
                                      if (!is_numeric($one_elem))
                                        {
                                          //$error = 1;
                                          //$error_text = "ошибка: неверный формат данных!";
                                          //break;
                                          return (array(1,"Ошибка: неверный формат данных!"));
                                        }
                                    }
                                  elseif (strpos($one_elem, "'") !== false)
                                    {
                                      //$error = 1;
                                      //$error_text = "ошибка: неверный формат данных!";
                                      //break;
                                      return (array(1,"Ошибка: неверный формат данных!"));
                                    }
                                  
                                  $value_param .= $sep2.(is_numeric($one_elem) ? $one_elem : "'".$one_elem."'");
                                  $sep2 = ",";
                                  $n++;
                                }
                            }
                          
                          $value_param .= "  )";
                          $sep1 = ",\n";
                        }
                      
                    }
                  
                  $value_param .= "\n)";
                  
                }
              
              if ($save_param) $text_code .= "define('".$name_param."',".$value_param.");\n";
              
              $text_code .= "\$masConfig['".$name_param."'] = ".$value_param.";\n";
              
            }
        }
      
      /* Сохраняем данные */
      
      $file_save=DIR_CMS."/config_save/config_main.php";
      
      if ($this->name_modul == "tpl")
        {
          global $dir_template;
          $file_save = $dir_template."/configs/param_cfg_tpl.php";
        }
       elseif ($this->on_modul)
         $file_save=DIR_CMS."/config_save/config_m_".$this->name_modul.".php";
      
      $df_save = @fopen($file_save, "w");
      if ($df_save)
        {
          
          if (@fwrite($df_save, "<?php \n\n".$text_code) === false)
            {
              $error = 1;
              $error_text = "Произошла ошибка при записи данных в конфигурационный файл php!";
            }
          
          fclose($df_save);
          
        }
      else
        {
          $error = 1;
          $error_text = "Произошла ошибка при создании конфигурационного файла php!";
        }
      
      return (array($error,$error_text));
    }
}

