<?php

class eng_mang_pay_systems
{
  
  function __construct()
    {
      
    }
  
  static public function get_init_data()
    {
      $data = [];
      
      $data=self::_get_data_dir();
      
      return ($data);
    }
  
  static protected function _get_data_dir()
    {
      $data=[];
      
      $dir_syst=DIR_CMS ."/systpayment/";
      
      $list_dir=scandir($dir_syst);
      //write_log_cms($list_dir);
      $all_cfg=self::_get_cfg_all_systems();
      
      foreach ($list_dir as $key => $name_elm)
        {
          if (in_array($name_elm,[".",".."])) continue;
          //write_log_cms($name_elm,"name elm dir");
          
          $path_elm=$dir_syst . $name_elm;
          if (is_dir($path_elm))
            {
              // имя каталога ($name_elm) - это имя платежной системы
              
              $data_syst=self::_check_one_plugin($name_elm,$path_elm);
              //write_log_cms($data_syst,"данные плагина платежной системы");
              if ($data_syst[0])
                {
                  $one_cfg=$all_cfg[$name_elm] ?? [];
                  $values=self::_get_values_one_system($data_syst[1],$one_cfg);
                  
                  $data[] = [$name_elm, $data_syst[1], $values];
                }
            }
          
        }
      
      
      return ($data);
    }
  
  static protected function _check_one_plugin($name_syst, $path_dir)
    {
      $name_file="paysystem_".$name_syst .".php";
      $path_file = $path_dir ."/". $name_file;
      
      $on_syst=false;
      $data_setngs=[];
      
      if ( self::_check_file_one_plugin($name_syst,$path_dir,$path_file) )
        {
          // файл $path_file есть и он подключен
          
          $class_name="eng_paysystem_". $name_syst;
          
          if (class_exists($class_name,false))
            {
              //Класс есть в подключенном файле
              $on_syst=true;
              $data_setngs=$class_name::get_settings_data();
              //write_log_cms($data_setngs,"конфигурационные данные ПС");
            }
          else
            {
              //Класса нет в подключенном файле
              
            }
          
        }
      
      return ([$on_syst, $data_setngs]);
    }
  
  static protected function _check_file_one_plugin($name_syst,$path_dir,$path_file)
    {
      // проверяем и подключаем файл содержащий класс для работы с одной платежной системой
      $on=false;
      if (is_file($path_file))
        {
          $on=true;
          include_once($path_file);
        }
      
      return ($on);
    }
  
  static protected function _get_values_one_system($setngs,$cfg)
    {
      $data=[];
      
      $data["use_pay_system"]=$cfg["use_pay_system"] ?? "off";
      
      foreach ($setngs as $one_setng)
        {
          $data[$one_setng[0]]=$cfg[$one_setng[0]] ?? $one_setng[3];
        }
      
      return ($data);
    }
  
  static public function save_settings_one_system()
    {
      
      $error=0;
      //$error_index_mas="";
      $error_mas=[0=>[], 1=>[]];
      
      $name_system=((!empty($_POST["create_system"]) && is_string($_POST["create_system"])) ? $_POST["create_system"] : "");
      
      list($error,$error_mas,$data_system,$mas_config)=self::_check_data_settings_one_system($name_system);
      
      if ($error == 0)
        {
          self::_save_config_one_system($name_system,$data_system,$mas_config);
        }
      
      return (["error_proc"=>$error,"error_proc_mas"=>$error_mas]);
    }
  
  static protected function _check_data_settings_one_system($name_system)
    {
      $error=0;
      //$error_index_mas=[];
      $error_mas=[0=>[], 1=>[]];
      
      $data_syst=[];
      $data_config=[];
      
      $dir_syst=DIR_CMS ."/systpayment/";
      $path_elm=$dir_syst . $name_system;
      
      if (is_dir($path_elm))
        {
          $data_syst=self::_check_one_plugin($name_system,$path_elm);
          //write_log_cms($data_syst);
          //$param_use=["use_pay_system","text","on","Использовать платежную систему",""];
          $data_verific=self::_convert_setngs_data_verific($data_syst[1]);
          //$param_use=["use_pay_system","post","use_pay_system","text",true,true,"listv","on,off",false,false,"Обнаружена внутренняя ошибка!",true,"Использование платежной системы"];
          //$data_verific=array_merge([$param_use],$data_verific);
          //write_log_cms($data_verific);
          
          global $obj_control_data;
          $control_data=$obj_control_data->processing_one_group($data_verific);
          //write_log_cms($control_data,"control data");
          if ( $control_data[0] )
            {
              if ( !$control_data[1] )
                {
                  $mas_inbox = $control_data[3];
                  //$mas_status = $control_data[5];
                  
                  $data_config = $mas_inbox;
                  
                }
              else
                {
                  $error=1;
                  $error_mas[1]=$control_data[6];
                }
            }
        }
      else
        {
          $error=1;
          $error_mas[0][]="Неверно указана платежная система!";
        }
      
      return ([$error,$error_mas,$data_syst,$data_config]);
    }
  
  static protected function _convert_setngs_data_verific($setngs)
    {
      $data_verific=eng_scheme_data::convert_setngs_data_verific($setngs);
      
      return ($data_verific);
    }
  
  static protected function _save_config_one_system($name_system,$data_system,$mas_config)
    {
      
      $all_data=self::_get_cfg_all_systems();
      //write_log_cms($all_data,"all data systems");
      $all_data[$name_system]=$mas_config;
      self::_save_cfg_all_systems($all_data);
      
      return (true);
    }
  
  static protected function _get_cfg_all_systems()
    {
      $d=loadNameConfig("cfg_payment_systems");
      
      $all_systems=[];
      
      if ($d && is_array($d))
        {
          //$all_systems=unserialize($d["all_systems"]);
          foreach ($d as $name => $one_cfg)
            {
              $all_systems[$name]=unserialize($one_cfg);
            }
        }
      
      return ($all_systems);
    }
  
  static protected function _save_cfg_all_systems($data_cfg)
    {
      //write_log_cms($data_cfg,"save data cfg");
      $save_data=[];
      
      foreach ($data_cfg as $name => $one_cfg)
        {
          $save_data[$name]=serialize($one_cfg);
        }
      
      //saveNameConfig("cfg_payment_systems",["all_systems"=>serialize($data_cfg)]);
      saveNameConfig("cfg_payment_systems",$save_data);
      
      return (true);
    }
  
}

