<?php

/* файл php */


class tool_check_active_email
  {
   
   private $mas_email = array();
   
   private $on_operation = "off";
   private $text_operation = "Действие не выполнено.";
   
   private $key_data_session = "s_mas_active_email";
   private $delta_time = 0;
   
   function __construct()
     {
      
     }
   
   private function init_mas_email()
     {
      
      if ( isset( $_SESSION[$this->key_data_session] ) )
        {
         $this->mas_email = $_SESSION[$this->key_data_session];
        }
       else
         {
          $_SESSION[$this->key_data_session] = array();
         }
      
     }
   
   private function copy_data_email_in_session()
     {
      $_SESSION[$this->key_data_session] = $this->mas_email;
     }
   
   public function action($operation,$email,$repeat,$code,$check_stop_list)
     {
      
      if ( !check_data_email($email) )
        {
         $this->on_operation = "off";
         $this->text_operation = "Неверный Email.";
         return ( array($this->on_operation, $this->text_operation, $this->delta_time ) );
        }
      
      if ( $check_stop_list === "on" )
        {
         
         $obj_proc_stop_email = new classProcesStopEmail();
         
         $on_stop_email = $obj_proc_stop_email->check_email_in_stop( $email );
         if ( $on_stop_email )
           {
            
            $this->on_operation = "off";
            $this->text_operation = "Вы не можете подтвердить Email! Ваш Email находится в стоп-листе!";
            return ( array($this->on_operation, $this->text_operation, $this->delta_time ) );
           }
         
        }
      
      $this->init_mas_email();
      
      if ( $operation == "get" || $operation == "send" )
        {
         $this->_send_code($operation,$email,$repeat,$code);
        }
       else
         {
          $this->_check_code($operation,$email,$repeat,$code);
         }
      
      return ( array($this->on_operation, $this->text_operation, $this->delta_time ) );
     }
   
   
   private function _send_code($operation,$email,$repeat,$code)
     {
      
      global $url_site;
      
      $time_before=30;// в секундах
      $on_before_send=false;
      $delta=0;
      
      //проверяем, может код уже был отправлен
      if (isset($this->mas_email[$email]))
        {
          $delta=$GLOBALS["timeGlobal"] - $this->mas_email[$email]["time"];
          if ($this->mas_email[$email]["send"] == "on" && ($delta < $time_before ))
            {
              $on_before_send=true;
            }
        }
      //if ( $repeat == "off" && isset( $this->mas_email[$email] ) && $this->mas_email[$email]["send"] == "on" )
      if ( $on_before_send && $repeat == "off" )
        {
         $this->on_operation = "exists";
         $this->text_operation = "Сообщение с кодом подтверждения на Email было отправлено ранее";
         $this->delta_time=$time_before - $delta;
         
         return (false);
        }
      
      //if ( $repeat == "off" )
        {
         $data_old_send = $this->_get_email_db($email);
         if ( $data_old_send )
           {
             $delta=$GLOBALS["timeGlobal"] - $data_old_send["putdate"];
             if ( $delta < $time_before )
               {
                 $this->mas_email[$email] = array("send" => "on", "code" => $data_old_send["code"], "on_check" => "off", "time" => $data_old_send["putdate"]);
                 $this->on_operation = "exists";
                 $this->text_operation = "Сообщение с кодом подтверждения на Email было отправлено ранее";
                 $this->delta_time=$time_before - $delta;
                 
                 $this->copy_data_email_in_session();
                 return (false);
               }
           }
        }
      
      //отправляем код на телефон (или на email для тестов)
      
      //генерируем код
      //$code = "123456";
      $code = rand(111111,999999);
      $code = "" . $code;
      
      global $domen_site,$masConfig;
      $site_name=NAME_SITE_TO_EMAIL;
      
      $mas_perem = array("site_name"=>$site_name);
      $mas_perem["url_site"]=$url_site;
      $mas_perem["domen_site"]=$domen_site;
      $mas_perem["code"]=$code;
      
      $subject=$masConfig["AUTHORIZATION_TITLE_USER_CHECK_EMAIL"];//"Подтверждение Email";
      
      $message=$masConfig["AUTHORIZATION_TEXT_USER_CHECK_EMAIL"];
      $message = replace_perem_texthablon($message,"{","}",$mas_perem);
      $message .= forming_signature_email();
      
      
      //отсылаем код на Email
      
      if ( !send_email($subject,$message,"",$email,false,false,false,false,true) )
        {
          //Сообщение не отправилось
          
          $this->on_operation = "off";
          $this->text_operation = "Не получилось отправить письмо. Попробуйте повторить попытку.";
          
          write_log_cms("Произошла ошибка при отправке письма пользователю", "Скрипт подтверждения Email");
          return (false);
        }
      
      // сообщение отправилось
      //write_log_cms("Сообщение успешно отправлено.","Скрипт подтверждения Email");
      
      //записываем код в массив
      
      $this->mas_email[$email] = array("send" => "on","code" => $code, "on_check" => "off", "time" => $GLOBALS["timeGlobal"]);
      
      //если все хорошо, то возвращаем соотвествующий ответ
      
      $this->on_operation = "on";
      $this->text_operation = "Вам на Email отправлен код подтверждения";
      $this->delta_time=$time_before;
      
      //записываем в сессию данные
      
      $this->copy_data_email_in_session();
      
      //добавляем в базу email и код
      
      $this->add_code_db($email,$code);
      
      return (true);
     }
   
   private function _check_code($operation,$email,$repeat,$code)
     {
      
      if ( !isset( $this->mas_email[$email] ) || $this->mas_email[$email]["send"] != "on" )
        {
         $this->on_operation = "off";
         $this->text_operation = "На ваш Email еще не был отправлен код";
         
         return (true);
        }
      
      if ( $this->mas_email[$email]["code"] == $code )
        {
         
         $this->on_operation = "on";
         $this->text_operation = "Email успешно подтвержден";
         $this->mas_email[$email]["on_check"] = "on";
         
         //записываем в сессию данные
         
         $this->copy_data_email_in_session();
         
        }
       else
         {
          $this->on_operation = "off";
          $this->text_operation = "Неправильный код подтверждения!";
         }
      
      return (true);
     }
   
   public function is_check_active_email($email,$mas_on_check_email = false)
     {
      // првоеряем Email, подтвержден ли он, при этом учитываем email в массиве $mas_on_check_email
      $is_check = false;
      
      if ( $mas_on_check_email && is_array($mas_on_check_email) && sizeof($mas_on_check_email) )
        {
         if ( in_array($email,$mas_on_check_email) ) $is_check = true;
        }
      
      if ( !$is_check )
        {
         $this->init_mas_email();
         
         if ( ( !empty($this->mas_email[$email]) && !empty($this->mas_email[$email]["on_check"]) 
             && $this->mas_email[$email]["on_check"] == "on" )
            )
           {
            $is_check = true;
           }
         
        }
      
      return ($is_check);
     }
   
   private function add_code_db($email,$code)
     {
      $mas_save = array();
      
      $mas_save["id_code"] = 0;
      $mas_save["email"] = $email;
      $mas_save["code"] = $code;
      $mas_save["putdate"] = $GLOBALS["timeGlobal"];
      
      $db_query = forming_db_query_indexmas(DB_PREF."code_active_email",$mas_save,"new","id_code");
      $q_ident = obr_db_query($db_query);
      
     }
   
   private function _get_email_db($email)
     {
      
      $db_query = "select * from ".DB_PREF."code_active_email where email = '".codeText($email)."' order by id_code DESC limit 1 ";
      list($kolvo,$data) = obr_db_query_select_one_assoc($db_query);
      
      return ( ( $kolvo > 0 ) ? $data : false );
     }
   
  }

