<?php

/* файл php */


class tool_check_active_phone
  {
   
   private $mas_phone = array();
   
   private $on_operation = "off";
   private $text_operation = "Действие не выполнено.";
   
   private $key_data_session = "s_mas_active_phone";
   private $delta_time = 0;
   
   function __construct()
     {
      
     }
   
   private function init_mas_phone()
     {
      
      if ( isset( $_SESSION[$this->key_data_session] ) )
        {
         $this->mas_phone = $_SESSION[$this->key_data_session];
        }
       else
         {
          $_SESSION[$this->key_data_session] = array();
         }
      
     }
   
   private function copy_data_phone_in_session()
     {
      $_SESSION[$this->key_data_session] = $this->mas_phone;
     }
   
   public function action($operation,$phone,$repeat,$code,$check_stop_list)
     {
      
      if ( !$this->check_data_phone($phone) )
        {
         $this->on_operation = "off";
         $this->text_operation = "Неправильно написан номер телефона!";
         return ( array($this->on_operation, $this->text_operation, $this->delta_time ) );
        }
      
      $phone = $this->clear_text_phone($phone);
      
      if ( $check_stop_list === "on" )
        {
         
         $obj_proc_stop_phone = new classProcesStopPhone();
         
         $on_stop_phone = $obj_proc_stop_phone->check_phone_in_stop( $phone );
         if ( $on_stop_phone )
           {
            
            $this->on_operation = "off";
            $this->text_operation = "Вы не можете подтвердить телефон! Ваш номер телефона находится в стоп-листе!";
            return ( array($this->on_operation, $this->text_operation, $this->delta_time ) );
           }
         
        }
      
      $this->init_mas_phone();
      
      if ( $operation == "get" || $operation == "send" )
        {
         $this->_send_code($operation,$phone,$repeat,$code);
        }
       else
         {
          $this->_check_code($operation,$phone,$repeat,$code);
         }
      
      return ( array($this->on_operation, $this->text_operation, $this->delta_time ) );
     }
   
   
   private function _send_code($operation,$phone,$repeat,$code)
     {
      
      global $url_site;
      
      $time_before=60;// в секундах
      $on_before_send=false;
      $delta=0;
      
      //проверяем, может код уже был отправлен
      if (isset($this->mas_phone[$phone]))
        {
          $delta=$GLOBALS["timeGlobal"] - $this->mas_phone[$phone]["time"];
          if ($this->mas_phone[$phone]["send"] == "on" && ($delta < $time_before ))
            {
              $on_before_send=true;
            }
        }
      
      if ( $on_before_send && $repeat == "off" )
        {
         $this->on_operation = "exists";
         $this->text_operation = "SMS-сообщение с кодом подтверждения на телефон было отправлено ранее";
         $this->delta_time=$time_before - $delta;
         
         return (false);
        }
      
      //if ( $repeat == "off" )
        {
         $data_old_send = $this->_get_phone_db($phone);
         if ( $data_old_send )
           {
             $delta=$GLOBALS["timeGlobal"] - $data_old_send["putdate"];
             if ( $delta < $time_before )
               {
                 $this->mas_phone[$phone] = array("send" => "on", "code" => $data_old_send["code"], "on_check" => "off", "time" => $data_old_send["putdate"]);
                 $this->on_operation = "exists";
                 $this->text_operation = "SMS-сообщение с кодом подтверждения на телефон было отправлено ранее";
                 $this->delta_time=$time_before - $delta;
                 
                 $this->copy_data_phone_in_session();
                 return (false);
               }
           }
        }
      
      
      //отправляем код на телефон (или на email для тестов)
      
      $num_phone = $phone;
      //генерируем код
      //$code = "123456";
      $code = rand(111111,999999);
      $code = "" . $code;
      
      $text_sms = "Код подтверждения телефона ".$code."";
      
      list($on_send_sms,$text_error) = $this->send_sms($num_phone, $text_sms);
      
      if ( !$on_send_sms )
        {
          //Сообщение не отправилось
          
          $this->on_operation = "off";
          $this->text_operation = "Не получилось отправить SMS. Проверьте номер телефона или попробуйте позже подтвердить телефон.";
    
          write_log_cms("Произошла ошибка при отправке sms пользователю".($text_error ? ". Ошибка: ".$text_error : ""), "Функция подтверждения телефона");
          return (false);
        }
      
      // сообщение отправилось
      //write_log_cms("Сообщение успешно отправлено.","Функция подтверждения телефона");
      
      //записываем код в массив
      
      $this->mas_phone[$phone] = array("send" => "on","code" => $code, "on_check" => "off", "time" => $GLOBALS["timeGlobal"]);
      
      //если все хорошо, то возвращаем соотвествующий ответ
      
      $this->on_operation = "on";
      $this->text_operation = "Вам на телефон отправлен код подтверждения";
      $this->delta_time=$time_before;
      
      //записываем в сессию данные
      
      $this->copy_data_phone_in_session();
      
      //добавляем в базу телефон и код
      
      $this->add_code_db($phone,$code);
      
      return (true);
     }
   
   private function _check_code($operation,$phone,$repeat,$code)
     {
      
      if ( !isset( $this->mas_phone[$phone] ) || $this->mas_phone[$phone]["send"] != "on" )
        {
         $this->on_operation = "off";
         $this->text_operation = "На ваш телефон не был отправлен код";
         
         return (true);
        }
      
      if ( $this->mas_phone[$phone]["code"] == $code )
        {
         
         $this->on_operation = "on";
         $this->text_operation = "Телефон успешно подтвержден";
         $this->mas_phone[$phone]["on_check"] = "on";
         
         //записываем в сессию данные
         
         $this->copy_data_phone_in_session();
         
        }
       else
         {
          $this->on_operation = "off";
          $this->text_operation = "Неправильный код подтверждения!";
         }
      
      return (true);
     }
   
   public function is_check_active_phone($phone,$mas_on_check_phone = false)
     {
      // првоеряем номер телефона, подтвержден ли он, при этом учитываем номера телефонов в массиве $mas_on_check_phone
      $is_check = false;
      
      $phone = $this->clear_text_phone($phone);
      
      if ( $mas_on_check_phone && is_array($mas_on_check_phone) && sizeof($mas_on_check_phone) )
        {
         
         foreach ( $mas_on_check_phone as $one_key => $one_phone ) $mas_on_check_phone[$one_key] = $this->clear_text_phone($one_phone);
         
         if ( in_array($phone,$mas_on_check_phone) ) $is_check = true;
        }
      
      if ( !$is_check )
        {
         $this->init_mas_phone();
         
         if ( ( !empty($this->mas_phone[$phone]) && !empty($this->mas_phone[$phone]["on_check"]) 
             && $this->mas_phone[$phone]["on_check"] == "on" )
            )
           {
            $is_check = true;
           }
         
        }
      
      return ($is_check);
     }
   
   private function check_data_phone( $phone )
     {
      //if ( preg_match("#^((\+)?7)?[0-9]{10}$#iu", $phone) )
      if ( check_data_phone($phone) )
        {
         return (true);
        }
      
      return (false);
     }
   
   private function send_sms($num_phone, $text_sms)
     {
      global $masConfig;
      $is_sent = false;
      
      $text_error = "";
      $error=0;
      
      if ( $masConfig["ON_USE_SMSPILOT"] > 0 )
        {
          if ( $masConfig["ON_USE_SMSPILOT"] == 1 || $masConfig["ON_USE_SMSPILOT"] == 2 )
            {
              if (class_exists("SMSpilot",false))
                {
                  $sms = new SMSPilot($masConfig["SMSPILOT_API_KEY"], 'UTF-8');
                  if (!$sms->send($num_phone, $text_sms, $masConfig["SMSPILOT_NAME_FROM"]))
                    {
                      $is_sent = false;
                      $text_error = $sms->error;
                      $error = 1;
                    }
                  else
                    {
                      $is_sent = true;
                    }
                }
              else
                {
                  $is_sent = false;
                  $text_error = "Система не настроена";
                  $error = 1;
                }
            }
          
          if ( $error == 0 && ( $masConfig["ON_USE_SMSPILOT"] == 2 || $masConfig["ON_USE_SMSPILOT"] == 3 ) )
            {
              send_email("Подтверждение телефона ".$num_phone, $text_sms, NAME_EMAIL_ADMIN, EMAIL_ADMIN);
              $is_sent = true;
            }
          
        }
       else
         {
          $is_sent = false;
          $text_error = "Система не настроена";
         }
      
      return ( array($is_sent,$text_error) );
     }
   
   private function clear_text_phone($phone)
     {
      // убираем из номера телефона все символы кроме цифр
      $num_phone = preg_replace("/[^0-9]/uis","",$phone);
      return ( $num_phone );
     }
   
   private function add_code_db($phone,$code)
     {
      $mas_save = array();
      
      $mas_save["id_code"] = 0;
      $mas_save["phone"] = $phone;
      $mas_save["code"] = $code;
      $mas_save["putdate"] = $GLOBALS["timeGlobal"];
      
      $db_query = forming_db_query_indexmas(DB_PREF."code_active_phone",$mas_save,"new","id_code");
      $q_ident = obr_db_query($db_query);
      
     }
   
   private function _get_phone_db($phone)
     {
      
      $db_query = "select * from ".DB_PREF."code_active_phone where phone = '".codeText($phone)."' order by id_code DESC limit 1 ";
      list($kolvo,$data) = obr_db_query_select_one_assoc($db_query);
      
      return ( ( $kolvo > 0 ) ? $data : false );
     }
   
  }

