<?php


class eng_fsupload
{
  
  protected $error=0;
  protected $error_text="";
  protected $rez="";
  
  private $type_upload = "";
  private $mas_images = array();
  private $save_images = false;
  private $rename_images = array();
  private $dir_big_images = "";
  private $dir_small_images = "";
  private $dir_images_cms = "";
  
  private $opts=array();
  
  
  function start()
    {
      
    }
  
  function base()
    {
      
    }
  
  function delete_tmp_one($key_post_tmp)
    {
      //$key_post_tmp="name_tmp";
      
      $error = 0;
      $error_text = "no";
      
      if (!empty($_POST[$key_post_tmp]))
        {
          if ($this->check_safe_image($_POST[$key_post_tmp], DIR_TMP_DATA))
            {
              
              $err_delete = delete_file(DIR_TMP_DATA."/", $_POST[$key_post_tmp]);
              if ($err_delete)
                {
                  $error = 1;
                  $error_text = "файл не был удален (".$err_delete.")";
                }
            }
          else
            {
              $error = 1;
              $error_text = "Ошибка с данными";
            }
        }
      else
        {
          $error = 1;
          $error_text = "не указано название файла";
        }
      
      return (array($error, $error_text));
    }
  
  function check_safe_image($name,$dir)
    {
      if (!$this->check_name($name)) return (false);
      
      $exp = proverka_exp_file($name, "jpg|gif|png|jpeg");
      
      if (!$exp) return (false);
      
      if (!file_exists($dir."/".$name)) return (false);
      
      return (true);
    }
  
  function check_name($name)
    {
      $on=false;
      
      if (preg_match('#(\\.\\.)|(\\/)|(\\\\)#',$name) === 0) $on=true;
      
      return ($on);
    }
  
  function upload_tmp_files($name_pole,$pref_tmp,$max_size_file)
    {
      //на данный момент поддерживается загрузка одного файла (если нужно загрузить несколько временных файлов, то нужно загружать по одному)
      list($error, $error_text, $file) = $this->upload_one_file_tmp($name_pole,$pref_tmp,$max_size_file);
      
      $data=array("oper_error"=>$error,"oper_error_text"=>$error_text,"files"=>($error == 0 ? [$file]:[]));
      
      return (array(0, "", $data));
    }
  
  function upload_one_file_tmp($name_pole,$pref_tmp,$max_size_file)
    {
      //функция загружает одно изображение во временную папку
      //поле $name_pole не должно быть массивом (значение должно быть в виде $name_pole="newfile") 
      //функция возвращает массив в виде [имя_файла, имя_временного_файла]
      $error = 0;
      $error_text = "no";
      $data = array();
      
      if (!empty($_FILES) && !empty($_FILES[$name_pole]) && !is_array($_FILES[$name_pole]["error"]))
        {
          if ($_FILES[$name_pole]["error"] == 0 && $_FILES[$name_pole]["size"]<=$max_size_file)
            {
              $name_file = $_FILES[$name_pole]["name"];
              $exp = get_exp_file($name_file);
              $name_tmp = generator_name_file_unique_dir(DIR_TMP_DATA, $exp, $pref_tmp);
              
              if (proverka_exp_file($name_file, "jpg|gif|png|jpeg"))
                {
                  
                  if (move_uploaded_file($_FILES[$name_pole]["tmp_name"], DIR_TMP_DATA."/".$name_tmp))
                    {
                      $data = array($name_file, $name_tmp);
                      
                      if (!eng_image_file::check_img_type($exp,DIR_TMP_DATA."/".$name_tmp))
                        {
                          $error = 1;
                          $error_text="Неверный тип изображжения!";
                        }
                      
                      if ($error != 0)
                        {
                          //ошибка с загруженным изображением, удаляем временный файл
                          delete_file(DIR_TMP_DATA."/",$name_tmp);
                        }
                      /*
                      $angle = 0;
                      $path_tmp=DIR_TMP_DATA."/".$name_tmp;
                      
                      $exif=@exif_read_data($path_tmp);
                      
                      if ($exif && !empty($exif["Orientation"]))
                        {
                          switch ($exif["Orientation"])
                            {
                              case 8: $angle=90;break;
                              case 3: $angle=180;break;
                              case 6: $angle=-90;break;
                            }
                        }
                      
                      if ($angle != 0)
                        {
                          $image= new Imagick($path_tmp);
                          
                          $image->rotateImage("#00000000",-$angle);
                          $image->stripImage();
                          $image->writeImage();
                          $image->clear();
                        }
                      
                      */
                      
                    }
                  else
                    {
                      $error = 1;
                      $error_text = "Ошибка с перемещением файла";
                    }
                  
                }
              else
                {
                  $error = 1;
                  $error_text = "Неверное расширение файла";
                }
            }
          else
            {
              $error = 1;
              $error_text = "Ошибка с загрузкой";
            }
          
          
        }
      
      return (array($error, $error_text, $data));
    }
  
  
  
  
  function set_data_imgs($mas_exists_imgs,$dir_big_images,$dir_small_images,$dir_images_cms,$opts)
    {
      $this->opts=[
       "max_numbr_files"=>5,
       "max_size_img"=>50000000,
       
       "on_use_wm_img"=>1,
       "file_wm_img"=>"",
       "position_x_wm"=>10,
       "position_y_wm"=>10,
       
       "max_width_img"=>2000,
       "max_height_img"=>1200,
       "max_width_preview"=>200,
       "max_height_preview"=>100,
       
       "name_pole_type_upload"=>"",
       "name_pole_dlt"=>"",
       "name_pole_new"=>"",
       "name_pole_sort"=>"",
       
       "name_field_files"=>"upload_field_files",
       "nplane"=>0,
       
      ];
      
      $this->type_upload = "";
      $this->mas_images = $mas_exists_imgs;
      $this->save_images = false;
      
      $this->rename_images = array();
      
      $this->dir_big_images = $dir_big_images;
      $this->dir_small_images = $dir_small_images;
      $this->dir_images_cms = $dir_images_cms;
      
      foreach ($this->opts as $key => $value)
        {
          if (isset($opts[$key])) $this->opts[$key]=$opts[$key];
        }
      
      
    }
  
  function process_upload_imgs()
    {
      
      $error=0;
      $error_text="";
      
      $this->type_upload=$this->get_value_indata("type_upload");
      //write_log_cms($this->type_upload,"type upload");
      
      if ($this->type_upload == "preload")
        {
          list($error,$error_text)=$this->delete_exists_imgs();
          
          list($error,$error_text)=$this->check_add_new_imgs_preload();
          list($error,$error_text)=$this->proc_sort_imgs();
        }
       elseif ($this->type_upload == "normal")
         {
           list($error,$error_text)=$this->delete_exists_imgs();
           
           list($error,$error_text)=$this->check_add_new_imgs_normal();
           
         }
      
      return ([$error,$error_text,$this->save_images,$this->mas_images]);
    }
  
  function get_value_indata($name_d)
    {
      $v="";
      $vv="";
      
      if ($name_d == "type_upload")
        {
          $vv=$_POST[$this->opts["name_pole_type_upload"]] ?? "";
        }
       else if ($name_d == "list_new")
         {
           $vv=$_POST[$this->opts["name_pole_new"]] ?? "";
         }
       else if ($name_d == "list_delete")
         {
           $vv=$_POST[$this->opts["name_pole_dlt"]] ?? "";
         }
       else if ($name_d == "list_sort")
         {
           $vv=$_POST[$this->opts["name_pole_sort"]] ?? "";
         }
      
      if ($vv && is_string($vv))
        {
          $v = $vv;
        }
      
      return ($v);
    }
  
  function delete_exists_imgs()
    {
      //удаляем изображения, которые были добавлены к 
      
      $list_delete=$this->get_value_indata("list_delete");
      
      if (sizeof($this->mas_images) > 0 && $list_delete)
        {
          
          $mas_delete_images = explode("|", $list_delete);
          
          foreach ($mas_delete_images as $name_image)
            {
              $num_index_del = array_search($name_image, $this->mas_images);
              if ($num_index_del !== false)
                {
                  $this->save_images = true;
                  //удаляем название файла из массива
                  unset($this->mas_images[$num_index_del]);
                  $this->mas_images = array_values($this->mas_images);
                  
                  //удаляем большую и маленькую картинки
                  if (!(file_exists($this->dir_big_images.$name_image) && unlink($this->dir_big_images.$name_image)))
                    {
                      
                    }
                  
                  if (!(file_exists($this->dir_small_images.$name_image) && unlink($this->dir_small_images.$name_image)))
                    {
                      
                    }
                }
            }
          
        }
    
      return (array(0, ""));
    }
  
  function check_add_new_imgs_preload()
    {
      // проверяем прикрепленные рисунки с помощью предварительной загрузки
      global $masConfig;
      
      $list_name_new=$this->get_value_indata("list_new");
      
      $opts=$this->opts;
      $error=0;
      $error_text="";
      
      if ($list_name_new)
        {
          $mas_name_img = explode("|", $list_name_new);
          
          if (!($opts["max_numbr_files"] > 0 && sizeof($this->mas_images) >= $opts["max_numbr_files"]))
            {
              $use_watermark = false;
              $file_img_watermark = "";
              if ($opts["on_use_wm_img"] == 1 && $opts["file_wm_img"] && proverka_exp_img($opts["file_wm_img"]))
                {
                  $use_watermark = true;
                  $file_img_watermark = $this->dir_images_cms.$opts["file_wm_img"];
                  
                }
              
              for ($n = 0; $n < sizeof($mas_name_img); $n++)
                {
                  
                  if ($opts["max_numbr_files"] > 0 && sizeof($this->mas_images) >= $opts["max_numbr_files"])
                    {
                      //максимальное количество изображений достигнуто - выходим из цикла
                      break;
                    }
                  
                  $name_one_img = $mas_name_img[$n];
                  $path_img = DIR_TMP_DATA."/".$name_one_img;
                  $stat_file = false;
                  
                  if ($name_one_img && file_exists($path_img) && is_file($path_img)) $stat_file = stat($path_img);
                  
                  if ($stat_file && $stat_file["size"] < $opts["max_size_img"])//(&& is_uploaded_file($path_img))
                    {
                      $name_upload = $name_one_img;
                      
                      $exp = proverka_exp_img($name_upload);//фукнция проверяет расширение, в случае допустимого расширения возвращает его
                      // если расширение не допустимо, возвращает false
                      
                      if (!$exp)
                        {
                          $error=1;
                          $error_text="Неверный формат рисунка!";
                          //return (array(1, "Неверный формат рисунка!"));
                        }
                      
                      if ($error == 0)
                        {
                          //генерируем новое случайное имя рисунка
                          $newname = generator_name_file_unique_dir($this->dir_small_images, $exp);
                          
                          $on_add_image = false;
                          
                          if ($use_watermark)
                            {
                              
                              if (transform_size_image_watermark($path_img, $this->dir_big_images.$newname, $file_img_watermark, $opts["max_width_img"], $opts["max_height_img"], true, $opts["position_x_wm"], $opts["position_y_wm"], 85, $opts["nplane"], true) 
                                  &&
                                  transform_size_image($path_img, $this->dir_small_images.$newname, $opts["max_width_preview"], $opts["max_height_preview"], false, 85, $opts["nplane"], true))
                                  $on_add_image = true;
                              
                            }
                          else
                            {
                              if (transform_size_image($path_img, $this->dir_big_images.$newname, $opts["max_width_img"], $opts["max_height_img"], true, 85, $opts["nplane"], true) 
                                  &&
                                  transform_size_image($path_img, $this->dir_small_images.$newname, $opts["max_width_preview"], $opts["max_height_preview"], false, 85, $opts["nplane"], true))
                                  $on_add_image = true;
                            }
                          
                          
                          if ($on_add_image)
                            {
                              $this->mas_images[] = $newname;
                              $this->save_images = true;
                              $this->rename_images[] = array($name_one_img, $newname);
                            }
                          else
                            {
                              $error=1;
                              $error_text="Произошла ошибка при сохранении рисунка!";
                              //return (array(1, "Произошла ошибка при сохранении рисунка!"));
                            }
                          
                        }
                    }
                  /*else
                    {
                     return (array(1,"Файл не найден"));
                    }*/
                  
                }
              
            }
          
          //удаляем временные файлы (изображения из /tmp)
          delete_mas_file(DIR_TMP_DATA."/", $mas_name_img);
          
        }
      
      return (array(0, ""));
    }
  
  function proc_sort_imgs()
    {
      
      //Сортировка изображений
      global $masConfig;
      
      $list_name_sort = $this->get_value_indata("list_sort");
      
      if ($list_name_sort && $list_name_sort != implode("|", $this->mas_images))
        {
          
          if (sizeof($this->rename_images))
            {
              foreach ($this->rename_images as $one_data)
                {
                  $list_name_sort = str_replace($one_data[0], $one_data[1], $list_name_sort);
                }
            }
          
          $mas_name_sort = explode("|", $list_name_sort);
          
          $mas_numb_name_sort = array();
          
          for ($i = 0; $i < sizeof($mas_name_sort); $i++)
            {
              $mas_numb_name_sort[$mas_name_sort[$i]] = $i + 1;
            }
          
          $mas_proc_name = array();
          
          $quant = sizeof($this->mas_images);
          
          for ($i = 0; $i < $quant; $i++)
            {
              $pos = 0;
              if (!empty($mas_numb_name_sort[$this->mas_images[$i]]))
                $pos = $mas_numb_name_sort[$this->mas_images[$i]];
               else
                 $pos = $quant + $i + 1;
              
              $mas_proc_name[] = array($this->mas_images[$i], $pos);
            }
          
          usort($mas_proc_name, function ($a, $b) {
            return ($a[1] - $b[1]);
          });
          
          $this->mas_images = select_mas1lev_2level($mas_proc_name, 0, false);
          $this->save_images = true;
        }
      
      return (array(0, ""));
    }
  
  function check_add_new_imgs_normal()
    {
      //global $masConfig;
      
      $opts=$this->opts;
      
      $use_watermark = false;
      $file_img_watermark = "";
      if ($opts["on_use_wm_img"] == 1 && $opts["file_wm_img"] && proverka_exp_img($opts["file_wm_img"]))
        {
          $use_watermark = true;
          $file_img_watermark = $this->dir_images_cms.$opts["file_wm_img"];
        }
      
      $max_numbr_img=0;
      $add_img=true;
      
      if ( $opts["max_numbr_files"] > 0 )
        {
          $nn=$opts["max_numbr_files"]-sizeof($this->mas_images);
          if ($nn > 0)
            {
              $add_img=true;
              $max_numbr_img=$nn;
            }
           else
             {
               $add_img=false;
               
             }
        }
      
      if ($add_img)
        {
          $data_new_upload_files = save_upload_mas_file($opts["name_field_files"], $this->dir_small_images, true, "jpg|jpeg|gif|png", 
            "tosize", $opts["max_width_preview"], $opts["max_height_preview"], $opts["max_size_img"], $this->dir_big_images, 
            "resize", $opts["max_width_img"], $opts["max_height_img"], false, 0, 0, $file_img_watermark, $opts["position_x_wm"], $opts["position_y_wm"],$opts["nplane"],true,$max_numbr_img);
          
          if ($data_new_upload_files[0])
            {
              $this->save_images = true;
              $this->mas_images = array_merge($this->mas_images, $data_new_upload_files[2]);
            }
        }
      
      return (array(0, ""));
    }
  
}

