<?php



class eng_payment_systems
{
  
  
  function __construct()
    {
      
    }
  
  static public function get_list_systems()
    {
      $mas_init_ps=[];
      $mas_name_ps=[];
      $mas_desc_ps=[];
      
      $all_systems=self::_get_cfg_all_systems();
      //write_log_cms($all_systems,"all systems");
      
      foreach ($all_systems as $name_system => $d_system)
        {
          if ($d_system["use_pay_system"] == "on")
            {
              $mas_name_ps[]=$name_system;
              $mas_init_ps[$name_system]=[$d_system["name_system"],$d_system["max_amount"],$d_system["min_amount"]];
              $mas_desc_ps["name_".$name_system]=$d_system["name_system"];
            }
        }
      
      return ([$mas_init_ps,$mas_name_ps,$mas_desc_ps]);
    }
  
  static public function get_cfg_one_system($name)
    {
      $one_cfg=[];
      
      $all_systems=self::_get_cfg_all_systems();
      if (!empty($all_systems[$name])) $one_cfg=$all_systems[$name];
      
      return ($one_cfg);
    }
  
  static protected function _get_cfg_all_systems()
    {
      $d=loadNameConfig("cfg_payment_systems");
      //write_log_cms($d,"data file cfg payment systems");
      $all_systems=[];
      
      if ($d && is_array($d))
        {
          //$all_systems=unserialize($d["all_systems"]);
          foreach ($d as $name => $one_cfg)
            {
              $all_systems[$name]=unserialize($one_cfg);
            }
        }
      
      return ($all_systems);
    }
  
  static public function adapter_definition($name)
    {
      global $spayment_adapter;
      if (isset($spayment_adapter[$name])) return (true);
      
      //$_path_file = DIR_COMPLEMENT."spayment_".$name.".php";
      $path_file = DIR_CMS ."/systpayment/". $name."/" . "paysystem_".$name .".php";
      
      $on_cl = false;
      if (file_exists($path_file))
        {
          $name_cl = "eng_paysystem_".$name;
          include($path_file);
          
          $one_cfg=self::get_cfg_one_system($name);
          $spayment_adapter[$name] = new $name_cl($one_cfg);
          
          $on_cl = true;
        }
      
      return ($on_cl);
    }
  
  
  static public function add_order($payment_name,$amount,$modul,$oper,$number,$param,$service_amount,$num_user=0)
    {
      //$payment_name - название платежной системы: webmoney, robokassa и т.п. или balance (при оплате с баланса)
      //$amount - сумма
      //$modul
      //$oper - операция, текст
      //$param - дополнительные параметры: false, текст или массив
      //$service_amount - сумма, необязательный параметр
      //$num_user - id пользователя (добавлено в версии v23.2)
      
      $d_save = array();
      $d_save["id_order"] = 0;
      $d_save["payment_name"] = $payment_name;
      $d_save["modul"] = $modul;
      $d_save["amount"] = $amount;
      $d_save["oper"] = $oper;
      $d_save["number"] = $number;
      $d_save["param"] = ($param === false ? "" : serialize($param));
      $d_save["put_date"] = $GLOBALS["timeGlobal"];
      $d_save["service_amount"] = $service_amount;
      $d_save["num_user"] = ($num_user > 0 ? $num_user : 0);
      
      $db_query = forming_db_query_indexmas(DB_PREF."payment_order", $d_save, "new", "id_order");
      db_work::query($db_query);
      $id_order = db_work::get_insert_id();
      
      //write_log_cms($id_order,"id payment order");
      
      return ($id_order);
    }
  
  static public function get_order($id_order,$num_user=false)
    {
      $db_query="select * from ".DB_PREF."payment_order where id_order=".codeText($id_order) .($num_user !== false ? " and num_user = ". $num_user:"");
      list($kolvo,$data_order)=db_work::query_select_one_assoc($db_query);
      
      return ($kolvo > 0 ? $data_order:false);
    }
  
  static public function set_paid_order($id_order)
    {
      $db_query="update ".DB_PREF."payment_order set paid='on' where id_order=".codeText($id_order);
      db_work::query($db_query);
      
      return (true);
    }
  
  static public function get_param_form($spayment_name,$id_order,$amount,$description)
    {
      global $spayment_adapter;
      $data = false;
      $on_payment = false;
      
      if (!isset($spayment_adapter[$spayment_name]))
        {
          $on_payment = self::adapter_definition($spayment_name);
        }
      else
        $on_payment = true;
      
      if ($on_payment) $data = $spayment_adapter[$spayment_name]->init_data_form_payment($id_order, $amount, $description);
      
      return ($data);
    }
  
  static public function forming_pay_param_form($name_ps,$amount,$modul,$oper,$number,$param,$num_user,$description_pay)
    {
      //$payment_name,$amount,$modul,$oper,$number,$param,$service_amount,$num_user=0
      
      global $spayment_adapter;
      
      self::adapter_definition($name_ps);
      $pay_amount = $spayment_adapter[$name_ps]->conversion_pay($amount);
      
      $id_payment_order = eng_payment_systems::add_order($name_ps, $pay_amount, $modul, $oper, $number, $param, $amount, $num_user);
      
      $data_form = eng_payment_systems::get_param_form($name_ps, $id_payment_order, $pay_amount, $description_pay);
      
      return ([$id_payment_order,$pay_amount,$data_form]);
    }
  
  static public function check_receipt($spayment_name)
    {
      global $spayment_adapter,$obj_site;
      
      $error = 0;
      $error_text = "";
      $id_payment_order = 0;
      $amount = 0;
      $is_check_query = false;
      
      $data_order = false;
      
      $on_payment = false;
      if (!isset($spayment_adapter[$spayment_name]))
        {
          $on_payment = self::adapter_definition($spayment_name);
        }
      else
        $on_payment = true;
      
      $data = false;
      
      if ($on_payment)
        {
          $data = $spayment_adapter[$spayment_name]->check_data_payment();
          list($error, $error_text, $id_payment_order, $amount, $is_check_query) = $data;
          //$data->[$error,$error_text,$payment_num,$payment_amount,$is_check_query]
        }
      else
        {
          $error = 1;
          $error_text = "Ошибка с укзанием платежной системы.";
        }
      //write_log_cms($data,"data payment receipt");
      
      if ($error == 0 && $id_payment_order == 0 && $is_check_query) return (array(0, "", false));
      
      if ($error == 0)
        {
          if (is_numeric($id_payment_order) && $id_payment_order > 0)
            {
              $data_order = self::get_order($id_payment_order, false);
              if (!$data_order)
                {
                  $error = 1;
                  $error_text = "Неверно задан номер платежа.";
                }
            }
          else
            {
              $error = 1;
              $error_text = "Ошибка с инициализационными данными.";
            }
        }
      
      if ($error == 0 && $data_order)
        {
          if ($data_order["paid"] == "on")
            {
              //проверяем оплачен или нет
              $error = 1;
              $error_text = "Повторное проведение платежа.";
            }
          
          if ($error == 0 && $data_order["amount"] > $amount)
            {
              $error = 1;
              $error_text = "Неверная сумма платежа.";
            }
          
          if ($error == 0)
            {
              if ($data_order["modul"] == "mainModul")
                {
                  list($error, $error_text)=self::main_modul_receipt($data_order, $is_check_query);
                }
              elseif ($obj_site->check_name_modul($data_order["modul"]))
                {
                  $obj_modul = $obj_site->getObjModul($data_order["modul"]);
                  list($error, $error_text) = $obj_modul->paymentSystemOperationReceipt($spayment_name, $data_order["oper"], $data_order["number"], $data_order["param"] !== "" ? unserialize($data_order["param"]) : false, $data_order["service_amount"], array("type_ps" => $data_order["payment_name"]), $is_check_query, $data_order["num_user"]);
                }
              else
                {
                  $error = 1;
                  $error_text = "Ошибка с инициализационными данными: неверно укзан модуль.";
                }
              
              if ($error == 0 && !$is_check_query)
                {
                  self::set_paid_order($data_order["id_order"]);
                }
            }
        }
      
      return (array($error, $error_text, $data_order));
    }
  
  static public function answer_result($error,$error_text,$spayment_name,$data_order=false)
    {
      global $spayment_adapter;
      self::adapter_definition($spayment_name);
      
      return ($spayment_adapter[$spayment_name]->answer_result($error,$error_text,$data_order));
    }
  
  
  static public function main_modul_receipt($d_order,$is_check_query)
    {
      $error = 0;
      $error_text = "";
      
      if ($d_order["oper"] == "addmoney")
        {
          
          list($error, $error_text) = eng_money_user::operationCheckServiceAddMoney($d_order["number"], $d_order["service_amount"], array("type_ps" => $d_order["payment_name"]), $is_check_query);
        }
      
      return (array($error, $error_text));
    }
  
  static public function payment_balance_main_modul($data_order,$on_payment = false)
    {
      //оплата с баланса в главном модуле
      
      //Функционал нужно будет написать при необходимости оплаты чего-либо в главном модуле
      
      return (false);
    }
  
  
}

