<?php

class eng_subscribe_content
{
  protected $num_user = 0;
  protected $on_user = false;
  protected $name_user_authorize=false;
  protected $data_auth_user=false;
  
  protected $oper="";
  
  function __construct()
    {
      
    }
  
  function work_external()
    {
      $data=false;
      
      $error=0;
      $error_text="";
      
      $this->check_auth_user();
      
      $this->oper=((!empty($_POST["oper"]) && is_string($_POST["oper"])) ? $_POST["oper"] : "");
      $data_res=false;
      //write_log_cms($this->oper,"eng subscribe content, oper");
      if ($this->oper == "change_subscribe_user")
        {
          list($error,$error_text,$data_res)=$this->change_subscribe_user();
        }
      elseif ($this->oper == "change_subscribe_author")
        {
          list($error,$error_text,$data_res)=$this->change_subscribe_author();
        }
      
      $data=["error_proc"=>$error,"error_text_proc"=>$error_text,"data_res"=>($data_res ? $data_res:"")];
      
      return ($data);
    }
  
  function check_auth_user()
    {
      if ($GLOBALS["user_to_site"] && $GLOBALS["id_user_to_site"] > 0)
        {
          $this->num_user = $GLOBALS["id_user_to_site"];
          $this->name_user_authorize = $GLOBALS["name_user_to_site"];
          $this->data_auth_user = $GLOBALS["data_authorize_user"];
          $this->on_user = true;
        }
    }
  
  function change_subscribe_user()
    {
      list($error,$error_text,$data)=$this->_proc_change_subscribe_user();
      
      return ([$error,$error_text,$data]);
    }
  
  function _proc_change_subscribe_user()
    {
      global $obj_control_data;
      
      $error=0;
      $error_text="";
      $data=false;
      
      if (!$this->on_user) return ([1,"Нужно авторизоваться!",false]);
      
      $mas_init=array(
        array("num_author","post","num_author","numeric",true,true,false,"",false,"tr","all",0,"Не указан автор!",false,false),
        array("type","post","type","text",true,true,"listv","on,off",false,false,"all","off"),
        array("contr_code","post","contr_code","text",true,true,false,"",false,false,false,false,"Не указан ключ безопасности!",true,false),
       );
      
      $rez_control_data = $obj_control_data->processing_one_group($mas_init);
      
      if ( !($rez_control_data[0] && !$rez_control_data[1]) ) return ([1,"Ошибка с данными",false]);
      
      $mas_inbox = $rez_control_data[3];
      
      if ( !eng_promote_safety::check_code($GLOBALS["id_user_to_site"],$mas_inbox["contr_code"]) ) return ([1,"Неверный ключ безопасности!",false]);
      
      if ($mas_inbox["num_author"] == $this->num_user) return ([1,"Невозможно подписаться на самого себя!",false]);
      
      $d_subscribe=$this->get_one_subscribe_author($mas_inbox["num_author"],$this->num_user);
      
      if ($d_subscribe && $d_subscribe["status"]=="on")
        {
          if ($mas_inbox["type"] == "off")
            {
              //удаляем подписку на контент
              $this->_delete_one_subscriber($mas_inbox["num_author"],$this->num_user,$d_subscribe);
            }
        }
      elseif ($mas_inbox["type"] == "on")
        {
          //добавляем подписку на контент
          $this->_add_one_subscriber($mas_inbox["num_author"],$this->num_user,$d_subscribe);
        }
      
      return ([$error,$error_text,$data]);
    }
  
  function get_one_subscribe_author($num_author,$num_user)
    {
      $db_query="select * from ".DB_PREF."subscribe_content where num_author = ".$num_author." and num_user = ".$num_user ." limit 1 ";
      list($kolvo,$data_subscribe)=db_work::query_select_one_assoc($db_query);
      
      return ($kolvo>0?$data_subscribe:false);
    }
  
  function check_on_subscribe_author($num_author,$num_user)
    {
      /*
      $db_query="select * from ".DB_PREF."subscribe_content where num_author = ".$num_author." and num_user = ".$num_user ." limit 1 ";
      list($kolvo,$data_subscribe)=db_work::query_select_one_assoc($db_query);
      */
      $data_subscribe=$this->get_one_subscribe_author($num_author,$num_user);
      
      return (($data_subscribe && $data_subscribe["status"]=="on") ? $data_subscribe:false);
    }
  
  protected function _add_one_subscriber($num_author,$num_user,$d_subscribe)
    {
      //Добавляем нового подписчика, если запись есть, то меняем параметр status с off на on
      //Проверка наличия записи в БД не проверяется, нужно делать заранее, данные подписки должны быть в переменной $d_subscribe
       
      $mas_data=["id_subscribe"=>$d_subscribe ? $d_subscribe["id_subscribe"]:0,"num_author"=>$num_author,"num_user"=>$num_user,"put_date"=>$GLOBALS["timeGlobal"],"status"=>"on"];
      
      $db_query=forming_db_query_indexmas(DB_PREF."subscribe_content",$mas_data,$d_subscribe ? "edit":"new","id_subscribe");
      db_work::query($db_query);
      
      return (true);
    }
  
  protected function _delete_one_subscriber($num_author,$num_user,$d_subscribe)
    {
      //Удаляем подписку - меняем статус (параметр status) на off
      
      $db_query="update ".DB_PREF."subscribe_content set status='off', put_date=".$GLOBALS['timeGlobal']
        ." where num_author=".$num_author." and num_user=".$num_user;
      db_work::query($db_query);
      
      return (true);
    }
  
  static public function get_text_query_list_authors($num_user)
    {
      $db_query="select num_author from ".DB_PREF."subscribe_content where num_user = ".$num_user." and status='on' ";
      return ($db_query);
    }
  
  static public function get_count_authors($num_user,$only_actual)
    {
      $db_query="select count(*) from ".DB_PREF."subscribe_content where num_user = ".$num_user." ".($only_actual ? " and status='on' " : "");
      $kolvo = db_work::query_count($db_query);
      
      return ($kolvo);
    }
  
  static public function get_count_users_author($num_author,$only_actual)
    {
      $db_query="select count(*) from ".DB_PREF."subscribe_content where num_author = ".$num_author." ".($only_actual ? " and status='on' " : "");
      $kolvo = db_work::query_count($db_query);
      
      return ($kolvo);
    }
  
  function get_info_authors_page($num_user,$num_page,$elms_page,$only_actual)
    {
      $kolvo_vsego=0;
      $data_authors=[];
      
      $kolvo_vsego=$this->get_count_authors($num_user,$only_actual);
      
      if ($kolvo_vsego > 0)
        {
          $db_query = "select * from ".DB_PREF."subscribe_content where num_user=".$num_user." ".($only_actual ? " and status='on' ":"")
            ." order by id_subscribe DESC limit  ".(($num_page - 1) * $elms_page).",".$elms_page;
          
          list($kolvo,$data_authors)=db_work::query_select_assoc($db_query);
        }
      
      return ([$kolvo_vsego,$data_authors]);
    }
  
  function get_info_users_author_page($num_author,$num_page,$elms_page,$only_actual)
    {
      $kolvo_vsego=0;
      $data_authors=[];
      
      $kolvo_vsego=$this->get_count_users_author($num_author,$only_actual);
      
      if ($kolvo_vsego > 0)
        {
          $db_query = "select * from ".DB_PREF."subscribe_content where num_author=".$num_author." ".($only_actual ? " and status='on' ":"")
            ." order by id_subscribe DESC limit  ".(($num_page - 1) * $elms_page).",".$elms_page;
          
          list($kolvo,$data_authors)=db_work::query_select_assoc($db_query);
        }
      
      return ([$kolvo_vsego,$data_authors]);
    }
  
  
  function change_subscribe_author()
    {
      list($error,$error_text,$data)=$this->_proc_change_subscribe_author();
      
      return ([$error,$error_text,$data]);
    }
  
  function _proc_change_subscribe_author()
    {
      global $obj_control_data;
      
      $error=0;
      $error_text="";
      $data=false;
      
      if (!$this->on_user) return ([1,"Нужно авторизоваться!",false]);
      
      $mas_init=array(
        array("num_user","post","num_user","numeric",true,true,false,"",false,"tr","all",0,"Не указан пользователь!",false,false),
        array("type","post","type","text",true,true,"listv","on,off",false,false,"all","off"),
        array("contr_code","post","contr_code","text",true,true,false,"",false,false,false,false,"Не указан ключ безопасности!",true,false),
       );
      
      $rez_control_data = $obj_control_data->processing_one_group($mas_init);
      
      if ( !($rez_control_data[0] && !$rez_control_data[1]) ) return ([1,"Ошибка с данными",false]);
      
      $mas_inbox = $rez_control_data[3];
      
      if ( !eng_promote_safety::check_code($GLOBALS["id_user_to_site"],$mas_inbox["contr_code"]) ) return ([1,"Неверный ключ безопасности!",false]);
      
      //if ($mas_inbox["num_user"] == $this->num_user) return ([1,"Невозможно подписаться на самого себя!",false]);
      
      $d_subscribe=$this->get_one_subscribe_author($this->num_user,$mas_inbox["num_user"]);
      //write_log_cms($d_subscribe,"eng subs");
      if ($d_subscribe && $d_subscribe["status"] == "on")
        {
          if ($mas_inbox["type"] == "off")
            {
              //отменяем подписку на контент
              $this->_delete_one_subscriber($this->num_user,$mas_inbox["num_user"],$d_subscribe);
            }
        }
      elseif ($mas_inbox["type"] == "on")
        {
          //Восстанавливаем подписку
          //Восстановить можно, если есть запись о подписке
          if ($d_subscribe)
            {
              //восстанавливаем подписку на контент
              $this->_add_one_subscriber($this->num_user, $mas_inbox["num_user"], $d_subscribe);
            }
          else
            {
              //Запись не найдена, восстановить нет возможности
              return ([1,"Восстановить подписку невозможно!",false]);
            }
        }
      
      return ([$error,$error_text,$data]);
    }
  
  static function clear_data_subscribe()
    {
      $db_query="delete from ".DB_PREF."subscribe_content where status='off' and put_date < ".($GLOBALS["timeGlobal"] - 1*24*3600)." ";
      db_work::query($db_query);
      
      return (true);
    }
  
}