<?php

/*
Класс db_work нужно использовать для работы с базой данных взамен функций obr_db_query_xxx()
Теперь не нужно описывать функцию obr_db_query() в отдельных частях кода.
Нужно определить функцию eng_db_error::main() и использовать метод db_work::query($db_query);

Для совместимости со старым кодом нужно удалить функцию obr_db_query() (она есть в данном файле)

и добавить функцию eng_db_error::main($error_text = "Произошла ошибка с базой даннных!") - данная функция будет вызываться в результате ошибки в работе с базой даннных

*/

class db_work
  {
   
   function __construct()
     {
      
     }
   
   public static function query($db_query,$t_error="")
     {
      global $dbcon;
      
      $result = $dbcon->query($db_query);
      
      if ( !$result )
        {
         self::obr_error($t_error);
         return (false);
        }
      return ($result);
     }
   
   public static function query_select_assoc($db_query)
     {
      $mas=array();
      
      $q_result = self::query($db_query);
      $kolvo = $q_result->num_rows;
      if ( $kolvo > 0 )
        {
         while ($row = $q_result->fetch_assoc())
           {
            $mas[]=decodeMasOneLevel($row);
            
           }
        }
      $q_result->free();
      
      return ( array($kolvo,$mas) );
     }
   
   public static function query_select_assoc_index($db_query,$name_index,$fn_convert_row=false)
     {
      $mas=array();
      
      $q_result = self::query($db_query);
      $kolvo = $q_result->num_rows;
      if ( $kolvo > 0 )
        {
         if (!$fn_convert_row)
           {
             while ($row = $q_result->fetch_assoc())
               {
                 $row = decodeMasOneLevel($row);
                 $mas[$row[$name_index]] = $row;
               }
           }
          else
            {
              // $fn_for_row -> function
              while ($row = $q_result->fetch_assoc())
                {
                  $row = decodeMasOneLevel($row);
                  $row = $fn_convert_row($row);
                  $mas[$row[$name_index]] = $row;
                }
            }
        }
      $q_result->free();
      
      return ( array($kolvo,$mas) );
     }
   
   public static function query_select_assoc_index_group($db_query,$name_index)
     {
      $mas=array();
      
      $q_result = self::query($db_query);
      $kolvo = $q_result->num_rows;
      if ( $kolvo > 0 )
        {
         while ($row = $q_result->fetch_assoc())
           {
            $row = decodeMasOneLevel($row);
            if ( empty($mas[$row[$name_index]]) )
              $mas[$row[$name_index]] = array();
            $mas[$row[$name_index]][]=$row;
            
           }
        }
      $q_result->free();
      
      return ( array($kolvo,$mas) );
     }
   
   public static function query_select_one_assoc($db_query)
     {
      $mas=array();
      
      $q_result = self::query($db_query);
      $kolvo = $q_result->num_rows;
      if ( $kolvo > 0 )
        {
         if ($row = $q_result->fetch_assoc())
           {
            $mas=decodeMasOneLevel($row);
           }
        }
      $q_result->free();
      
      return ( array($kolvo,$mas) );
     }
   
   public static function query_count($db_query)
     {
      $q_result = self::query($db_query);
      $kolvo = 0;
      $kolvo_row = $q_result->num_rows;
      if ( $kolvo_row > 0 )
        {
         if ( $row = $q_result->fetch_row() )
           $kolvo = $row[0];
        }
      $q_result->free();
      
      return ( $kolvo );
     }
   
   public static function get_insert_id()
     {
      global $dbcon;
      $result = $dbcon->insert_id;
      
      return ($result);
     }
   
   public static function query_select_row($db_query)
     {
      $mas=array();
      
      $q_result = self::query($db_query);
      $kolvo = $q_result->num_rows;
      if ( $kolvo > 0 )
        {
         while ($row = $q_result->fetch_row())
           {
            $mas[]=decodeMasOneLevel($row);
            
           }
        }
      $q_result->free();
      
      return ( array($kolvo,$mas) );
     }
   
   public static function get_db_error()
     {
      $text_error = "Error db: ";
      global $dbcon;
      if ( $dbcon->connect_errno )
        $text_error .= $dbcon->connect_errno." ".$dbcon->connect_error;
       elseif ( $dbcon->errno )
         $text_error .= $dbcon->errno." ".$dbcon->error;
      
      return ($text_error);
     }
   
   public static function obr_error($t_error="")
     {
      $error_db = self::get_db_error();
      
      if ( !$t_error )
        {
         eng_db_error::main($error_db);//функция должна быть определена раньше
        }
       else
         {
          if ( $t_error === true )
            $t_error = $error_db;
           else
             {
              if ( mb_strpos($t_error,"{error}") !== false )
                {
                 $t_error = str_replace("{error}",$error_db,$t_error);
                }
               else
                 $t_error .= " ".$error_db;
             }
          
          eng_db_error::main($t_error);
         }
     }
   
   public static function multi_query($db_query,$t_error="")
     {
      global $dbcon;
      $result = $dbcon->multi_query($db_query);
      if ( !$result )
        {
         self::obr_error($t_error);
         return (false);
        }
      return ($result);
     }
   
   public static function result_get_count($q_result)
     {
      return($q_result->num_rows);
     }
   
   public static function result_select_assoc_num($q_result,$quantity)
     {
      $mas=array();
      
      $kolvo = $q_result->num_rows;
      if ( $kolvo > 0 )
        {
         for ( $i = 0; ($i < $quantity) && ($row = $q_result->fetch_assoc()); $i++ )
           {
            $mas[]=decodeMasOneLevel($row);
            
           }
        }
      
      return ( array(sizeof($mas),$mas) );
     }
   
   public static function result_clear($q_result)
     {
      $q_result->free();
     }
   
   public static function get_affected_rows()
     {
       global $dbcon;
       $count = $dbcon->affected_rows;
       
       return ($count);
     }
   
  }

function obr_db_query($db_query)
  {
   return (db_work::query($db_query));
  }

function obr_db_query_select_assoc($db_query)
  {
   return ( db_work::query_select_assoc($db_query) );
  }

function obr_db_query_select_assoc_index($db_query,$name_index)
  {
   return ( db_work::query_select_assoc_index($db_query,$name_index) );
  }

function obr_db_query_select_assoc_index_group($db_query,$name_index)
  {
   return ( db_work::query_select_assoc_index_group($db_query,$name_index) );
  }

function obr_db_query_select_one_assoc($db_query)
  {
   return ( db_work::query_select_one_assoc($db_query) );
  }

function obr_db_query_count($db_query)
  {
   return ( db_work::query_count($db_query) );
  }


function construct_db_query_add_nall($db_query,$name_pole_table,$value)
  {
   if ( $value != "all" )
     $db_query .= ($db_query == "" ? "": " and ")." ".$name_pole_table." = '".$value."' ";
   
   return ($db_query);
  }














