<?php


function decodeText($textCode) //заменяет в текстовой строке мнемонический код &#039; на символ ' (одинарная кавычка)
  {
   //$textCode=str_replace("&quot;",'"',$textCode);
   //$textCode=str_replace("&#92;",'\\',$textCode);
   //return (str_replace("&#039;","'",$textCode));
   return ( str_replace( array("&quot;","&#92;","&#039;"), array('"','\\',"'"), $textCode) );
  }
  
function codeText($textCode) //заменяет в текстовой строке символ ' (одинарная кавычка) на мнемонический код &#039;
  {
   //$textCode=str_replace('"',"&quot;",$textCode);
   //$textCode=str_replace('\\',"&#92;",$textCode);
   //return (str_replace("'","&#039;",$textCode));
   return ( str_replace( array('"','\\',"'"), array("&quot;","&#92;","&#039;"), $textCode));
  }


function delete_pref_text($text,$del_pref)
  {
    //функция преобразует текст: если вначале строки есть префикс $del_pref , то функция уберет его
    $len_pref=mb_strlen($del_pref);
    $text=trim($text);
    if ( mb_strpos($text,$del_pref) === 0 )
      $text=mb_substr($text,$len_pref,mb_strlen($text) - $len_pref);
    
    return($text);
  }

function begin_delete_text($delete_text,$text)
  {
   //функция удалит в начале строки текст $delete_text, если он там будет
   //$http_link="http://";
   $len_delete_text=mb_strlen($delete_text);
   $text=trim($text);
   if ( mb_strpos($text,$delete_text) === 0 )
     $text=mb_substr($text,$len_delete_text,mb_strlen($text)-$len_delete_text);
   
   return($text);
  }
  
function encode_mas_to_jointext($data_mas)
  {
   $raz="";
   $t_encode="";
   foreach ($data_mas as $one_row)
      {
       
       $t_encode.=$raz."{ ";
       $t_encode.=encode_row_mas_to_jointext($one_row);
       
       $t_encode.="}";
       $raz=" , ";
      }
   
   return ($t_encode);
  }

function encode_row_mas_to_jointext($one_row)
  {
   $t="";
   $raz1=" ";
   
   foreach ($one_row as $name_cell => $value_cell_row)
     {
      $value_cell = $value_cell_row;
      
      $is_code=true;
      if ($value_cell === true)
        {
         $value_cell = 1;
         $is_code = false;
        }
      if ($value_cell === false)
        {
         $is_code=false;
         $value_cell = 0;
        }
      if ( is_array($value_cell) )
        {
         $is_code = false;
         $value_cell = "{".encode_row_mas_to_jointext($value_cell)."}";
        }
      
      if ( $is_code )
        $value_cell = "'".RawUrlEncode($value_cell)."'";
      $t.=$raz1."'$name_cell':".$value_cell;
      $raz1=",";
     }
   
   return ($t);
  }



function encode_assoc_mas_to_jointext($data_mas)
  {
   $raz="";
   $t_encode="";
   foreach ($data_mas as $key_row => $one_row)
      {
       
       $t_encode.=$raz.'"'.$key_row.'":{ ';
       $t_encode.=encode_row_mas_to_jointext($one_row);
       
       $t_encode.="}";
       $raz=" , ";
      }
   
   return ($t_encode);
  }

function encode_gen_mas_to_jointext($data_mas,$set_simvols=true, $only_encode=false, $key_type=false, $mas_use_index=false, $check_type_v=false )
  {
   //функция преобразует в jointext массив, автоматически определяя тип ключей
   //
   // key_type если не задан, то тип будет определен автоматически, 
   // если равен assoc - то будет создан как ассоциативный
   // если равен numeric - то будет создан как с числовыми индексами
   // если равен allnumeric - то будет создан как с числовыми индексами полностью
   //
   //$mas_use_index - указывает какие использовать индексы (ключи) второго уровня заданного массива $data_mas ,
   // задается список в виде названий индексов (ключей) через запятую,
   // если нужно все использовать, то параметр должен принимать значение false
   
   
   if ( $mas_use_index )
     {
      $mas_use_index = explode(",",$mas_use_index);
     }
   
   $type_assoc = true;
   $first_cell = true;
   $value_check_key_cell = 0;
   $type_is_numeric = true;
   $type_is_all_numeric = false;
   
   $key_type_many_lvl = false;
   
   if ( !$key_type )
     {
       foreach ( $data_mas as $key_cell => $value_cell )
         {
          if ( !is_int( $key_cell ) )
            {
             $type_is_numeric = false;
             break;
            }
          if ( $first_cell )
            {
             if ($key_cell !== 0 && $key_cell !== "0")
               {
                 $type_is_numeric = false;
                 break;
               }
             
             $first_cell = false;
             $value_check_key_cell = $key_cell;
             continue;
            }
          
          if ( $key_cell - $value_check_key_cell == 1 )
            {
             $value_check_key_cell = $key_cell;
            }
           else
             {
              $type_is_numeric = false;
              break;
             }
          
         }
     }
    elseif ( $key_type == "assoc" )
      $type_is_numeric = false;
     else
       {
        if ( $key_type == "allnumeric" )
          {
           $type_is_all_numeric = true;
           $key_type_many_lvl = "allnumeric";
          }
        $type_is_numeric = true;
       }
   
   
   if ( $type_is_numeric ) $type_assoc = false;
   
   $raz="";
   $t_encode="";
   foreach ($data_mas as $key_cell => $value_cell)
      {
       /*
       $t_encode.=$raz."{ ";
       $t_encode.=encode_row_mas_to_jointext($one_row);
       
       $t_encode.="}";
       $raz=" , ";
       */
       $value = $value_cell;
       
       $is_code=true;
       
       if ( is_array($value) )
         {
          $is_code = false;
          if ( !$mas_use_index )
            {
             list($t_encode_cell_mas,$type_cell_mas) = encode_gen_mas_to_jointext($value,true,false,$key_type_many_lvl,false,$check_type_v );
             $value = $t_encode_cell_mas;//echo("*".$t_encode_cell_mas."** ");
            }
           else
             {
              $sim_start = "{";
              $sim_end = "}";
              if ( $type_is_all_numeric )
                {
                 $sim_start = "[";
                 $sim_end = "]";
                }
              
              $t_encode_v2 = $sim_start;//"{";
              $value_v2 = "";
              $raz_v2 = "";
              
              foreach ( $mas_use_index as $key_cell_v2 )
                {
                 $is_code_v2 = true;
                 $value_v2 = $value[$key_cell_v2];
                 
                 if ( is_array($value_v2) )
                   {
                    $value_v2 = encode_gen_mas_to_jointext($value, true, true,$key_type_many_lvl,false,$check_type_v );
                    $is_code_v2 = false;
                   }
                  elseif ( $value_v2 === true )
                    {
                     $value_v2 = 1;
                     $is_code_v2 = false;
                    }
                  elseif ( $value_v2 === false )
                    {
                     $value_v2 = 0;
                     $is_code_v2 = false;
                    }
                 
                 $t_encode_v2 .= $raz_v2 . (!$type_is_all_numeric ? "'".$key_cell_v2."':":"").($is_code_v2 ? (($check_type_v && !is_string($value_v2)) ? $value_v2 : "'".RawUrlEncode($value_v2)."'"): $value_v2);
                 $raz_v2 = ",";
                }
              $t_encode_v2 .= $sim_end;//"}";
              $value = $t_encode_v2;
             }
         }
        else
          if ($value === true)
             {
              $value = 1;
              $is_code = false;
             }
            else
             if ($value === false)
              {
               $is_code=false;
               $value = 0;
              }
       
       if ( $is_code )
         $value = ($check_type_v && !is_string($value)) ? $value : "'".RawUrlEncode($value)."'";
       $t_encode .= $raz.($type_assoc ? "'$key_cell':" : "").$value;
       $raz = ",";
      }
   
   if ( $set_simvols )
     {
      if ( $type_assoc )
        $t_encode = "{".$t_encode."}";
       else
         $t_encode = "[".$t_encode."]";
     }
   
   return ($only_encode ? $t_encode : array($t_encode,$type_assoc) );
  }



function _code_utf8_to_win($text)
  {
   //при кодеровке сайта utf-8 эта функция не нужна
   $text=iconv("UTF-8","windows-1251",$text);
   return ($text);
  }


function _encode_text_win_to_utf8url($text)
  {
   //при кодеровке сайта utf-8 эта функция не нужна
   $rez="";
   $rez=RawUrlEncode(iconv("windows-1251","utf-8",$text));
   
   return ($rez);
  }

function _transformer_text_win_to_utf8url($text)
  {
   //при кодеровке сайта utf-8 эта функция не нужна
   //устаревшая функция, взамен надо использовать code_text_win_to_utf8url($text)
   return (encode_text_win_to_utf8url($text));
  }


function codeHtmlText($text)
  {
   $text=htmlspecialchars($text,ENT_QUOTES);
   return ($text);
  }

function decodeHtmlText($text)
  {
   $text=str_replace(array('&amp;','&quot;','&#039;','&lt;','&gt;'),array("&",'"',"'",'<','>'),$text);
   return ($text);
  }

function _codeMasOneLevelUtf8_to_Win($mas)
  {
   foreach ( $mas as $key => $value )
     {
      if ( is_string($mas[$key]) )
        {
         $mas[$key]=code_utf8_to_win($mas[$key]);
        }
      
     }
   
   return ($mas);
  }


function decodeMasOneLevel($mas)
  {
   foreach ( $mas as $key => $value )
     {
      if ( is_string($mas[$key]) )
        {
         $mas[$key]=decodeText($mas[$key]);
        }
      
     }
   
   return ($mas);
  }


function decodeMasTwoLevel($mas)
  {
   foreach ( $mas as $key => $mas_two )
     {
      foreach ( $mas_two as $key_two => $value )
        {
          if ( is_string($mas_two[$key_two]) )
            {
             $mas[$key][$key_two]=decodeText($mas[$key][$key_two]);
            }
        }
      
     }
   
   return ($mas);
  }


function replace_perem_texthablon($text,$begin_marker,$end_marker,$mas_perem)
  {
   
   foreach ( $mas_perem as $name_perem => $value_perem )
     {
      $text = str_replace($begin_marker.$name_perem.$end_marker,$value_perem,$text);
     }
   
   return ($text);
  }


function formation_str_url_mas_param($mas_param,$first_elm = "",$end_elm = "")
  {
   $t = "";
   $sep = "";
   foreach ($mas_param as $key => $value)
     {
      $t .= $sep.$key."=".RawUrlEncode($value);
      $sep = "&";
     }
   if ( $t ) $t = $first_elm.$t.$end_elm;
   return ($t);
  }


function process_text_search($text,$min_length_word = 3,$max_length_text = 60,$add_sim = "",$addslashes = false)
  {
   // функция удаляет из строки символы, оставляет только буквы анг. и рус.
   // разбивает на слова по пробелу
   // и проверяет длину - возвращает массив слов длина которых больше или равна заданной
   
   $mas_word = array();
   $is_min = false;
   
   $text = trim($text);
   if ( $text )
     {
      $text=mb_substr($text,0,$max_length_text);
      $text=preg_replace("/[^a-zA-Z0-9а-яА-ЯёЁ\-\_".($add_sim ? addcslashes($add_sim,$add_sim):"")."]/iu"," ",$text);
      $text=trim(preg_replace("/ +/iu"," ",$text));
      if ( $addslashes )
        {
         $text = addcslashes($text,"-_".($add_sim?$add_sim:""));
        }
      $mas = explode(" ",$text);
      
      foreach ( $mas as $one_word )
        {
         if ( mb_strlen($one_word) >= $min_length_word )
           {
            $mas_word[] = $one_word;
           }
          else
            {
             $is_min = true;
            }
         
        }
      
     }
   
   return ( array($mas_word,$is_min) );
  }


function check_text_on_stop_words($text,$mas_stop_words,$type_search)
  {
   // если $type_search равно 1 - точный поиск слов
   // если равно 2 - вхождение указанного слова в проверяемых словах, то есть слово "идиот" будет будет найдено в слове "идиоты"
   $on_search = false;
   $word = "";
   
   $t=preg_replace("/[^a-zA-Z0-9а-яА-ЯёЁ]/iu"," ",$text);
   $t=mb_strtolower(trim(preg_replace("/ +/iu"," ",$t)));
   
   if ( $t )
     {
       $t = " ".$t." ";
       
       if ( !is_array($mas_stop_words) && is_string($mas_stop_words) )
         {
          $mas_stop_words = explode(",",$mas_stop_words);
         }
       
       foreach ( $mas_stop_words as $one_word )
         {
          
          $one_word = preg_replace("/[^a-zA-Z0-9а-яА-ЯёЁ]/iu","",$one_word);
          $one_word = mb_strtolower(trim($one_word));
          
          if ( $one_word )
            {
             if ( $type_search == 1 )
               {
                //if ( preg_match("/ ".$one_word." /iu",$t) )
                if ( strpos($t," ".$one_word." ") !== false )
                  {
                   $on_search = true;
                   $word = $one_word;
                   break;
                  }
               }
              else
                {
                 if ( preg_match("/ [^ ]*".$one_word."[^ ]* /iu",$t,$matches) )
                   {
                    $on_search = true;
                    $word = $matches[0];
                    break;
                   }
                }
            }
          
         }
         
     }
   
   
   return ($on_search ? $word : $on_search);
  }



function max_truncate_text($text,$max_sim,$end_sim = "...",$check_word = false)
  {
   $t = "";
   
   if ( $max_sim > 0 )
     {
      if ( mb_strlen($text) > $max_sim )
        {
         $max_length = $max_sim - mb_strlen($end_sim);
         $max_length = ( $max_length > 0 ) ? $max_length : 0;
         $t = mb_substr($text,0,$max_length);
         if ( $check_word && mb_substr($text,$max_length, 1) != " " )
           {
            $pos = $max_length-1;
            while ( mb_substr($t,$pos,1) != " " && $pos >= 0 )
              {
               $pos--;
              }
            
            if ( $pos >= 0 && $pos < $max_length )
              $t = mb_substr($t,0,$pos);
           }
         
         $t .= $end_sim;
         
         if ( mb_strlen($t) > $max_sim )
           $t = mb_substr($t,0,$max_sim);
         
        }
       else
         $t = $text;
      
     }
   
   return ( $t );
  }




function compres_text_middle($t,$kolvo_max,$compres_sim = "...")
  {
   if ( mb_strlen( $t ) > $kolvo_max )
     {
      if ( $kolvo_max > mb_strlen($compres_sim) )
        {
         $length_str = mb_strlen($t);
         $length_new_c = $kolvo_max - mb_strlen( $compres_sim );
         $part1 = ceil( $length_new_c / 2 );
         $part2 = $length_new_c - $part1;
         
         $t1 = mb_substr($t,0,$part1);
         $t2 = mb_substr($t,$length_str-$part2,$part2);
         $t = $t1.$compres_sim.$t2;
        }
       else
         {
          $t = mb_substr($t,0,$kolvo_max);
         }
      
     }
   
   return ($t);
  }


function replace_one_str_end($str,$s_end="\n")
  {
   return ( str_replace(array("\r\n","\n\r","\r","\n"),$s_end,$str) );
  }


function check_protocol_url($url,$mas_check_protocol=array("http://","https://"),$default_protocol="http://")
  {
   $url_small = mb_strtolower($url);
   $mas_data = array( $default_protocol.$url, $url, $default_protocol );
   foreach ( $mas_check_protocol as $one_protocol )
     {
      if ( mb_strpos($url_small,$one_protocol) === 0 )
        {
         $protocol_length = mb_strlen($one_protocol);
         $adr = mb_substr($url,$protocol_length,mb_strlen($url)-$protocol_length);
         $mas_data = array( $one_protocol.$adr, $adr, $one_protocol );
         break;
        }
     }
   
   return ($mas_data);
  }


class conversion_text
  {
   public static $stop_words_strict = "а,без,более,бы,был,была,были,было,быть,в,вам,вас,весь,во,вот,все,всего,всех,вы,где,да,даже,для,до,его,ее,если,есть,ещё,же,за,здесь,и,из,из-за,или,им,их,к,как,как-то,ко,когда,кто,ли,либо,мне,может,мы,на,надо,наш,не,него,неё,нет,ни,них,но,ну,о,об,однако,он,она,они,оно,от,очень,по,под,при,с,со,так,также,такой,там,те,тем,то,того,тоже,той,только,том,ты,у,уже,хотя,чего,чей,чем,что,чтобы,чьё,чья,эта,эти,это,а,б,в,г,д,е,ё,ж,з,и,й,к,л,м,н,о,п,р,с,т,у,ф,х,ц,ч,ш,щ,ъ,ы,ь,э,ю,я";
   
   public static $stop_words_match = "продам,продаю,продаж,куплю,сдам,сниму,продает,покупает";
   
   public static function create_hash($text)
     {
      $v_hash = "";
      
      $v_hash = md5(self::canonize_text($text));
      
      return ($v_hash);
     }
   
   public static function canonize_text($text)
     {
      $text = mb_strtolower($text);
      $text = preg_replace("/[^a-zA-ZА-ЯёЁ]/iu"," ",$text);
      $text = " ".$text." ";
      
      $mas_stop_words_strict = explode(",",self::$stop_words_strict);
      if ( sizeof($mas_stop_words_strict) > 0 )
        {
         $mas_pattern_strict = array();
         
         foreach ($mas_stop_words_strict as $one_word)
           {
            $mas_pattern_strict[]="/ ".$one_word." /iu";
           }
         
         $text = preg_replace($mas_pattern_strict," ",$text);
         
        }
      
      $mas_stop_words_match = explode(",",self::$stop_words_match);
      if ( sizeof($mas_stop_words_match) > 0 )
        {
         $mas_pattern_match = array();
         
         foreach ($mas_stop_words_match as $one_word)
           {
            $mas_pattern_match[]="/ [^ ]*".$one_word."[^ ]* /iu";
           }
         
         $text = preg_replace($mas_pattern_match," ",$text);
         
        }
      
      $text = preg_replace("/[\s]{2,}/"," ",$text);
      $text = trim($text);
      
      return ($text);
     }
   
  }


function getEndingNum($number,$masEnding)
  {
   // $number - число
   // $masEnding - массив слов или окончаний, к примеру, array("день","дня","дней")
   $t="";
   $check_num=$number % 100;
   
   if ($check_num >= 11 && $check_num <= 19)
     {
      $t=$masEnding[2];
     }
    else
      {
       $check_num=$check_num % 10;
       switch ($check_num)
         {
          case (1): $t=$masEnding[0];break;
          case (2):
          case (3):
          case (4): $t=$masEnding[1];break;
          default: $t=$masEnding[2];
         }
       
      }
   
   return ($t);
  }

