<?php

/*
Версия v5
14.01.2022 г. - добавлена поддержка шаблона
*/

function send_email($subject,$message,$name_recipient,$email_recipient,$reply_email=false,$reply_name=false, $files=false, $mas2files=false, $on_template=false)
  {
   $on_send=false;
   
   if ( ON_SMTP_EMAIL_SITE )
     {
      
      $on_send=send_mail::send_smtp($subject,$message,$name_recipient,$email_recipient,$reply_email,$reply_name,$files,$mas2files,$on_template);
      
     }
    else
      {
       //отправляем письмо функцией php mail()
       
       $on_send=send_mail::send($subject,$message,$name_recipient,$email_recipient,$reply_email,$reply_name,$files,$mas2files,$on_template);
       
      }
   
   return ($on_send);
  }




class send_mail
  {
   
   static private $obj_con_mserv=false;
   
   function __construct()
     {
      
     }
   
   static public function send($subject,$message,$name_recipient,$email_recipient,$reply_email=false,$reply_name=false,$files=false,$mas2files=false,$on_template=false)
     {
      list($email_encode,$subject_encode,$message,$headers)=self::forming_data_mail(false,$subject,$message,$name_recipient,$email_recipient,$reply_email,$reply_name,$files,$mas2files,$on_template);
      $on_send=mail($email_encode,$subject_encode,$message,$headers);
      
      return ($on_send);
     }
   
   static public function send_smtp($subject,$message,$name_recipient,$email_recipient,$reply_email=false,$reply_name=false,$files=false,$mas2files=false,$on_template=false)
     {
      $on_send=false;
      
      self::init_obj_con_mserv();
      
      list($email_encode,$subject_encode,$message,$headers)=self::forming_data_mail(true,$subject,$message,$name_recipient,$email_recipient,$reply_email,$reply_name,$files,$mas2files,$on_template);
      
      $error=0;
      $error_text="";
      list($error,$error_text)=self::$obj_con_mserv->openLinkServ();
      //self::$obj_con_mserv->set_check_answer_code(false);
      
      if ($error==0) list($error,$error_text)=self::$obj_con_mserv->sendLinkServ($email_recipient,$headers,$message);
      self::$obj_con_mserv->closeLinkServ();
      
      if ($error==0) $on_send=true;
      
      return ($on_send);
     }
   
   static public function init_obj_con_mserv()
     {
      
      if (!self::$obj_con_mserv)
        {
         //-------
         //данные для авторизации на почтовом сервере
         //-------
         $server=SERVER_EMAIL_ADMIN;
         $domen_server=DOMEN_SERVER_EMAIL_ADMIN;
         $port=EMAIL_PORT_ADMIN;
         
         $login_email=EMAIL_ADMIN;
         $passw_email=EMAIL_PASSW_ADMIN;
         $from_email=EMAIL_ADMIN;
         $from_name=NAME_EMAIL_ADMIN;
         
         self::$obj_con_mserv=new connect_mserv();
         
         self::$obj_con_mserv->setup($server,$domen_server,$port,$login_email,$passw_email,$from_email,$from_name);
        }
      
      return (true);
     }
   
   static public function forming_data_mail($on_smtp,$subject,$message,$name_recipient,$email_recipient,$reply_email=false,$reply_name=false,$files=false,$mas2files=false,$on_template=false)
     {
      //функция вернет mime-email, mime-заголовок, текст (код) сообщения и заголовки
      $email_encode="";
      $subject_encode="";
      //$message="";
      $headers="";
      
      $multipart=false;
      $boundary="";
      
      if ( ($files && is_array($files) && sizeof($files)>0) || ($mas2files && is_array($mas2files) && sizeof($mas2files)>0) )
        {
         $multipart = true;
         $boundary = "------------".strtoupper( md5( uniqid(time()) ) );//"unique_identification";
        }
      
      $subject_encode=self::mime_header_encode($subject);
      $email_encode=( $name_recipient ? self::mime_header_encode($name_recipient) : "" )."<".$email_recipient.">";
      
      $headers.="From: ".self::mime_header_encode(NAME_EMAIL_ADMIN)." <".EMAIL_ADMIN.">\r\n";
      
      if ($on_smtp)
        {
         $headers.="To: ".( $name_recipient ? self::mime_header_encode($name_recipient) : "" )."<".$email_recipient.">\r\n";//smtp
         $headers.="Subject: ".self::mime_header_encode($subject)."\r\n";//smtp
         
         //$headers.="Date: ".date("D, j M Y G:i:s",$GLOBALS["timeGlobal"])." +0300\r\n";//smtp
         $headers.="Date: ".date("D, d M Y H:i:s O",$GLOBALS["timeGlobal"])."\r\n";//smtp
        }
      
      
      
      $headers.="Reply-To: "
       .($reply_email ? ( $reply_name ? self::mime_header_encode($reply_name)." " : "" ). "<".$reply_email.">"
       : self::mime_header_encode(NAME_EMAIL_ADMIN)." <".EMAIL_ADMIN.">")
       ."\r\n";
      
      $headers.="X-Mailer: PHP\r\n";
      /*
      $message = "<html>\r\n"
       ."<head>\r\n"
       .'<meta http-equiv="content-type" content="text/html; charset=UTF-8">'."\r\n"
       .'<title>'.codeHtmlText($subject).'</title>'."\r\n"
       ."</head>\r\n"
       ."<body>\r\n"
       .$message
       ."\r\n</body>\r\n</html>\r\n";
      */
      $message=self::forming_hcode_message($subject,$message,$on_template);
      
      if ($multipart)
        {
         $headers .= 'MIME-Version: 1.0'."\r\n";
         $headers .= 'Content-Type: multipart/mixed; boundary="'.$boundary.'"'."\r\n";// alternative или mixed или related
         $headers .= 'Content-Transfer-Encoding: 7bit'."\r\n";
         
         $text_message = $message;
         
         $message = "";
         $message .= "--".$boundary."\r\n";
         $message .= 'Content-Type: text/html; charset=utf-8'."\r\n";
         $message .= "Content-Transfer-Encoding: 8bit\r\n";
         $message .= "\r\n";
         
         $message .= $text_message;
         
         $text_message = "";
         
         if ( $files && is_array($files) && sizeof($files)>0 )
           foreach ( $files as $one_file )
             {
              $t_file = self::forming_mime_data_file($one_file,$boundary);
              if ( $t_file )
                $message .= $t_file;
             }
         
         if ( $mas2files && is_array($mas2files) && sizeof($mas2files) )
           foreach ( $mas2files as $one_mas2file )
             {
              $t_file = self::forming_mime_data_mas2file($one_mas2file, $boundary);
              if ( $t_file )
                $message .= $t_file;
             }
         
         
         $message .= "\r\n"."--".$boundary."--\r\n";
        }
       else
         {
          $headers.='Content-Type: text/html; charset=utf-8'."\r\n";
          $headers.="Content-Transfer-Encoding: 8bit\r\n";
         }
      
      return (array($email_encode,$subject_encode,$message,$headers));
     }
   
   static public function mime_header_encode($str)
     {
      
      return ("=?utf-8?B?".base64_encode($str)."?=");
     }
   
   static public function forming_mime_data_file($data_file, $boundary)
     {
      $text = false;
      
      $content_id = false;
      if ( $data_file && is_array($data_file) )
        {
         $one_file = $data_file[0];
         if ( !empty($data_file[1]) )
           $content_id = $data_file[1];
         
        }
       else
         $one_file = $data_file;
      
      $d_file = fopen($one_file, "rb");
      
      if ( $d_file )
        {
         if ( ( $contents_file = fread($d_file, filesize($one_file)) ) !== false )
           {
            
            $name_file = basename($one_file);
            $text = "";
            $text .= "\r\n\r\n--".$boundary."\r\n";
            $text .= 'Content-Type: application/octet-stream; name="'.$name_file.'"'."\r\n";//application/octet-stream
            
            $text .= "Content-Transfer-Encoding: base64\r\n";
            
            if ( $content_id )
              $text .= 'Content-ID:<'.$content_id.">\r\n";
            
            $text .= 'Content-Disposition: attachment; filename="'.$name_file.'"'."\r\n";//attachment или inline
            
            $text .= "\r\n";
            $text .= chunk_split(base64_encode($contents_file))."\r\n";
            
           }
         
         fclose($d_file);
         
        }
      
      return ($text);
     }
   
   static public function forming_mime_data_mas2file($one_mas2file, $boundary)
     {
      $text = false;
      
      $content_id = false;
      $name_file = $one_mas2file[0];
      if ( !empty( $one_mas2file[2] ) )
        $content_id = $one_mas2file[2];
      
      $contents_file = $one_mas2file[1];
      
      //$name_file = basename( $one_file );
      $text = "";
      $text .= "\r\n\r\n--".$boundary."\r\n";
      $text .= 'Content-Type: application/octet-stream; name="'.$name_file.'"'."\r\n";// application/octet-stream
      
      $text .= "Content-Transfer-Encoding: base64\r\n";
      
      if ( $content_id )
        $text .= 'Content-ID:<'.$content_id.">\r\n";
      
      $text .= 'Content-Disposition: attachment; filename="'.$name_file.'"'."\r\n";// attachment или inline
      
      $text .= "\r\n";
      $text .= chunk_split(base64_encode($contents_file))."\r\n";
      
      return ($text);
     }
   
   
   static public function send_list_mails($one_msender,$data_contacts)
     {
      //отправляем письма нескольким пользователям (рассылка)
      global $url_http,$masConfig;
      
      $on_smtp=ON_SMTP_EMAIL_SITE;
      
      $on_template=true;
      
      $mas_id_send=array();
      $mas_id_error=array();
      
      $on_send=false;
      //$on_error=false;
      $error=0;
      $error_text="";
      
      if ($on_smtp)
        {
         self::init_obj_con_mserv();
         list($error,$error_text)=self::$obj_con_mserv->openLinkServ();
        }
      
      if ($error == 0)
        {
          foreach ($data_contacts as $one_contact)
            {
              //id_contact,name,email,perem
              $on_send = false;
              //$error=0;
              //$error_text="";
              
              $data_perem = array();
              $data_perem["name_user"] = $one_contact["name"];
              $data_perem["email_user"] = $one_contact["email"];
              $data_perem["url_site"] = $url_http;
              $data_perem["name_site"] = $masConfig["NAME_SITE"];
              
              if ($one_contact["perem"])
                {
                  $c_perem = unserialize($one_contact["perem"]);
                  $data_perem = array_merge($data_perem, $c_perem);
                }
              
              $message = replace_perem_texthablon($one_msender["message"], "{:", ":}", $data_perem);
              
              if ($on_smtp)
                {
                  list($email_encode, $subject_encode, $message, $headers) = self::forming_data_mail(true, $one_msender["title"], $message, $one_contact["name"], $one_contact["email"],false,false,false,false,$on_template);
                  list($error, $error_text) = self::$obj_con_mserv->sendLinkServ($one_contact["email"], $headers, $message);
                  if ($error == 0) $on_send = true;
                }
               else
                 {
                   $on_send = self::send($one_msender["title"], $message, $one_contact["name"], $one_contact["email"],false,false,false,false,$on_template);
                   if (!$on_send)
                     {
                       $error=1;
                       $error_text="Ошибка при отправке письма функцией mail()";
                     }
                 }
              
              if ($on_send)
                $mas_id_send[] = $one_contact["id_contact"];
               else
                 $mas_id_error[] = $one_contact["id_contact"];
              
              if ($error != 0) break;//при ошибке отправки писма, выходим из цикла
            }
        }
      
      if ($on_smtp)
        {
         self::$obj_con_mserv->closeLinkServ();
        }
      
      return (array($error,$error_text,$mas_id_send,$mas_id_error));
     }
   
   static protected function forming_hcode_message($subject,$message,$on_template=false)
     {
       $hcode="";
       
       if (!$on_template)
         {
           $hcode = "<html>\r\n"
            ."<head>\r\n"
            .'<meta http-equiv="content-type" content="text/html; charset=UTF-8">'."\r\n"
            .'<title>'.codeHtmlText($subject).'</title>'."\r\n"
            ."</head>\r\n"
            ."<body>\r\n"
            .$message
            ."\r\n</body>\r\n</html>\r\n";
         }
        else
          {
            $hcode=self::forming_template_message($subject,$message);
          }
       
       return ($hcode);
     }
   
   static protected function forming_template_message($subject,$message)
     {
       global $masConfig;
       $hcode = ''
         .'<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">'
         ."<html>\r\n"
         ."<head>\r\n"
         .'<meta http-equiv="content-type" content="text/html; charset=UTF-8">'."\r\n"
         .'<title>'.codeHtmlText($subject).'</title>'."\r\n"
         ."</head>\r\n"
         ."<body bgcolor='#cffdfc' style='font-family: Verdana, Geneva, sans-serif; font-size: 14px; background: #cffdfc;'>\r\n"
         .'<table border="0" cellpadding="0" cellspacing="0" bgcolor="#cffdfc" width="100%" style="margin:0; padding:0; font-family: Verdana, Geneva, sans-serif; font-size: 14px;">'
         .'<tr>'
         .'<td align="center" style="padding: 30px;" height="100%">'
          
          .'<center style="max-width: 600px; width: 100%;">'
           
           //Таблица для формирования структуры блоков письма
           .'<table border="0" cellpadding="0" cellspacing="0" width="100%" style="margin:0; padding:0; font-family: Verdana, Geneva, sans-serif; font-size: 14px;">'
           .'<tr><td>';
           
           if ( $masConfig["EMAIL_SITE_TEMPL_HEADER_NAME"] )
           {
           $hcode.=''
           
           //Заголовок шаблона письма (с названием сайта)
           .'<table border="0" cellpadding="0" cellspacing="0" width="100%" style="margin:0; padding:0; font-family: \'Arial Black\', Gadget, sans-serif; font-size: 18px; color: #343844;">'
           .'<tr><td style="padding: 0px 20px 20px 20px;" style="font-family: \'Arial Black\', Gadget, sans-serif; font-size: 18px; color: #343844;">'
           .$masConfig["EMAIL_SITE_TEMPL_HEADER_NAME"]
           .'</td></tr>'
           .'</table>';
           }
           
           $hcode.=''
           
           //Таблица с содержимым письма
           .'<table border="0" cellpadding="0" cellspacing="0" bgcolor="#ffffff" width="100%" style="margin:0; padding:0; border: solid 1px #86d5d3; font-family: Verdana, Geneva, sans-serif; font-size: 14px;">'
           .'<tr>'
           .'<td style="padding: 20px;" style="font-family: Verdana, Geneva, sans-serif; font-size: 14px;">'
             //Содержимое письма
             .$message
             
           .'</td>'
           .'</tr>'
           .'</table>'
           
           //Текст об автоматическом формировании письма
           .'<table border="0" cellpadding="0" cellspacing="0" width="100%" style="margin:0; padding:0; font-family: Verdana, Geneva, sans-serif; font-size: 12px;">'
           //Отступ от основного блока (таблицы) письма, сделанный строкой таблицы
           .'<tr><td style="padding: 10px;"></td></tr>'
           .'<tr>'
           .'<td style="padding: 20px;" style="font-family: Verdana, Geneva, sans-serif; font-size: 12px; color: #555555;" align="center">'
             .'<center style="width: 100%;">'
             ."Это письмо сформировано автоматически. Отвечать на это письмо не нужно."
             .'</center>'
           .'</td>'
           .'</tr>'
           .'</table>'
           
           .'</td></tr>'
           .'</table>'
           
          .'</center>'
         
         .'</td>'
         .'</tr>'
         .'</table>'
         ."\r\n</body>\r\n</html>\r\n";
       
       return ($hcode);
     }
   
  }




class connect_mserv
  {
   
   private $server="";
   private $domen_server="";
   private $port=25;
   private $login_email="";
   private $passw_email="";
   private $from_email="";
   private $from_text="";
   private $email="";
   private $subject="";
   private $message="";
   private $headers="";
   
   private $text_answer="";
   
   private $timeout=30;
   
   private $smtp_conn=0;
   private $errno=0;
   private $errstr="";
   
   private $check_answer_code = false;
   
   function __construct()
     {
      
     }
   
   public function set_check_answer_code($value = true)
     {
      $this->check_answer_code = $value;
     }
   
   public function setup($server,$domen_server,$port,$login_email,$passw_email,$from_email,$from_text)
     {
      $this->server=$server;
      $this->domen_server=$domen_server;
      $this->port=$port;
      $this->login_email=$login_email;
      $this->passw_email=$passw_email;
      $this->from_email=$from_email;
      $this->from_text=$from_text;
     }
   
   private function connect()
     {
      //$this->smtp_conn = fsockopen($this->server, $this->port ,$this->errno, $this->errstr, $this->timeout);
      
      $contextOpts=array(
        "ssl"=>array(
         'verify_peer' => false,
         'verify_peer_name' => false
        )
       );
      $context=stream_context_create($contextOpts);
      
      $this->smtp_conn = stream_socket_client($this->server .":".$this->port,$this->errno,$this->errstr,$this->timeout,STREAM_CLIENT_CONNECT,$context);
      
      if (!$this->smtp_conn) return (false);
      
      if (!$this->get_data(220))
        {
         $this->close_conn();
         return (false);
        }
      
      return (true);
     }
   
   private function close_conn()
     {
      fclose($this->smtp_conn);
     }
   
   private function query_ehlo()
     {
      
      $this->query_data_to_server("EHLO ".$this->domen_server."\r\n");
      if (!$this->get_data(250))
        {
         $this->close_conn();
         return (false);
        }
      
      return (true);
     }
   
   private function query_quit()
     {
      
      $this->query_data_to_server("QUIT\r\n");//завершаем работу с сервером
      if (!$this->get_data(221))
        {
         $this->close_conn();
         return (false);
        }
      
      return (true);
     }
   
   private function query_auth()
     {
      
      $kod_login_email=base64_encode($this->login_email);
      $kod_passw_email=base64_encode($this->passw_email);
      
      
      $this->query_data_to_server("AUTH LOGIN\r\n");
      if (!$this->get_data(334))
        {
         $this->close_conn();
         return (false);
        }
       
      
      $this->query_data_to_server("$kod_login_email\r\n");
      if (!$this->get_data(334))
        {
         $this->close_conn();
         return (false);
        }
       
      
      $this->query_data_to_server("$kod_passw_email\r\n");
      if (!$this->get_data(235))
        {
         $this->close_conn();
         return (false);
        }
      
      return (true);
     }
   
   private function query_mail_from()
     {
      
      $this->query_data_to_server("MAIL FROM:<".$this->from_email.">\r\n");
      if (!$this->get_data(250))
        {
         $this->close_conn();
         return (false);
        }
      return (true);
     }
   
   private function query_rcpt_to_email($email)
     {
      
      $this->query_data_to_server("RCPT TO:<".$email.">\r\n");
      if (!$this->get_data(250))
        {
         $this->close_conn();
         return (false);
        }
      return (true);
     }
   
   private function query_start_data()
     {
      
      $this->query_data_to_server("DATA\r\n");
      if (!$this->get_data(354))
        {
         $this->close_conn();
         return (false);
        }
      return (true);
     }
   
   private function query_write_data($headers,$message)
     {
      
      $this->query_data_to_server($headers."\r\n".$message."\r\n.\r\n","текст письма");
      if (!$this->get_data(250))
        {
         $this->close_conn();
         return (false);
        }
      return (true);
     }
   
   private function query_data_to_server($query,$type = false)
     {
      fwrite($this->smtp_conn,$query);
      
      //$this->text_answer.="Q >". ( $type ? "--/".$type."/--" : $query ) ."<br>";
     }
   
   private function get_data($on_kode)
     {
      
      $data="";
      $answer=true;
      
      while ($str = fgets($this->smtp_conn,515))
        {
         $data .= $str;
         
         if ( $this->check_answer_code )
           {
            if (substr($str,0,3)==$on_kode)
               $answer=true;
              else
                $answer=false;
           }
         
         if ( substr($str,3,1) == " " )
           {
            break;
           }
        }
      
      //$this->text_answer.="A >".$data."<br>";
      
      return ($answer);
     }
   
   public function openLinkServ()
     {
      
      $error = 0;$error_text = "";
      if ( !$this->connect() ) return (array(1,"Произошла ошибка при соединении к серверу электронной почты!"));
      if ( !$this->query_ehlo() ) return (array(1,"Произошла ошибка при подключению к серверу электронной почты!"));
      if ( !$this->query_auth() ) return (array(1,"Произошла ошибка при авторизации на сервере электронной почты!"));
      //if ( !$this->query_mail_from() ) return (array(1,"Произошла ошибка при определении email отправителя!"));
      
      return (array($error,$error_text));
     }
   
   public function closeLinkServ()
     {
      $this->query_quit();
      $this->close_conn();
      
      return (true);
     }
   
   public function sendLinkServ($email_recipient,$headers,$message)
     {
      if ( !$this->query_mail_from() ) return (array(1,"Произошла ошибка при определении email отправителя!"));
      if ( !$this->query_rcpt_to_email($email_recipient) ) return (array(1,"Произошла ошибка при определении email получателя!"));
      if ( !$this->query_start_data() ) return (array(1,"Произошла ошибка при инициализации передачи данных письма!"));
      if ( !$this->query_write_data($headers,$message) ) return (array(1,"Произошла ошибка при передаче данных письма!"));
      
      return (array(0,"no"));
     }
   
   public function write_text_answer()
     {
      return ($this->text_answer);
     }
   
  }


