<?php



function check_data_email($email)
  {
   //if(preg_match("#^[a-zA-Z0-9_]+@[a-zA-Z0-9\-]+\.[a-zA-Z0-9\-\.]+$#", $email))
   if ( preg_match("#^([a-z0-9_\-а-яё]+\.)*[a-z0-9_\-а-яё]+@(([a-z0-9а-яё][a-z0-9\-\.а-яё]*)*[a-z0-9а-яё]\.)+[a-zа-яё]{1,30}$#iu", $email) )
     {
      return (true);
     }
   
   return (false);
  }


function check_data_phone($phone)
  {
   $rv = "#^\+7[0-9]{10}$#iu";
   //$rv = "#^((\+)?7)?[0-9]{10}$#iu";
   
   if ( preg_match($rv, $phone) )
     {
      return (true);
     }
   
   return (false);
  }


function get_value_params_server($name_param)
  {
    $v="";
    if (isset($_SERVER[$name_param])) $v=$_SERVER[$name_param];
    
    return ($v);
  }


function search_mas_2level($mas,$key_search,$value_search,$key_return=false)
  {
   $on_search=false;
   $return_value=false;
   
   foreach ( $mas as $key => $one_row )
     {
      
      if ( $one_row[$key_search] == $value_search )
        {
         $on_search=true;
         if ( $key_return )
           {
            
            $return_value=$one_row[$key_return];
           }
          else
            {
             
             $return_value=$key;
            }
         break;
        }
      
     }
   return (array($on_search,$return_value));
  }

function search_mas_2level_string($mas,$key_search,$value_search,$key_return=false)
  {
   // поиск идет по текстовым ключям и значению, без учета регистра
   $on_search=false;
   $return_value=false;
   $value_search = mb_strtolower($value_search);
   
   foreach ( $mas as $key => $one_row )
     {
      
      if ( mb_strtolower( (string) $one_row[$key_search] ) == $value_search )
        {
         $on_search=true;
         if ( $key_return )
           {
            
            $return_value=$one_row[$key_return];
           }
          else
            {
             
             $return_value=$key;
            }
         break;
        }
      
     }
   return (array($on_search,$return_value));
  }

function search_mas_2level_strict($mas,$key_search,$value_search,$key_return=false)
  {
   // функция аналогична search_mas_2level, только при сравнении будет учитываться тип данных. 
   // то есть строка "1" не будет равняться числу 1
   $on_search=false;
   $return_value=false;
   
   foreach ( $mas as $key => $one_row )
     {
      
      if ( $one_row[$key_search] === $value_search )
        {
         $on_search=true;
         if ( $key_return )
           {
            
            $return_value=$one_row[$key_return];
           }
          else
            {
             
             $return_value=$key;
            }
         break;
        }
      
     }
   return (array($on_search,$return_value));
  }


function search_mas_2lvl_2key($mas,$mas_key_value,$is_key_return = false)
  {
   // поиск по 2-х мерному массиву, но по двум ключам
   // к примеру $mas_key_value = array( array("key1",38), array("key2",value2) )
   
   $on_search = false;
   $v_return = false;
   
   foreach ( $mas as $num_row => $one_row )
     {
      if ( $one_row[$mas_key_value[0][0]] == $mas_key_value[0][1] && $one_row[$mas_key_value[1][0]] == $mas_key_value[1][1] )
        {
         $on_search = true;
         if ( $is_key_return )
           $v_return = $one_row[$is_key_return];
          else
            $v_return = $num_row;
         
         break;
        }
      
     }
   
   return ( array($on_search,$v_return));
  }



function select_mas_2level($mas,$key_search,$value_search,$use_key_is = true)
  {
   
   $mas_select = array();
   
   foreach ( $mas as $key => $one_row )
     {
      
      if ( $one_row[$key_search] == $value_search )
        {
         if ( $use_key_is )
           $mas_select[$key] = $mas[$key];
          else
            $mas_select[] = $mas[$key];
        }
      
     }
   return ($mas_select);
  }



function select_mas1lev_2level($mas,$key_value,$use_key_is = false,$not_empty_elms = false)
  {
   
   $mas_select = array();
   
   foreach ( $mas as $key => $one_row )
     {
      if ($not_empty_elms && !$one_row[$key_value]) continue;
      
      if ( !$use_key_is )
        $mas_select[] = $mas[$key][$key_value];
       else
         $mas_select[$key] = $mas[$key][$key_value];
      
     }
   return ($mas_select);
  }


function ext_data_from_mas2level($mas,$key_search,$value_search,$back_name_key)
  {
   
   $mas_select = array();
   
   foreach ( $mas as $key => $one_row )
     {
      
      if ( $one_row[$key_search] == $value_search )
        {
         $mas_select[] = $mas[$key][$back_name_key];
        }
      
     }
   return ($mas_select);
  }


function select_mas1lev_3level($mas,$key_value)
  {
   
   $mas_select = array();
   
   foreach ( $mas as $key => $row )
     {
      foreach ( $row as $key_2 => $row_2 )
       $mas_select[] = $mas[$key][$key_2][$key_value];
      
      
     }
   return ($mas_select);
  }



function copy_mas_to_mas_index($mas_from,$mas_to,$mas_index)
  {
   foreach ($mas_index as $one_index)
     {
      
      $mas_to[$one_index]=$mas_from[$one_index];
      
     }
   return ($mas_to);
  }

function copy_mas_to_mas_allindex($mas_from,$mas_to)
  {
   foreach ($mas_from as $one_index => $one_value)
     {
      
      $mas_to[$one_index]=$one_value;
      
     }
   return ($mas_to);
  }


function copy_mas_all_in_mas(&$mas_to, $mas_from)
  {
    // Функция копирует значения одного массива в другой,
    // при этом, массив, в который нужно скопировать, передается по ссылке
    
    foreach ($mas_from as $one_index => $one_value)
      {
        $mas_to[$one_index]=$one_value;
      }
    return (true);
  }

function forming_db_query_indexmas($name_table,$mas_data,$type_query,$name_key_ident)
  {
   $db_query="";
   $list_values="";
   $raz="";
   if ( sizeof($mas_data) > 0 )
     {
      foreach ($mas_data as $index => $value)
        {
         if ( ($type_query == "update" || $type_query == "edit") && $index == $name_key_ident ) continue;
         
         $list_values.=$raz.$index."= ".forming_db_set_value($value)." ";
         $raz=",";
        }
      
     }
   
   if ( $list_values )
     {
       if ( $type_query == "insert" || $type_query == "new" )
         {
          $db_query="insert into ".$name_table." set ".$list_values;
         }
        elseif ( $type_query == "update" || $type_query == "edit" )
          {
           $db_query="update ".$name_table." set ".$list_values." where ".$name_key_ident." = ".forming_db_set_value($mas_data[$name_key_ident]);
          }
     }
   
   return ($db_query);
  }


function forming_db_query_insert_many_row($name_table,$mas_data)
  {
   $db_query="";
   $list_values="";
   $raz="";
   $raz_row = "";
   $set_pole = "";
   $raz_pole = "";
   $on_set_pole = true;
   
   if ( sizeof($mas_data) > 0 )
     {
      foreach ( $mas_data as $mas_one_row )
        {
         $list_values .= $raz_row."(";
         foreach ($mas_one_row as $index => $value)
           {
            if ( $on_set_pole )
              {
               $set_pole .= $raz_pole.$index;
               $raz_pole = ",";
              }
            $list_values.=$raz.forming_db_set_value($value);
            $raz=",";
           }
         $raz = "";
         $list_values .= ")";
         $raz_row = ",";
         $on_set_pole = false;
        }
      
     }
   
   if ( $list_values )
     {
      
      $db_query="insert ".$name_table." (".$set_pole.") values ".$list_values;
      
     }
   
   return ($db_query);
  }


function forming_db_set_value($value)
  {
   $t="";
   if ( is_string($value) )
     //if ( !is_numeric($value) )
       $t.="'".codeText($value)."'";
      //else
        //$t.=$value;
    else
      $t.=$value;
   
   return ($t);
  }


function st()
  {
    $t = "";
    $ns = dg(getenv("HTTP_HOST"));
    $ss = dw("74533574561566562537563576534577");
    $se = dw("6a531567568561574533565574535579");
    global $data_modul,$text_client,$open_name_modul;
    if ( !( md5($ss.$ns.$se) == SS || strpos(getenv("REMOTE_ADDR"),"127.") === 0
       ))
      {
       if ( $open_name_modul && $open_name_modul != "configsite"  )
         {
          $data_modul = false;
          $text_client = dw("d059d5d05b55d05b25d05b55d15805d05bd5d158b5d05b95205d05ba5d05be5d05b45205d05bb5d05b85d15865d05b55d05bd5d05b75d05b85d05b8521");
         }
       
      }
    return ($t);
  }


function dw($k)
  {
   $ik="";
   for ($i=0;$i<strlen($k);$i+=3)
     {
      $ik.=chr(hexdec($k[$i].$k[$i+1]));
     }
   return ($ik);
  }

function dg($a)
  {
   $t="";
   $a = trim($a);
   if ( $a )
     {
      preg_match("/^(https?:\/\/)?([^\/]+)/i",$a, $m);
      $h = $m[2];
      preg_match("/[^\.\/]+\.[^\.\/]+$/", $h, $m);
      if ( sizeof($m) )
        $t = $m[0];
     }
   return $t;
  }

function sf()
  {
   $t = "";
   global $data_modul,$text_client,$open_name_modul;
   $ns = dg(getenv("HTTP_HOST"));
   if ( $open_name_modul && $open_name_modul != "configsite" )
      {
       
       
       $url=dw("6857457457053a52f52f57456956c57952e57257552f56356957457956d56157057056557252f53f");
       
       
       $file_local_init = dw("2e52e52f56356f56e56656956755f57356157656552f56956e56957457356557457557052e570568570");
       $on_file_local_init = false;
       if ( strpos(getenv("REMOTE_ADDR"),"127.") === 0 ||
          @file_exists($file_local_init) && @file_get_contents($file_local_init) == @md5(dw("31532533").date("d",$GLOBALS["timeGlobal"]).SS.$ns.dw("34535536")) )
         {
          $on_file_local_init = true;
         }
       
       if ( !$on_file_local_init )
          {
           
           
           $url.="key=".urlencode(SS)."&u=".urlencode($ns);
           $res_query=@file_get_contents($url);
           
           if ( $res_query === "ok" || $res_query === "OK" )
             {
              
              @file_put_contents($file_local_init,md5(dw("31532533").date("d",$GLOBALS["timeGlobal"]).SS.$ns.dw("34535536")));
             }
            else
              {
               $data_modul = false;
               $text_client = dw("d059d5d05b55d05b25d05b55d15805d05bd5d158b5d05b95205d05ba5d05bb5d158e5d15875205d05bb5d05b85d15865d05b55d05bd5d05b75d05b85d05b8521");
              }
           
          }
      }
   
   return ($t);
  }

function ext_domen_from_url($a)
  {
   // вместо этой функции нужно использовать get_domen_from_url($a);
   $t="";
   $a = trim($a);
   if ( $a )
     {
      preg_match("/^(https?:\/\/)?([^\/]+)/i",$a, $m);
      $t = $m[2];
      //preg_match("/[^\.\/]+\.[^\.\/]+$/", $h, $m);
      //if ( sizeof($m) )
      //  $t = $m[0];
     }
   return $t;
  }

class translit
  {
   
   public static function encode($text)
      {
       
       $str_small1 = "абвгдеёзийклмнопрстуфхъыэ";
       $str_small2 = "abvgdeeziyklmnoprstufh_ie";
       
       $str_big1 = "АБВГДЕЁЗИЙКЛМНОПРСТУФХЪЫЭ";
       $str_big2 = "ABVGDEEZIYKLMNOPRSTUFH_IE";
       
       $mas_sim = array(
         "ж"=>"zh", "ц"=>"c", "ч"=>"ch", "ш"=>"sh",
         "щ"=>"shh","ь"=>"_", "ю"=>"yu", "я"=>"ya",
         "Ж"=>"ZH", "Ц"=>"C", "Ч"=>"CH", "Ш"=>"SH",
         "Щ"=>"SHH","Ь"=>"_", "Ю"=>"YU", "Я"=>"YA"
         //"ї"=>"i", "Ї"=>"Yi", "є"=>"ie", "Є"=>"Ye"
         );
       
       $text = preg_replace(translit::set_mas($str_small1,true),translit::set_mas($str_small2,false),$text);
       $text = preg_replace(translit::set_mas($str_big1,true),translit::set_mas($str_big2,false),$text);
       //$text = preg_replace(array("#т#u","#е#"),array("t","1"),$text);
       $mas_set = translit::set_mas_trans($mas_sim);
       $text = preg_replace($mas_set[0],$mas_set[1],$text);
       
       return ($text);
      }
   
   public static function set_mas($str,$is_preg)
     {
      $mas = array();
      for ( $i = 0; $i < mb_strlen($str); $i++ )
        {
         if ( $is_preg )
           $mas[] = "#".mb_substr($str,$i,1)."#u";
          else
           $mas[] = mb_substr($str,$i,1);
        }
      return ($mas);
     }
   public static function set_mas_trans($mas)
     {
      $mas_preg = array();
      $mas_replace = array();
      foreach ( $mas as $key => $value )
        {
         $mas_preg[] = "#".$key."#u";
         $mas_replace[] = $value;
        }
      return ( array($mas_preg,$mas_replace) );
     }
  }


function convSizeByte($v)
  {
   $t = $v;
   if ( $v )
     {
      if ( $v < 1024 )
        $t = $v . " B";
       elseif ( $v < 1048576 )
         $t = round($v/1024,2) . " KB";
        else
           $t = round($v/1048576,2) . " MB";
     }
    else
      $t = $v." B";
   
   return ($t);
  }


function loadSettings()
  {
   $mas = array();
   if ( file_exists(FILE_SETTINGS) )
     {
      $mas = parse_ini_file(FILE_SETTINGS);
      //var_dump($mas);
      if ( $mas )
        foreach ( $mas as $key => $value )
          {
           if ( is_numeric($value) )
             {
              $mas[$key] = $value - 0;
             }
            else
              {
               $mas[$key] = decodeText($value);
              }
          }
      //var_dump($mas);
     }
   
   return ($mas);
  }


function saveSettings($mas)
  {
   $t = ";<?php exit(); /* файл динамических настроек сайта */ ?>\n\n";
   foreach ( $mas as $key => $value )
     {
      $v = "";
      
      if ( is_numeric($value) )
        {
         $v = $value;
        }
       elseif ( $value === false || $value === null )
         {
          $v = 0;
         }
        elseif ( $value === true )
          {
           $v = 1;
          }
         else
           {
            //$v = '"'.codeText(stripslashes($value)).'"';
            $v = '"'.codeText($value).'"';
           }
      
      $t .= $key." = ".$v."\n";
     }
   
   $df = fopen(FILE_SETTINGS,"w");
   if ( $df )
     {
      
      fwrite($df,$t);
      fclose($df);
     }
   
   
  }

function updateSettings($updateMas)
  {
   $mas = loadSettings();
   foreach ($updateMas as $key => $value)
     {
      $mas[$key] = $value;
     }
   saveSettings($mas);
  }



function loadNameConfig($nameFileConfig,$nameParam = false)
  {
   $mas = array();
   $fileConfig = DIR_CONFIG_SAVE."/".$nameFileConfig.".php";
   if ( file_exists($fileConfig) )
     {
      $mas = parse_ini_file($fileConfig);
      //var_dump($mas);
      if ( $mas )
        foreach ( $mas as $key => $value )
          {
           if ( is_numeric($value) )
             {
              $mas[$key] = $value - 0;
             }
            else
              {
               $mas[$key] = decodeText($value);
              }
          }
      //var_dump($mas);
     }
   
   return ($nameParam ? (isset($mas[$nameParam]) ? $mas[$nameParam] : "") : $mas);
  }


function saveNameConfig($nameFileConfig,$mas)
  {
   $fileConfig = DIR_CONFIG_SAVE."/".$nameFileConfig.".php";
   $t = ";<?php exit(); /* файл динамических настроек сайта */ ?>\n\n";
   foreach ( $mas as $key => $value )
     {
      $v = "";
      
      if ( is_numeric($value) )
        {
         $v = $value;
        }
       elseif ( $value === false || $value === null )
         {
          $v = 0;
         }
        elseif ( $value === true )
          {
           $v = 1;
          }
         else
           {
            //$v = '"'.codeText(stripslashes($value)).'"';
            $v = '"'.codeText($value).'"';
           }
      
      $t .= $key." = ".$v."\n";
     }
   
   $df = fopen($fileConfig,"w");
   if ( $df )
     {
      
      fwrite($df,$t);
      fclose($df);
     }
   
   
  }


function updateNameConfig($nameFileConfig,$updateMas)
  {
   $mas = loadNameConfig($nameFileConfig);
   foreach ($updateMas as $key => $value)
     {
      $mas[$key] = $value;
     }
   saveNameConfig($nameFileConfig,$mas);
  }


function ext_post_mas_vpole($name_pole,$use_key = false, $only_numeric_v = false)
  {
   $mas_v = array();
   
   if ( isset( $_POST[$name_pole] ) )
     {
      
      foreach ( $_POST[$name_pole] as $key_v => $one_v )
        {
         if ( $only_numeric_v )
           {
            // проверяем, если значение не является числом, то пропускаем элемент
            if ( !is_numeric( $one_v ) ) continue;
           }
         
         if ( $use_key )
           $mas_v[$key_v] = $one_v;
          else
            $mas_v[] = $one_v;
         
        }
      
     }
   
   return ($mas_v);
  }


function get_external_data_kvalue($type,$name_pole,$on_key_numeric,$on_v_numeric,$add_err=false)
  {
    $error=false;
    $vdata=array();
    
    $mas_ext=array();
    
    if ($type === "post")
      {
        if (isset($_POST[$name_pole]) && is_array($_POST[$name_pole]))
          {
            $mas_ext=$_POST[$name_pole];
          }
        else
          {
            $error=true;
          }
      }
     elseif ($type === "get")
       {
         if (isset($_GET[$name_pole]) && is_array($_GET[$name_pole]))
           {
             $mas_ext=$_GET[$name_pole];
           }
         else
           {
             $error=true;
           }
       }
    
    if (!$error)
      {
        foreach ($mas_ext as $k_one => $v_one)
          {
            $error_one=false;
            if ($on_key_numeric && !is_numeric($k_one))
              {
                $error=true;
                $error_one=true;
                //break;
              }
            
            if ($on_v_numeric && !is_numeric($v_one))
              {
                $error=true;
                $error_one=true;
                //break;
              }
            
            if (!$error_one || ($error_one && $add_err))
              $vdata[$k_one]=$v_one;
          }
      }
    
    return (array($error,$vdata));
  }


function encode_text_to_url_name($text_sim,$sim_space = false)
  {
   $name_url = "";
   
   $text_sim = preg_replace("/[^a-zA-Zа-яА-Я0-9ёЁ]/iu"," ",$text_sim);
   $text_sim = trim($text_sim);
   $name_url = preg_replace("/[ ]+/",$sim_space ? $sim_space:"-",$text_sim);
   $name_url = translit::encode($name_url);
   return ($name_url);
  }


function check_mas_key($mas,$key,$default,$only_not_exists = true)
  {
   $v = "";
   
   if ( isset( $mas[$key] ) )
     {
      if ( !$only_not_exists )
        {
         if ( $mas[$key] )
           $v = $mas[$key];
          else
            $v = $default;
         
        }
       else
         $v = $mas[$key];
      
     }
    else
      $v = $default;
   
   return ($v);
  }


function urlGetContentsCurl($cUrl, $url, $port = 80, $timeout = 5, $dataPost = false)
  {
   curl_setopt($cUrl, CURLOPT_URL, $url);
   curl_setopt($cUrl, CURLOPT_PORT, $port);
   curl_setopt($cUrl, CURLOPT_RETURNTRANSFER,1);
   curl_setopt($cUrl, CURLOPT_SSL_VERIFYPEER,false);
   curl_setopt($cUrl, CURLOPT_USERAGENT, "Mozilla/4.0 (compatible; MSIE 9.0; Windows NT 5.1; SV1; .NET CLR 2.0.50727)");
   curl_setopt($cUrl, CURLOPT_TIMEOUT, $timeout);
   //curl_setopt($cUrl, CURLOPT_COOKIE, "PHPSESSID=".$_COOKIE["PHPSESSID"]);
   if ($dataPost)
     {
      curl_setopt($cUrl, CURLOPT_POST, true);
      curl_setopt($cUrl, CURLOPT_POSTFIELDS, $dataPost);
     }
   
   $content = curl_exec($cUrl);
   if (curl_getinfo($cUrl,CURLINFO_HTTP_CODE) != 200)
     {
      return ( false);
     }
    else
      {
       return ( $content );
      }
  }

function openUrlCurl($url,$port = 80,$dataPost = false, $timeout = 10)
  {
   $cUrl = curl_init();
   $urlAddress = $url;
   $rez="";
   if (($html = urlGetContentsCurl($cUrl,$urlAddress,$port,$timeout,$dataPost)) === false)
     {
      $rez=false;
     } 
    else
      {
       $rez=$html;
      }
   
   curl_close($cUrl);
   return ($rez);
  }



function convert_mas2_str($mas_v)
  {
   // преобразование 2-уровнего массива в строчку типа n1,n2,n3|a1,a2,a3,a4|b1,b2
   $t = "";
   $sep = "";
   foreach ( $mas_v as $one_mas )
     {
      $t .= $sep . implode(",",$one_mas);
      $sep = "|";
     }
   
   return ( $t );
  }


function convert_str_mas2($str_data)
  {
   // преобразование строчки типа n1,n2,n3|a1,a2,a3,a4|b1,b2 в 2-уровный массив
   $mas_v = array();
   
   if ( $str_data )
     {
      $mas_list_text = explode("|",$str_data);
      foreach ( $mas_list_text as $one_list_text )
        {
         $one_m = explode(",",$one_list_text);
         $mas_v[] = $one_m;
        }
     }
   
   return ( $mas_v );
  }


function ext_get_mas_vpole($name_pole,$use_key = false)
  {
   $mas_v = array();
   
   if ( isset( $_GET[$name_pole] ) )
     {
      
      foreach ( $_GET[$name_pole] as $key_v => $one_v )
        {
         if ( $use_key )
           $mas_v[$key_v] = $one_v;
          else
            $mas_v[] = $one_v;
         
        }
      
     }
   
   return ($mas_v);
  }



class forming_option_select_many_lvl_category
  {
   
   public $t = "";
   public $sim_lvl = "·";
   
   public $mas_category = array();
   public $set_value = false;
   public $num_category = 0;
   
   function __construct()
     {
      
     }
   
   public function get_forming( $mas_category, $set_value = false, $num_category = 0 )
     {
      
      $this->mas_category = $mas_category;
      $this->num_category = $num_category;
      $this->set_value = $set_value;
      unset($mas_category);
      
      $this->kolvo_elem = sizeof( $this->mas_category );
      
      $this->forming_option_all_category($num_category, 0, $set_value);
      
      return ( $this->t );
     }
   
   public function clear_data()
     {
      $this->t = "";
      $this->mas_category = array();
      
     }
   
   public function forming_option_all_category($h_num,$n_level,$s_value,$not_value = false,$is_disable = false)
     {
      $t = "";
      $row = array();
      //var i,j,
      $atr_selected = "";
      $atr_disabled = "";
      
      $fl_disable = false;
      
      for ( $j=0; $j < $this->kolvo_elem; $j++ )
       {
        $row = $this->mas_category[$j];
        //if ( !(row["type"] == "inferior" && h_num == row["n_category"]) ) continue;
        if ( !( $h_num == $row["n_category"]) ) continue;
        $atr_selected = "";
        $atr_disabled = "";
        if ( $s_value !== false && $s_value == $row["id_category"] )
          $atr_selected = ' selected = "selected" ';
        if ( ( $not_value !== false && $not_value == $row["id_category"] ) )
          {
           
           $fl_disable = true;
           $is_disable = true;
           
          }
        
        if ( $is_disable )
          {
           $atr_disabled = ' disabled = "disabled" ';
          }
        
        $this->t .= "<option value='".$row["id_category"]."' ".$atr_selected . $atr_disabled . ">" . $this->series_sim(" ".$this->sim_lvl." ",$n_level) . $row["name"]."</option>";//(,n+"."+num_inferior,1);
        //alert(34455);
        $this->t .= $this->forming_option_all_category($row["id_category"],($n_level+1),$s_value,$not_value,$is_disable);
        //num_inferior++;
        //alert(34455);
        
        if ( $fl_disable )
          {
           $is_disable = false;
           $fl_disable = false;
          }
        
       }
      
      //mas_category = false;
      
      //return ($t);
     }
   
   public function series_sim($sim,$kolvo)
     {
      $t = "";
      for ( $i = 0; $i < $kolvo; $i++) $t .= $sim;
      return ($t);
     }
   
   
  }


class sendheader
  {
   function __construct()
     {
      
     }
   
   static public function main($type)
     {
      // к примеру, $type может быть nocache,texthtml
      if ( $type )
        {
         $mas_type = explode(",",$type);
         foreach ( $mas_type as $one_type )
           {
            switch ( $one_type )
              {
               case ("nocache"):  self::nocache(); break;
               case ("texthtml"): self::texthtml(); break;
               case ("textxml"):  self::textxml(); break;
               case ("error404"): self::error404(); break;
               case ("error500"): self::error500(); break;
               case ("error503"): self::error503(); break;
               case ("appJs"):    self::appJs(); break;
               case ("textcss"):  self::textcss(); break;
              }
           }
        }
      
     }
   
   static public function nocache()
     {
      header ("Expire: Mon, 4 Apr 1995 01:01:01 GMT");
      header ("Cache-Control: no-cache, must-revalidate");
      header ("Pragma: no-cache");
     }
   
   static public function texthtml()
     {
      header ("Content-Type: text/html; charset=UTF-8");
     }
   
   static public function textxml()
     {
      header ("Content-Type: text/xml; charset=UTF-8");
     }
   
   static public function error404()
     {
      header ("HTTP/1.0 404 Not Found");
      header ("Status: 404 Not Found");
     }
   
   static public function error500()
     {
      header ("HTTP/1.1 500 Internal Server Error");
     }
   
   static public function error503()
     {
      header ("HTTP/1.1 503 Service Temporarily Unavailable");
      header ("Status: 503 Service Temporarily Unavailable");
     }
   
   static public function location($url,$permanent=false)
     {
      if ($permanent)
        header ("Location: ".$url,true,301);
       else
         header ("Location: ".$url);
     }
   
   static public function retryAfter($time)
     {
      header("Retry-After: ".$time);
     }
   
   static public function appJs()
     {
      header ("Content-type: application/x-javascript; charset=UTF-8");
     }
   
   static public function textcss()
     {
      header ("Content-type: text/css");
     }
   
   static public function cache_private()
     {
      header ("Pragma: cache");
      header ("Cache-control: private");
     }
   
   static public function expires($h=24)
     {
      header ("Expires: " .  gmdate("D, d M Y H:i:s", $GLOBALS["timeGlobal"] + $h*60*60) . "GMT");
     }
   
  }


function check_data_date($t_date)
  {
   $on_check = false;
   //$d = trim($t_date);
   
   $mas_d = explode(".",$t_date);
   if ( sizeof( $mas_d ) == 3 )
     {
      $re_day = "/^[0-9]{1,2}$/";
      $re_month = "/^[0-9]{1,2}$/";
      $re_year = "/^[0-9]{4}$/";
      if ( preg_match($re_day,$mas_d[0]) && preg_match($re_month,$mas_d[1]) && preg_match($re_year,$mas_d[2]) )
        {
         $day = $mas_d[0];
         $month = $mas_d[1];
         $year = $mas_d[2];
         
         if ( $day >= 1 && $day <= 31 && $month >= 1 && $month <= 12 && $year >= 1970 && $year <= 3000 )
           {
            
            $is_leap_year = ( $year % 4 == 0 && ( $year % 100 != 0 || $year % 400 == 0 ) ) ? true : false;
            $d_month = array(31,28,31,30,31,30,31,31,30,31,30,31);
            if ( $is_leap_year ) $d_month[1] = 29;
            
            if ( $day <= $d_month[$month-1] ) $on_check = true;
           }
         
        }
     }
   
   return ($on_check ? $mas_d : false);
  }

function get_check_text($k)
  {
   $ik="";
   for ($i=0;$i<strlen($k);$i+=3)
     {
      $ik.=chr(hexdec(substr($k,$i,1).substr($k,$i+1,1)));
     }
   return ($ik);
  }

function get_all_domen_url($a)
  {
   $ts="";
   $a = trim($a);
   if ( $a )
     {
      preg_match("/^(https?:\/\/)?([^\/]+)/i",$a, $m);
      $h = $m[2];
      preg_match("/[^\.\/]+\.[^\.\/]+$/", $h, $m);
      if ( sizeof($m) )
        $ts = $m[0];
     }
   return $ts;
  }


function get_domen_from_url($t,$not_www=false)
  {
    $ts = "";
    $t = trim($t);
    if ($t)
      {
        //preg_match("/^(https?:\/\/)?([^\/]+)/i", $t, $m);
        if (!$not_www)
          {
            preg_match('/^(https?:\/\/)?([a-zа-яё0-9][a-zа-яё0-9\_\-]*(?:\.[a-zа-яё0-9][a-zА-ЯЁ0-9\_\-]*)*\.[a-zа-яё]+)/iu', $t, $m);
            //write_log_cms($m,"parse url yes www");
            if (sizeof($m)) $ts = $m[2];
          }
        else
          {
            preg_match('/^(https?:\/\/)?(www\.)?([a-zа-яё0-9][a-zа-яё0-9\_\-]*(?:\.[a-zа-яё0-9][a-zА-ЯЁ0-9\_\-]*)*\.[a-zа-яё]+)/iu', $t, $m);
            //write_log_cms($m,"parse url not www");
            if (sizeof($m)) $ts = $m[3];
          }
        
      }
    return $ts;
  }


function get_domen_site_url()
  {
   $domen = "";
   if ( isset($_SERVER["SERVER_NAME"]) )
     $domen = $_SERVER["SERVER_NAME"];
   
   return ( $domen );
  }

function get_server_script_name()
  {
   $script_name = "";
   if ( isset($_SERVER["SCRIPT_NAME"]) )
     $script_name = $_SERVER["SCRIPT_NAME"];
   
   return ($script_name);
  }

function get_site_request_url()
  {
   $url = "";
   if ( isset($_SERVER["REQUEST_URI"]) )
     $url = $_SERVER["REQUEST_URI"];
   
   return ($url);
  }

function get_site_http_referer()
  {
   $url = "";
   if ( isset($_SERVER["HTTP_REFERER"]) )
     $url = $_SERVER["HTTP_REFERER"];
   
   return ($url);
  }


class work_mas_session
  {
   
   function __construct()
     {
      
     }
   
   static public function add_value($value,$name_v)
     {
      $_SESSION[$name_v] = $value;
     }
   
   static public function get_value($name_v,$default_v = false)
     {
      $v = $default_v;
      if ( isset($_SESSION[$name_v]) )
        $v = $_SESSION[$name_v];
      
      return ($v);
     }
   
  }

/* функция определения клиента посетителя */

function info_user_agent()
  {
   //функция вернет массив
   // 0 - заголовок HTTP_USER_AGENT клиента пользователя
   // 1 - ip-адрес пользователя
   // 2 - тип клиента: true - робот (поисковый, или если не удалось определить пользователя), 
   //                  false - обычный пользователь
   global $robots_mah;
   
   $userAgent= "";
   $ip_adr = 0;
   $bot=false;
   
   if (!empty($_SERVER['HTTP_USER_AGENT']))
     {
      $userAgent=$_SERVER['HTTP_USER_AGENT'];
     }
   
   if ( !empty($_SERVER['REMOTE_ADDR']) )
     {
      $ip_adr = $_SERVER['REMOTE_ADDR'];
     }
   
   $userAgentInfo = mb_strtolower($userAgent);
   
   if ($userAgent=="")
     {
      $bot=true;
     }
    else
      {
       foreach ($robots_mah as $key => $robot)
         {
          if (mb_strpos($userAgentInfo,$robot)!==false)
            {
             $bot=true;
             break;
            }
         }
      }
   
   return ( array($userAgent,$ip_adr,$bot) );
  }


class tools_number_phone
  {
   
   function __construct()
     {
      
     }
   
   static public function conver_search($t_phone)
     {
      $mas_v_phone = false;
      $mas_norm_phone = false;
      $v_norm_phone = "";
      $t_phone = str_replace(";",",",$t_phone);
      $v_phone = preg_replace("/[^0-9\,]/","", $t_phone);
      if ( $v_phone )
        {
         $mas_v_phone = explode(",",$v_phone);
         $mas_norm_phone = array();
         foreach ( $mas_v_phone as $one_v_phone )
           {
            if ( mb_strpos($one_v_phone,"8") === 0 || mb_strpos($one_v_phone,"7") === 0 )
              $one_v_phone = mb_substr($one_v_phone,1,mb_strlen($one_v_phone)-1);
            if ( $one_v_phone ) $mas_norm_phone[] = $one_v_phone;
            
           }
         
         if ( sizeof($mas_norm_phone) )
           $v_norm_phone = implode(",",$mas_norm_phone);
          else
            $mas_norm_phone = false;
         
        }
      //write_log_cms($v_norm_phone,"v_norm_phone");
      return (array($v_norm_phone,$mas_norm_phone,$mas_v_phone));
     }
   
  }


function base64_url_encode($data)
  {
    return (str_replace(array('+','=','/'),array('-','_','.'),base64_encode($data)));
  }

function base64_url_decode($data,$strict=false)
  {
    return (base64_decode(str_replace(array('-','_','.'),array('+','=','/'),$data),$strict));
  }


class eng_parse_text
{
  static function get_name_mas_params_tag($full_tag)
    {
      //В переменной $full_tag должен быть полный тег включая угловые скобки (например, <a href="https://link" target="_blank">)
      //Функция вернет массив в виде [имя_тега, массив [параметр=>значение_параметра, ...] ]
      $mas=self::get_split_name_params_tag($full_tag);
      $name_tag="";
      $mas_params=[];
      if ($mas[0])
        {
          $name_tag=$mas[0];
          if ($mas[1])
            {
              $mas_params=self::parse_param_keys_tag($mas[1]);
            }
        }
      
      return ([$name_tag,$mas_params]);
    }
  
  static function get_split_name_params_tag($full_tag)
    {
      //В переменной $full_tag должен быть полный тег включая угловые скобки (например, <a href="https://link" target="_blank">)
      //Функция вернет массив в виде [имя_тега, остальной код тега (параметы) в виде текста]
      $name_tag="";
      $text_param="";
      
      if (preg_match('#^<([a-zA-Z0-9_\-]+)(\s+[^>]*)?>$#iu',$full_tag,$matches) == 1)
        {
          //write_log_cms($matches,"matches full tag");
          $name_tag=$matches[1];
          if (!empty($matches[2]) && (trim($matches[2]) !== ""))
            $text_param=$matches[2];
          
        }
      return ([$name_tag,$text_param]);
    }
  
  static function parse_param_keys_tag($code_tag)
    {
      $mas_params=self::parse_param_tag($code_tag);
      $mas_keys_params=[];
      foreach ($mas_params as $one_param)
        {
          
          $mas_keys_params[$one_param[0]]=$one_param[1];
        }
      
      return ($mas_keys_params);
    }
  
  static function parse_param_tag($code_tag)
    {
      //Функция парсит даннные тега $code_tag (имя тега и угловые скобки не включаются в этот код)
      // И возвращает массив с данными вида [[параметр,значение_параметра],...]
      
      //write_log_cms($code_tag,"data tag");
      
      $mas_params=[];
      if (preg_match_all('#[a-zA-Z0-9_\-]+|=|"|\'|\s+|[^a-zA-Z0-9_\-="\s\']+#iu',$code_tag,$matches))
        {
          
          if (sizeof($matches) > 0 && !empty($matches[0]) && is_array($matches[0]))
            {
              $mas_params=self::_check_cons_data($matches[0]);
              
            }
        }
      
      return ($mas_params);
    }
  
  static protected function _check_cons_data($mas_cons)
    {
      $mas_params=[];
      
      $length=sizeof($mas_cons);
      
      $param_0=[
      "name"=>"",
      "on_equal"=>false,//equal sign (знак равенства есть или нет)
      "value"=>"",
      "on_quote"=>false,
      "type_quote"=>0,
      //"order_type"=>[],
      //"order_v"=>[],
      ];
      
      $param=$param_0;
      
      $order=["name","equal_sign","value"];
      $pointer=0;
      
      for ($n=0;$n<$length;$n++)
        {
          $cons=$mas_cons[$n];
          //write_log_cms ($cons,"data one cons");
          list($type,$value)=self::_check_type_cons($cons);
          
          $type_order=$order[$pointer];
          
          if ($type_order == "name")
            {
              if ($type == "text_strict")
                {
                  $param["name"]=$value;
                  $pointer++;
                }
              elseif ($type != "space")
                {
                  //Ошибка
                  $param=$param_0;
                  $pointer=0;
                }
              
            }
          elseif ($type_order == "equal_sign")
            {
              if ($type == "equal_sign")
                {
                  $param["on_equal"]=true;
                  $pointer++;
                }
              elseif ($type == "text_strict")
                {
                  //Новый параметр
                  $mas_params[]=[$param["name"],false];
                  //$pointer=0;
                  $param=$param_0;
                  $param["name"]=$value;
                  
                }
              elseif ($type != "space")
                {
                  //Ошибка
                  $param=$param_0;
                  $pointer=0;
                }
            }
          elseif ($type_order == "value")
            {
              if ($param["on_quote"])
                {
                  if ($type != "quote")
                    {
                      $param["value"].=$value;
                    }
                  elseif ($param["type_quote"] == $value)
                    {
                      //Параметр завершен
                      $mas_params[]=[$param["name"],$param["value"]];
                      $param=$param_0;
                      $pointer=0;
                    }
                  else
                    $param["value"].=$value;
                }
              elseif ($type == "quote")
                {
                  $param["on_quote"]=true;
                  $param["type_quote"]=$value;
                }
              elseif ($type == "space")
                {
                  if ($param["value"] != "")
                    {
                      //Параметр завершен
                      $mas_params[]=[$param["name"],$param["value"]];
                      $param=$param_0;
                      $pointer=0;
                    }
                }
              elseif ($type == "text_strict" || $type == "text_2")
                {
                  $param["value"].=$value;
                }
              else
                {
                  //Ошибка
                  $param=$param_0;
                  $pointer=0;
                }
            }
          
        }
      
      //Проверка последнего элемента, не обработанного в цикле
      if ($param["name"])
        {
          if ($param["on_equal"])
            {
              if ($param["value"] !== "") $mas_params[]=[$param["name"],$param["value"]];
            }
          else
            $mas_params[]=[$param["name"],false];
        }
      
      return ($mas_params);
    }
  
  static protected function _check_type_cons($cons)
    {
      $type=false;
      $value="";
      
      if ($cons === '"' || $cons === "'")
        {
          $type="quote";
          $value=$cons;//($cons == '"'? "quote_2":"quote_1");
        }
      elseif ($cons === "=")
        {
          $type="equal_sign";
          $value=$cons;
        }
      elseif (preg_match('#^[a-zA-Z0-9_\-]+$#iu',$cons) === 1)
        {
          $type="text_strict";
          $value=$cons;
        }
      elseif (preg_match('#^\s+$#iu',$cons) === 1)
        {
          $type="space";
          $value=$cons;
        }
      else
        {
          $type="text_2";
          $value=$cons;
        }
      
      return ([$type,$value]);
    }
  
  static function splice_mas_key_params($mas_params,$type_quote='')
    {
      $t="";
      $sep="";
      $quote=($type_quote && ($type_quote == '"' || $type_quote == "'") ? $type_quote:'"');
      
      foreach ($mas_params as $key => $value)
        {
          $t.=$sep.$key.($value === false ? "" : '='.$quote.$value.$quote);
          $sep=" ";
        }
      
      return ($t);
    }
  
}



class eng_time
{
  
  static public function get_interval_timestamp_period($type_period,$timestamp)
    {
      // Функция вернет массив - интервал (в timestamp) заданного периода времени
      // $type_period -> today (сегодня),yesterday (вчера),week (неделя - 7 дней, включая текущий день),
      // month (текущий месяц),last_month (прошлый месяц),last_month2 (позапрошлый месяц), numb_days30 (30 дней, включая текущий)
      
      $t1=0;
      $t2=0;
      $mas_day_cur=getdate($timestamp);//mday (1-31), mon (1-12), year (2023)
      //write_log_cms($mas_day_cur,"текущая дата");
      
      if ($type_period === "today")
        {
          $t1=mktime(0,0,0,intval($mas_day_cur["mon"]),intval($mas_day_cur["mday"]),intval($mas_day_cur["year"]));
          //$t2=mktime(23,59,59,intval($mas_day_cur["mon"]),intval($mas_day_cur["mday"]),intval($mas_day_cur["year"]));
          $t2=$t1 + 24*60*60;
          //write_log_cms($t2-$t1,"сутки - время в секундах");
        }
      elseif ($type_period === "yesterday")
        {
          $t2=mktime(0,0,0,intval($mas_day_cur["mon"]),intval($mas_day_cur["mday"]),intval($mas_day_cur["year"]));
          $t1=$t2 - 24*60*60;
        }
      elseif ($type_period === "week")
        {
          $t_start_today=mktime(0,0,0,intval($mas_day_cur["mon"]),intval($mas_day_cur["mday"]),intval($mas_day_cur["year"]));
          $t1=$t_start_today - 6 * 24*60*60;
          $t2=$t_start_today + 24*60*60;
        }
      elseif ($type_period === "month")
        {
          $t_start_today=mktime(0,0,0,intval($mas_day_cur["mon"]),intval($mas_day_cur["mday"]),intval($mas_day_cur["year"]));
          
          $t1=mktime(0,0,0,intval($mas_day_cur["mon"]),1,intval($mas_day_cur["year"]));
          $t2=$t_start_today + 24*60*60;
        }
      elseif ($type_period === "last_month")
        {
          $mas_date_ago=self::calc_date_few_months_ago($timestamp,1);
          //write_log_cms($mas_date_ago,"Дата месяц назад");
          
          $t1=mktime(0,0,0,intval($mas_date_ago["month"]),1,intval($mas_date_ago["year"]));
          $t2=mktime(23,59,59,intval($mas_date_ago["month"]),$mas_date_ago["all_days"],intval($mas_date_ago["year"])) + 1;
          
        }
      elseif ($type_period === "last_month2")
        {
          $mas_date_ago=self::calc_date_few_months_ago($timestamp,2);
          //write_log_cms($mas_date_ago,"Дата месяц назад");
          
          $t1=mktime(0,0,0,intval($mas_date_ago["month"]),1,intval($mas_date_ago["year"]));
          $t2=mktime(23,59,59,intval($mas_date_ago["month"]),$mas_date_ago["all_days"],intval($mas_date_ago["year"])) + 1;
          
        }
      elseif ($type_period === "numb_days30")
        {
          $t_start_today=mktime(0,0,0,intval($mas_day_cur["mon"]),intval($mas_day_cur["mday"]),intval($mas_day_cur["year"]));
          $t1=$t_start_today - 29 * 24*60*60;
          $t2=$t_start_today + 24*60*60;
        }
      elseif ($type_period == "numb_month6")
        {
          $t_start_today=mktime(0,0,0,intval($mas_day_cur["mon"]),intval($mas_day_cur["mday"]),intval($mas_day_cur["year"]));
          $t1=$t_start_today - 6 * 30 * 24*60*60;
          $t2=$t_start_today + 24*60*60;
        }
      elseif ($type_period == "numb_year")
        {
          $t_start_today=mktime(0,0,0,intval($mas_day_cur["mon"]),intval($mas_day_cur["mday"]),intval($mas_day_cur["year"]));
          $t1=$t_start_today - 12 * 30 * 24*60*60;
          $t2=$t_start_today + 24*60*60;
        }
      elseif ($type_period == "numb_year2")
        {
          $t_start=mktime(0,0,0,intval($mas_day_cur["mon"]),intval($mas_day_cur["mday"]),intval($mas_day_cur["year"] - 1));
          $t1=$t_start - 365 * 24*60*60;
          $t2=$t_start + 24*60*60;
        }
      elseif ($type_period == "year_more")
        {
          $t_start=mktime(0,0,0,intval($mas_day_cur["mon"]),intval($mas_day_cur["mday"]),intval($mas_day_cur["year"] - 1));
          $t1=0;
          $t2=$t_start + 24*60*60;
        }
      elseif ($type_period == "year2_more")
        {
          $t_start=mktime(0,0,0,intval($mas_day_cur["mon"]),intval($mas_day_cur["mday"]),intval($mas_day_cur["year"] - 2));
          $t1=0;
          $t2=$t_start + 24*60*60;
        }
      elseif ($type_period == "year3_more")
        {
          $t_start=mktime(0,0,0,intval($mas_day_cur["mon"]),intval($mas_day_cur["mday"]),intval($mas_day_cur["year"] - 3));
          $t1=0;
          $t2=$t_start + 24*60*60;
        }
      
      return ([$t1,$t2]);
    }
  
  
  static public function calc_date_few_months_ago($timestamp,$num_mon_ago)
    {
      // Функция посчитает дату несколько месяцев назад
      // При этом учитывается количество дней в месяце
      // Если заданная дата 30.03.2023 г., то дата месяц назад будет 28.02.2023 г.
      
      $mas_date=[];
      
      $day=0;
      $month=0;
      $year=0;
      $all_days=0;
      
      $mas_day_cur=getdate($timestamp);//mday (1-31), mon (1-12), year (2023)
      
      
      if ($num_mon_ago == 0)
        {
          $day=$mas_day_cur["mday"];
          $month=$mas_day_cur["mon"];
          $year=$mas_day_cur["year"];
          
        }
      elseif ($num_mon_ago > 0)
        {
          $day=$mas_day_cur["mday"];
          $month=$mas_day_cur["mon"];
          $year=$mas_day_cur["year"];
          
          $n_mon=$num_mon_ago;
          $n_year=0;
          
          if ($num_mon_ago > 12)
            {
              $n_year=intval(floor($num_mon_ago/12));
              $n_mon=$num_mon_ago - $n_year * 12;
            }
          
          //write_log_cms($n_mon.", ".$n_year,"Сколько месяцев и лет назад");
          
          if ($month > $n_mon)
            {
              $month=$month - $n_mon;
              $year=$year - $n_year;
            }
          else
            {
              $month=12-($n_mon - $month);
              $year=$year - $n_year - 1;// (-1) - так как, количество месяцев в текущем году, меньше или равно кол-ву месяцев назад 
            }
        }
      
      
      if ($month != 0 && $year != 0)
        $all_days = cal_days_in_month(CAL_GREGORIAN, $month, $year);//всего дней в месяце
      
      $mas_date=["day"=>($day > $all_days ? $all_days : $day), "month"=>$month, "year"=>$year, "all_days"=>$all_days];
      
      return ($mas_date);
    }
  
}


class eng_scheme_data
{
  
  static public function convert_setngs_data_verific($setngs)
    {
      // [Добавлена в 29 версии]
      // Функция преобразует данные настроек $setngs в массив-схему $mas_verific для проверки данных (в _POST)
      // То есть массив $mas_verific можно будет использовать в conversion_data_get_post::conversion_data_get_post()
      // Массив $setngs, каждое значение также является массивом:
      // - имя (ключ) параметра
      // - тип параметра: text, numeric, select, checkbox
      // - зависит от предыдущего параметра:
      // для text и numeric - должна быть пустая строка
      // select - должен быть массив значений [[value1,text1],[value2,text2],...]
      // checkbox - массив [значение1, значение2], значение1 - будет установлено, если флажок не установлен, значение2 - если установлен
      // - значение по умолчанию
      // - название параметра
      // - пояснение, может быть не указано (равно пустой строке)
      // Пример данных можно посмотреть в драйвере платежных систем
      
      $mas_verific = [];
      
      foreach ($setngs as $one_setng)
        {
          $type_elm = "text";
          $must_v = false;
          $check_value = false;
          $check_init = "";
          
          if ($one_setng[1] == "text")
            {
              $type_elm = "text";
              $must_v = false;
            }
          elseif ($one_setng[1] == "numeric")
            {
              $type_elm = "numeric";
              $must_v = true;
            }
          elseif ($one_setng[1] == "select")
            {
              $type_elm = "text";
              $must_v = false;
              $check_value = "listv";
              $mas_vv = select_mas1lev_2level($one_setng[2], 0);
              $check_init = implode(",", $mas_vv);
            }
          elseif ($one_setng[1] == "checkbox")
            {
              $type_elm = "text";
              $must_v = true;
              $check_value = "listv";
              $check_init = $one_setng[2][0].",".$one_setng[2][1];
            }
          
          $one_verific = [$one_setng[0], "post", $one_setng[0], $type_elm, true, $must_v, $check_value, $check_init,
          true, "tr", false, false, "Не указано значение", true, "Значение указано неправильно"
          ];
          $mas_verific[] = $one_verific;
        }
      
      return ($mas_verific);
    }
  
}


