<?php

// файл php


class class_article_cache_db
  {
   
   private $obj_article_cache_category = false;
   
   function __construct()
     {
      
     }
   
   function set_obj_article_cache_category( &$obj_article_cache_category )
     {
      $this->obj_article_cache_category = &$obj_article_cache_category;
      
     }
   
   public function get_quantity_item_mas_data_category($mas_category,$n_country,$n_region,$n_city)
     {
      // $mas_category - массив с данными об категориях
      
      $mas_num_category = select_mas1lev_2level($mas_category,"id_category",false);
      
      return ( $this->get_quantity_item_mas_num_category($mas_num_category,$n_country,$n_region,$n_city) );
     }
   
   public function get_quantity_item_mas_num_category($mas_num_category,$n_country,$n_region,$n_city)
     {
      //$mas_num_category - массив с id категориями
      if ( !( $n_country > 0 ) ) $n_country = 0;
      if ( !( $n_region > 0 ) ) $n_region = 0;
      if ( !( $n_city > 0 ) ) $n_city = 0;
      $this->check_series_lvl_category($mas_num_category);
      list( $kol,$data_quantity_item ) = $this->select_data_quantity_item($mas_num_category,$n_country,$n_region,$n_city);
      
      if ( sizeof($data_quantity_item) < sizeof($mas_num_category) )
        {
         $this->check_category_no_data($mas_num_category,$data_quantity_item,$n_country,$n_region,$n_city);
         list( $kol,$data_quantity_item ) = $this->select_data_quantity_item($mas_num_category,$n_country,$n_region,$n_city);
        }
      
      $quantity = select_mas1lev_2level($data_quantity_item,"quantity",true);
      
      return ($quantity);
     }
   
   private function select_data_quantity_item($mas_num_category,$n_country,$n_region,$n_city)
     {
      $db_query = "select * from ".DB_PREF."article_quantity_item "
        ." where country = ".$n_country." and region = ".$n_region." and city = ".$n_city." and n_category IN (".( sizeof($mas_num_category) > 0 ? implode(",",$mas_num_category) : "0" ).") ";
      
      list($kol,$data_quantity_item) = obr_db_query_select_assoc_index($db_query,"n_category");
      
      return ( array($kol,$data_quantity_item) );
     }
   
   private function check_category_no_data($mas_num_category,$data_quantity_item,$n_country,$n_region,$n_city)
     {
      $mas_not_found = array();
      foreach ($mas_num_category as $num_category)
        {
         if ( empty( $data_quantity_item[$num_category] ) )
           {
            $mas_not_found[] = $num_category;
           }
         
        }
      
      if ( sizeof( $mas_not_found ) > 0 )
        {
         $this->proc_calculation_quantity($mas_not_found,$n_country,$n_region,$n_city);
        }
      
     }
   
   private function proc_calculation_quantity($mas_num_category,$n_country,$n_region,$n_city)
     {
      //$mas_num_category - массив id категорий, для которых нужно подсчитать количество объявлений
      
      $db_query = "insert into ".DB_PREF."article_quantity_item "
        ."( select 0,".$n_country.",".$n_region.",".$n_city.",0,series.n_category as n_category, count(article_item.id_item) as count_item  "
        ." from ".DB_PREF."article_series_category as series left join ".DB_PREF."article_item as article_item "
        ." on series.num_nested = article_item.n_category  "
        ." and article_item.hide='show' "
        .( $n_country > 0 ? " and ( article_item.country_item = 0 or article_item.country_item = ".$n_country." ) " : "" )
        .( $n_region > 0 ? " and ( article_item.region_item = 0 or article_item.region_item = ".$n_region." ) " : "" )
        .( $n_city > 0 ? " and ( article_item.city_item = 0 or article_item.city_item = ".$n_city." ) " : "" )
        ." where "
        .( " series.n_category IN ( ".implode(",",$mas_num_category)." ) " )
        ." group by series.n_category ) ";
      
      db_work::query($db_query);
      
     }
   
   public function check_series_lvl_category($mas_num_category)
     {
      
      //$this->check_procedure_create_series_lvl_category();
      
      
      $db_query = "select distinct n_category from ".DB_PREF."article_series_category "
        ." where n_category IN ( ".(sizeof($mas_num_category) > 0 ? implode(",", $mas_num_category ) : "0")." ) ";
      
      list($kolvo,$data_category) = obr_db_query_select_assoc_index_group($db_query,"n_category");
      
      $mas_not_found = array();
      
      if ( sizeof( $data_category ) < sizeof( $mas_num_category ) )
        {
         foreach ( $mas_num_category as $one_num )
           {
            if ( !isset( $data_category[$one_num] ) )
              $mas_not_found[] = $one_num;
           }
        }
      
      if ( sizeof($mas_not_found) > 0 )
        {
         /*
         $db_query = "call ".DB_PREF."article_create_list_series_lvl_category('".implode(",",$mas_not_found)."')";
         db_work::query($db_query);
         */
         
         foreach ($mas_not_found as $one_num)
           {
             $mas_data = $this->obj_article_cache_category->get_mas_num_data($one_num, true);
             //write_log_cms($mas_data);
             $this->insert_db_many_row_series_category($one_num,$mas_data);
           }
         
        }
      
     }
   
   private function insert_db_many_row_series_category($num_category,$mas_data)
     {
       $size=sizeof($mas_data);
       if ( $size > 0)
         {
           $db_query="";
           $first_part="insert ".DB_PREF."article_series_category (id_item, n_category, num_nested) values ";
           $list_v="";
           $kolvo_add=0;
           $max_row=500;
           $raz="";
           
           foreach ($mas_data as $key => $one_data)
             {
               $list_v.=$raz;
               $list_v.="(0,".$num_category.",".$one_data.")";
               $kolvo_add++;
               $raz=",";
               
               if ($kolvo_add >= $max_row)
                 {
                   $db_query=$first_part.$list_v;
                   //write_log_cms($db_query,"запрос insert");
                   db_work::query($db_query);
                   
                   $list_v="";
                   $raz="";
                   $kolvo_add=0;
                 }
             }
           
           if ($list_v != "")
             {
               $db_query = $first_part.$list_v;
               //write_log_cms($db_query, "запрос insert");
               db_work::query($db_query);
               
               $list_v = "";
               $raz = "";
             }
         }
       
       return (true);
     }
   
   private function check_procedure_create_series_lvl_category()
     {
      global $dbname;
      $db_query = "show procedure status";
      list ( $kolvo,$data ) = obr_db_query_select_assoc($db_query);
      
      $is_exist_create_series = false;
      $is_exist_create_list_series = false;
      
      if ( $kolvo > 0 )
        {
         foreach ( $data as $one_row )
           {
            if ( mb_strtolower($one_row["Db"]) == mb_strtolower($dbname) && mb_strtolower($one_row["Name"]) == DB_PREF."article_create_series_lvl_category" )
              {
               $is_exist_create_series = true;
               break;
              }
           }
         foreach ( $data as $one_row )
           {
            if ( mb_strtolower($one_row["Db"]) == mb_strtolower($dbname) && mb_strtolower($one_row["Name"]) == DB_PREF."article_create_list_series_lvl_category" )
              {
               $is_exist_create_list_series = true;
               break;
              }
           }
        }
      
      if ( !$is_exist_create_series )
        {
         $db_query = "CREATE PROCEDURE ".DB_PREF."article_create_series_lvl_category (IN num_category INT)
          BEGIN
           SET group_concat_max_len = 65533;
           SET @seq = num_category;
           SET @next_seq = NULL;
           INSERT INTO `".DB_PREF."article_series_category`
             SELECT 0,num_category,`id`
               FROM 
                (
                 SELECT
                     @id:=Cast(Substring_index(@seq, ',', 1) AS UNSIGNED INTEGER) as id,
                     @seq_len:=Length(@seq)-Length(@id)-1 as seq_len,
                     @next_seq:=IfNull(If(@seq_len > 0, @next_seq, NULL),
                        (
                         SELECT Group_concat(`id_category`)
                           FROM `".DB_PREF."article_category`
                           WHERE Find_in_set(`n_category`, IfNull(@next_seq, @seq)) and hide='show' 
                        )
                       ) as next_seq,
                     @seq:=If(@seq_len > 0, Right(@seq, @seq_len), IfNull(@next_seq,'')) as seq
                 FROM `".DB_PREF."article_category`
                 WHERE Length(@seq) > 0 and hide='show' 
                ) branch;
          
          END";
         
         $q_ident = obr_db_query($db_query);
        }
      
      if ( !$is_exist_create_list_series )
        {
         $db_query = "CREATE PROCEDURE ".DB_PREF."article_create_list_series_lvl_category (IN list_category TEXT)
          BEGIN
           
           SET @t_list := list_category;
           while Length(@t_list) > 0
           do
           SET @one_id:=Cast(Substring_index(@t_list, ',', 1) AS UNSIGNED INTEGER);
           call ".DB_PREF."article_create_series_lvl_category(@one_id);
           SET @t_list := right(@t_list,length(@t_list)-length(@one_id)-1);
           end while;
          END";
         
         $q_ident = obr_db_query($db_query);
        }
      
     }
   
   public function clear_cache_data($n_country,$n_region,$n_city,$num_category)
     {
      
      if ( !( $n_country > 0 ) ) $n_country = 0;
      if ( !( $n_region > 0 ) ) $n_region = 0;
      if ( !( $n_city > 0 ) ) $n_city = 0;
      
      //$mas_lvl_num = ext_mas_lvl_category($this->mas_all_category,$num_category,array($num_category),true);
      
      //$mas_series_category = search_series_num_lvl_category($this->mas_all_category,$num_category);
      
      $mas_series_category = $this->obj_article_cache_category->search_series_num_data( $num_category );
      if (!$mas_series_category) return (false);
      
      //$num_category_top = $mas_series_category[0];
      
      $t_db_query_category = $this->obj_article_cache_category->get_text_db_query_data_many_lvl( "n_category", $num_category );
      
      $t_where_category = "";
      $t_where_category = ( $t_db_query_category ? " ( ".$t_db_query_category." ) " : "" );
      $t_where_category .= ( ( sizeof($mas_series_category) > 0 ) ? ($t_where_category ? " or ":""). " n_category IN ( ".(implode(",",$mas_series_category))." ) " : "" );
      
      $db_query = "delete from ".DB_PREF."article_quantity_item where "
        //."( n_top_category = ".$num_category_top." or n_category = ".$num_category." ) "
        .$t_where_category
        ." and "
        ." ( country = 0 ".( $n_country > 0 ? " or country = ".$n_country." " : "" )
        ." or region = 0 ".( $n_region > 0 ? " or region = ".$n_region." " : "")
        ." or city = 0 ".( $n_city > 0 ? " or city = ".$n_city." " : "" )." ) ";
      
      db_work::query($db_query);
      
     }
   
   public function clear_cache_mas_item($mas_item)
     {
      foreach ( $mas_item as $one_item )
        {
         $this->clear_cache_data($one_item["country_item"],$one_item["region_item"],$one_item["city_item"],$one_item["n_category"]);
        }
      
     }
   
   public function clear_all_cache_quantity_item()
     {
      
      $db_query="truncate table  ".DB_PREF."article_quantity_item  ";
      $q_ident=obr_db_query($db_query);
      
     }
   
   public function clear_cache_series_category()
     {
      
      $db_query="truncate table `".DB_PREF."article_series_category`  ";
      $q_ident=obr_db_query($db_query);
      
      $db_query="drop procedure if exists ".DB_PREF."article_create_series_lvl_category ";
      $q_ident=obr_db_query($db_query);
      
      $db_query="drop procedure if exists ".DB_PREF."article_create_list_series_lvl_category ";
      $q_ident=obr_db_query($db_query);
      
     }
   
  }

