<?php

class eng_paysystem_interkassa
{
  
  protected $payment_amount = 0;
  protected $payment_num = 0;
  protected $is_check_query = false;
  
  protected $cfg_values=[];
  
  function __construct($cfg_values)
    {
      $this->cfg_values=$cfg_values;
    }
  
  static public function get_settings_data()
    {
      $mas_init=[
        array("use_pay_system","checkbox",["off","on"],"","Использовать платежную систему",""),
        array("ps_shop_id","text","oneline|trim","","ID-идентификатор в системе платежей interkassa.com","Например, xxxxxx-xxxxx-xxxxx-xxxxx"),
        array("ps_secret_key","text","oneline|trim","","Секретный ключ в системе interkassa.com","Например, xxxxx"),
        
        //array("ps_use","select",array(array(0,"не использовать"),array(1,"использовать")),"","Использование системы interkassa.com","использовать или нет"),
        array("name_system","text",0,"Оплата в системе interkassa.com","Описание способа оплаты","Например, Оплата в системе interkassa.com"),
        array("max_amount","numeric",0,500,"Максимальная сумма пополнения","Например, 500"),
        array("min_amount","numeric",0,10,"Минимальная сумма пополнения","Например, 10")
      ];
      
      return ($mas_init);
    }
  
  public function conversion_pay($amount)
    {
      //преобразуем сумму в валюте на сайте к валюте платежной системы
      return (1 * $amount);
    }
  
  public function init_data_form_payment($number, $amount, $description)
    {
      //global $masConfig;
      
      $data = array(
        "main" => array("accept-charset" => "UTF-8", "action" => "https://sci.interkassa.com/"),
        "elms" => array(
          array("name" => "ik_co_id", "value" => $this->cfg_values['ps_shop_id']),
          array("name" => "ik_pm_no", "value" => $number),
          array("name" => "ik_am", "value" => $amount),
          array("name" => "ik_desc", "value" => $description),
          //array("name"=>"ik_x_initpm", "value"=>"")
        )
      );
      
      return ($data);
    }
  
  public function check_data_payment()
    {
      
      $error = 0;
      $error_text = "";
      $this->payment_amount = 0;
      $this->payment_num = 0;
      
      list($error, $error_text) = $this->proc_check_data_payment();
      
      return (array($error, $error_text, $this->payment_num, $this->payment_amount, $this->is_check_query));
    }
  
  protected function proc_check_data_payment()
    {
      global $obj_control_data;//$masConfig;
      
      $mas_set = array(
        
        array("ik_co_id", "post", "ik_co_id", "text", true, false, false, false, false, false, "all", ""),
        //кошелек продавца
        array("ik_am", "post", "ik_am", "text", true, true, false, false, false, false, "all", "0"),
        //Сумма, которую заплатил покупатель. Дробная часть отделяется точкой.
        array("ik_pm_no", "post", "ik_pm_no", "text", true, true, false, false, false, false, "all", ""),
        array("ik_desc", "post", "ik_desc", "text", true, false, false, false, false, false, "all", ""),
        //array("ik_x_initpm","post","ik_x_initpm","text",true,false,false,false,false,false,"all",""),
        array("ik_pw_via", "post", "ik_pw_via", "text", true, false, false, false, false, false, "all", ""),
        array("ik_inv_st", "post", "ik_inv_st", "text", true, false, false, false, false, false, "all", ""),
        //array("ik_currency_exch","post","ik_currency_exch","text",true,false,false,false,false,false,"all",""),
        //array("ik_fees_payer","post","ik_fees_payer","text",true,false,false,false,false,false,"all","0"),
        
        array("ik_sign", "post", "ik_sign", "text", true, false, false, false, false, false, "all", ""),
        
      );
      
      $rez_control_data = $obj_control_data->processing_one_group($mas_set);
      $mas_inbox = $rez_control_data[3];
      $mas_status = $rez_control_data[5];
      
      if ($rez_control_data[0] && !$rez_control_data[1])
        {
          //данные обнаружены и ошибок нет
          
          $contr = "";
          
          if (isset($_POST))
            {
              $mas_post = $_POST;
              unset($mas_post['ik_sign']);// удаляем из данных строку подписи
              ksort($mas_post, SORT_STRING); // сортируем по ключам в алфавитном порядке элементы массива 
              array_push($mas_post, $this->cfg_values["ps_secret_key"]); // добавляем в конец массива "секретный ключ"
              $signString = implode(':', $mas_post); // конкатенируем значения через символ ":"
              $contr = base64_encode(md5($signString, true)); // берем MD5 хэш в бинарном виде по сформированной строке и кодируем в BASE64
              
            }
          
          if ($contr === $mas_inbox["ik_sign"])
            {
              $this->payment_amount = $mas_inbox["ik_am"];//сумма оплаченная пользователем
              $this->payment_num = $mas_inbox["ik_pm_no"];//номер заказа
              
              return (array(0, ""));
            }
          else
            {
              return (array(1, "контрольные ключи не совпали"));
            }
          
        }
      else
        {
          return (array(1, "ошибка с данными"));
        }
      
      return (array(1, "данных нет"));
    }
  
  public function answer_result($error, $error_text, $data_order = false)
    {
      $t = "";
      
      if ($error == 0) $t = "200";
      else
        $t = "error: ".$error_text;
      
      return ($t);
    }
  
  
}


