<?php


class eng_paysystem_robokassa
{
  
  protected $payment_amount = 0;
  protected $payment_num = 0;
  protected $is_check_query = false;
  
  protected $cfg_values=[];
  
  function __construct($cfg_values)
    {
      $this->cfg_values=$cfg_values;
    }
  
  static public function get_settings_data()
    {
      
      $mas_init=[
        array("use_pay_system","checkbox",["off","on"],"","Использовать платежную систему",""),
        array("ps_login","text","oneline|trim","","Логин в системе платежей Robokassa","Например, xxxxxxx"),
        array("ps_password1","text","oneline|trim","","Пароль N1 в системе Robokassa","Например, password1"),
        array("ps_password2","text","oneline|trim","","Пароль N2 в системе Robokassa","Например, password2"),
        
        array("ps_type_mode","select",array(array(0,"тестовый режим"),array(1,"рабочий режим")),"","Режим работы оплаты","После подключения системы robokassa.ru к сайту, нужно выбрать &laquo;рабочий режим&raquo;"),
        //array("ps_use","select",array(array(0,"не использовать"),array(1,"использовать")),"","Использование системы robokassa.ru","использовать или нет"),
        
        array("name_system","text",0,"Оплата с помощью Robokassa","Описание способа оплаты","Например, Оплата с помощью Robokassa"),
        array("max_amount","numeric",0,500,"Максимальная сумма пополнения","Например, 500"),
        array("min_amount","numeric",0,10,"Минимальная сумма пополнения","Например, 10")
      ];
      
      return ($mas_init);
    }
  
  public function conversion_pay($amount)
    {
      //преобразуем сумму в валюте на сайте к валюте платежной системы
      return (1 * $amount);
    }
  
  public function init_data_form_payment($number, $amount, $description)
    {
      //global $masConfig;
      $signature = md5($this->cfg_values["ps_login"].":".$amount.":".$number.":".$this->cfg_values["ps_password1"]);
      
      $data = array(
        "main" => array("accept-charset" => "UTF-8", "action" => "https://auth.robokassa.ru/Merchant/Index.aspx"),
        "elms" => array(
          array("name" => "MerchantLogin", "value" => $this->cfg_values['ps_login']),
          array("name" => "InvId", "value" => $number),
          array("name" => "OutSum", "value" => $amount),
          array("name" => "Description", "value" => $description),
          array("name" => "SignatureValue", "value" => $signature)
        )
      );
      
      if ($this->cfg_values["ps_type_mode"] == 0)
        $data["elms"][] = array("name" => "IsTest", "value" => "1");
      
      return ($data);
    }
  
  public function check_data_payment()
    {
      
      $error = 0;
      $error_text = "";
      $this->payment_amount = 0;
      $this->payment_num = 0;
      
      list($error, $error_text) = $this->proc_check_data_payment();
      
      return (array($error, $error_text, $this->payment_num, $this->payment_amount, $this->is_check_query));
    }
  
  protected function proc_check_data_payment()
    {
      global $obj_control_data;//$masConfig;
  
      $mas_set = array(
        array("OutSum", "post", "OutSum", "text", true, true, false, "", false, false),
        array("InvId", "post", "InvId", "numeric", true, true, false, "", false, false),
        array("SignatureValue", "post", "SignatureValue", "text", true, true, false, "", false, false),
        
      );
      
      $rez_control_data = $obj_control_data->processing_one_group($mas_set);
      $mas_inbox = $rez_control_data[3];
      $mas_status = $rez_control_data[5];
      
      if ($rez_control_data[0] && !$rez_control_data[1])
        {
          //данные обнаружены и ошибок нет
          
          $part1 = $mas_inbox['OutSum'].":".$mas_inbox["InvId"].":".$this->cfg_values["ps_password2"];
          $contr = mb_strtolower(md5($part1));
          
          if ($contr == mb_strtolower($mas_inbox["SignatureValue"]))
            {
              $this->payment_amount = $mas_inbox["OutSum"];//сумма оплаченная пользователем
              $this->payment_num = $mas_inbox["InvId"];//номер заказа
              
              return (array(0, ""));
            }
          else
            {
              return (array(1, "контрольные ключи не совпали"));
            }
          
        }
      else
        {
          return (array(1, "ошибка с данными"));
        }
      
      return (array(1, "данных нет"));
    }
  
  public function answer_result($error, $error_text, $data_order = false)
    {
      $t = "";
      
      if ($error == 0) $t = "OK".$data_order["id_order"];
      else
        $t = "ERR: ".$error_text;
      
      return ($t);
    }
  
  
}


