<?php

class eng_paysystem_unitpay
{
  
  protected $payment_amount = 0;
  protected $payment_num = 0;
  protected $is_check_query = false;
  
  protected $cfg_values = [];
  
  function __construct($cfg_values)
    {
      $this->cfg_values = $cfg_values;
    }
  
  static public function get_settings_data()
    {
      $mas_init = [
        array("use_pay_system","checkbox",["off","on"],"","Использовать платежную систему",""),
        array("ps_project_id", "text", "oneline|trim", "", "Уникальный код формы оплаты системы платежей unitpay.ru", "Например, xxx-xxxxx"),
        array("ps_secret_key", "text", "oneline|trim", "", "Секретный ключ в системе unitpay.ru", "Например, xxxxxxx"),
        
        //array("ps_use","select",array(array(0,"не использовать"),array(1,"использовать")),"","Использование системы unitpay.ru","использовать или нет"),
        array("name_system", "text", 0, "Оплата в системе unitpay.ru", "Описание способа оплаты", "Например, Оплата в системе unitpay.ru"),
        array("max_amount", "numeric", 0, 500, "Максимальная сумма пополнения", "Например, 500"),
        array("min_amount", "numeric", 0, 10, "Минимальная сумма пополнения", "Например, 10")
      ];
      
      return ($mas_init);
    }
  
  public function conversion_pay($amount)
    {
      //преобразуем сумму в валюте на сайте к валюте платежной системы
      return (1 * $amount);
    }
  
  public function init_data_form_payment($number, $amount, $description)
    {
      //global $masConfig;
      
      //$currency="RUB";
      
      $data = array(
        "main" => array(
          "accept-charset" => "UTF-8",
          "action" => "https://unitpay.ru/pay/".$this->cfg_values["ps_project_id"]
        ),
        "elms" => array(
          array("name" => "account", "value" => $number),
          array("name" => "sum", "value" => $amount),
          array("name" => "desc", "value" => $description),
          array(
          "name" => "signature",
          "value" => hash('sha256', $number."{up}".$description."{up}".$amount."{up}".$this->cfg_values["ps_secret_key"])),
        )
      );
      
      return ($data);
    }
  
  public function check_data_payment()
    {
      
      $error = 0;
      $error_text = "";
      $this->payment_amount = 0;
      $this->payment_num = 0;
      
      list($error, $error_text) = $this->proc_check_data_payment();
      
      return (array($error, $error_text, $this->payment_num, $this->payment_amount, $this->is_check_query));
    }
  
  protected function proc_check_data_payment()
    {
      global $obj_control_data;//$masConfig;
      
      $mas_set = array(
      
      array("method", "get", "method", "text", true, true, "listv", "check,pay,error", false, false, "all", 0),
      //Индикатор предварительного запроса 
      );
      
      $mas_set_params = array(
        array("unitpayId", "numeric", false),
        array("account", "numeric", true),
        array("sum", "numeric", true),
        array("profit", "numeric", false),
        array("phone", "text", false),
        array("paymentType", "text", false),
        array("operator", "text", false),
        array("date", "text", false),
        array("orderSum", "numeric", true),
        array("orderCurrency", "text", false),
        array("signature", "text", true),
      );
      
      $rez_control_data = $obj_control_data->processing_one_group($mas_set);
      $mas_inbox = $rez_control_data[3];
      $mas_status = $rez_control_data[5];
      
      $get_params = array();
      $data_params = array();
      $is_check_data_params = false;
      
      if (!empty($_GET["params"]) && is_array($_GET["params"]) && sizeof($_GET["params"]))
        {
          $get_params = $_GET["params"];//var_dump($get_params);
          $is_data = true;
          foreach ($mas_set_params as $one_init_v)
            {
              $v = false;
              if (isset($get_params[$one_init_v[0]])) $v = trim($get_params[$one_init_v[0]]);
              
              if (!$v && $one_init_v[2])
                {
                  $is_data = false;
                  break;
                }
              
              if ($one_init_v[1] == "numeric")
                {
                  if ($v === false || ($v !== "" && !is_numeric($v)))
                    {
                      $is_data = false;
                      break;
                    }
                }
              
              $data_params[$one_init_v[0]] = ($v === false ? "" : $v);
              
            }
          
          if ($is_data) $is_check_data_params = true;
          if (isset($get_params["account"]) && $get_params["account"] == "test") return (array(0, ""));
        }
      
      if ($rez_control_data[0] && !$rez_control_data[1] && $is_check_data_params)
        {
          //данные обнаружены
          $method = $mas_inbox["method"];
          if ($method == "error") return (array(0, ""));
          
          $this->is_check_query = ($method == "pay" ? false : true);
          
          $m = $get_params;
          /*
          unset ($m["sign"]);
          ksort($m);
          
          $part1 = implode("",$m);
          $part1 .= $masConfig["SP_SECRET_KEY_UNITPAY"];
          
          $contr = md5( $part1 );
          */
          
          ksort($m);
          unset($m['sign']);
          unset($m['signature']);
          array_push($m, $this->cfg_values["ps_secret_key"]);
          array_unshift($m, $method);
          
          $contr = hash('sha256', join('{up}', $m));
          
          if ($contr == $data_params["signature"])
            {
              
              if (!mb_strlen($data_params["account"])) return (array(1, "не заданы идентификационные параметры"));
              
              $this->payment_amount = $data_params["orderSum"];//сумма оплаченная пользователем
              $this->payment_num = $data_params["account"];//номер заказа
              
              return (array(0, ""));
            }
          else
            {
              return (array(1, "контрольные ключи не совпали"));
            }
          
        }
      else
        {
          return (array(1, "ошибка с данными"));
        }
      
      return (array(1, "данных нет"));
    }
  
  public function answer_result($error, $error_text, $data_order = false)
    {
      $t = "";
      
      if ($error == 0) $t = '{"result": {"message": "Услуга успешно оказана!"}}';
      else
        $t = '{"error": {"code": -32000, "message": "'.codeHtmlText($error_text).'"}}';
      
      return ($t);
    }
  
  
}


