<?php

class eng_paysystem_walletone
{
  
  protected $payment_amount = 0;
  protected $payment_num = 0;
  protected $is_check_query = false;
  
  protected $cfg_values = [];
  
  function __construct($cfg_values)
    {
      $this->cfg_values = $cfg_values;
    }
  
  static public function get_settings_data()
    {
      $mas_init=[
        array("use_pay_system","checkbox",["off","on"],"","Использовать платежную систему",""),
        array("ps_merchant_id","text","oneline|trim","","Идентификатор проекта","Например, 1xxxxxxxxxx"),
        array("ps_secret_key","text","oneline|trim","","Секретный ключ системы","Например, xxxxx"),
        
        //array("ps_use_money","select",array(array(0,"не использовать"),array(1,"использовать")),"","Использование системы walletone.com","использовать или нет"),
        array("name_system","text",0,"Оплата в системе walletone","Описание способа оплаты","Например, Оплата в системе walletone"),
        array("max_amount","numeric",0,500,"Максимальная сумма пополнения","Например, 500"),
        array("min_amount","numeric",0,10,"Минимальная сумма пополнения","Например, 10")
      ];
      
      return ($mas_init);
    }
  
  public function conversion_pay($amount)
    {
      //преобразуем сумму в валюте на сайте к валюте платежной системы
      return (1 * $amount);
    }
  
  public function init_data_form_payment($number, $amount, $description)
    {
      global $url_site;
      $currency_id="643";//Российские рубли
      $email="";
      $json="";
      //write_log_cms($description,"описание платежа");
      $v_desc=$description;//iconv("UTF-8","WINDOWS-1251",$description);
      $encode_desc= "BASE64:". base64_encode($v_desc);
      $signature="";
      
      if ($GLOBALS["user_to_site"])
        {
          $email=$GLOBALS["data_authorize_user"]["email_user"];
          //write_log_cms($email);
        }
      
      $fields=[];
      $fields["WMI_MERCHANT_ID"]=$this->cfg_values['ps_merchant_id'];
      $fields["WMI_CURRENCY_ID"]=$currency_id;
      $fields["WMI_PAYMENT_AMOUNT"]=$amount;
      $fields["WMI_PAYMENT_NO"]=$number;
      $fields["WMI_DESCRIPTION"]=$encode_desc;
      $fields["WMI_CUSTOMER_EMAIL"]=$email;
      $fields["WMI_ORDER_ITEMS"]=$json;
      $fields["WMI_SUCCESS_URL"]=$url_site."/success_payment.html";
      $fields["WMI_FAIL_URL"]=$url_site."/fail_payment.html";
      
      ksort($fields);
      //$fieldsValues="";
      
      $fieldsValues=implode("",$fields);
      
      $s1=$fieldsValues . $this->cfg_values["ps_secret_key"];
      $s2=pack("H*", md5($s1));
      $signature=base64_encode($s2);
      //write_log_cms($s2,"pack H");
      
      $data = array(
        "main" => array("accept-charset" => "UTF-8", "action" => "https://wl.walletone.com/checkout/checkout/Index"),
        "elms" => array(
          array("name" => "WMI_MERCHANT_ID", "value" => $this->cfg_values['ps_merchant_id']),
          array("name" => "WMI_CURRENCY_ID", "value" => $currency_id),
          array("name" => "WMI_PAYMENT_AMOUNT", "value" => $amount),
          array("name" => "WMI_PAYMENT_NO", "value" => $number),
          array("name" => "WMI_DESCRIPTION", "value" => $encode_desc),
          array("name" => "WMI_CUSTOMER_EMAIL", "value" => $email),
          array("name" => "WMI_ORDER_ITEMS", "value" => $json),
          array("name" => "WMI_SUCCESS_URL", "value" => $fields["WMI_SUCCESS_URL"]),
          array("name" => "WMI_FAIL_URL", "value" => $fields["WMI_FAIL_URL"]),
          array("name" => "WMI_SIGNATURE", "value" => $signature),
        )
      );
      
      return ($data);
    }
  
  public function check_data_payment()
    {
      
      $error = 0;
      $error_text = "";
      $this->payment_amount = 0;
      $this->payment_num = 0;
      
      list($error, $error_text) = $this->proc_check_data_payment();
      
      return (array($error, $error_text, $this->payment_num, $this->payment_amount, $this->is_check_query));
    }
  
  protected function proc_check_data_payment()
    {
      global $obj_control_data, $masConfig;
      
      $mas_set = array(
        array("WMI_TEST_MODE_INVOICE", "post", "WMI_TEST_MODE_INVOICE", "text", false, false, false, false, false, false, "all", 0),
        //Индикатор тестового запроса
        array("WMI_MERCHANT_ID", "post", "WMI_MERCHANT_ID", "text", true, true, false, false, false, false, "all", ""),
        //id аккаунта
        array("WMI_PAYMENT_NO", "post", "WMI_PAYMENT_NO", "text", true, true, false, false, false, false, "all", "0"),
        array("WMI_PAYMENT_AMOUNT","post","WMI_PAYMENT_AMOUNT","text", true, true, false, false, false, false, "all", "0"),
        //Сумма, которую заплатил покупатель. Дробная часть отделяется точкой.
        array("WMI_COMMISSION_AMOUNT", "post", "WMI_COMMISSION_AMOUNT", "text", true, false, false, false, false, false, "all", "0"),
        array("WMI_CURRENCY_ID", "post", "WMI_CURRENCY_ID", "text", true, false, false, false, false, false, "all", "0"),
        array("WMI_ORDER_ID", "post", "WMI_ORDER_ID", "text", true, false, false, false, false, false, "all", ""),//Идентификатор заказа в системе учета Единой кассы
        array("WMI_ORDER_STATE", "post", "WMI_ORDER_STATE", "text", true, false, false, false, false, false, "all", ""),//Состояние оплаты заказа: Accepted  — заказ оплачен
        //array("LMI_SYS_TRANS_NO", "post", "LMI_SYS_TRANS_NO", "text", true, false, false, false, false, false, "all", ""),
        //array("LMI_SYS_TRANS_DATE", "post", "LMI_SYS_TRANS_DATE", "text", true, false, false, false, false, false, "all", ""),
        array("WMI_SIGNATURE", "post", "WMI_SIGNATURE", "text", true, false, false, false, false, false, "all", ""),
        
        //array("comment","post","comment","text",true,false,false,false,false,false,"all",""),
        
      );
      
      $rez_control_data = $obj_control_data->processing_one_group($mas_set);
      $mas_inbox = $rez_control_data[3];
      $mas_status = $rez_control_data[5];
      
      if ($rez_control_data[0] && !$rez_control_data[1])
        {
          //данные обнаружены и ошибок нет
          
          $params=[];
          
          if (!empty($_POST))
            {
              foreach ($_POST as $key => $value)
                {
                  if ($key != "WMI_SIGNATURE") $params[$key] = $value;
                }
            }
          
          //write_log_cms($params,"mas params inbox");
          
          ksort($params);
          $paramsValues=implode("",$params);
          
          $s1=$paramsValues . $this->cfg_values["ps_secret_key"];
          $s2=pack("H*", md5($s1));
          $signature=base64_encode($s2);
          
          if ($signature == $mas_inbox["WMI_SIGNATURE"])
            {
              if (mb_strtoupper($mas_inbox["WMI_ORDER_STATE"]) == "ACCEPTED")
                {
                  $this->payment_amount = $mas_inbox["WMI_PAYMENT_AMOUNT"];//сумма оплаченная пользователем
                  $this->payment_num = $mas_inbox["WMI_PAYMENT_NO"];//номер заказа
                  //$this->is_check_query = ($mas_inbox["WMI_TEST_MODE_INVOICE"] == 1) ? true : false;
                  return (array(0, ""));
                }
              else
                {
                  return (array(1, "Неверное состояние запроса ".$mas_inbox["WMI_ORDER_STATE"]));
                }
            }
          else
            {
              return (array(1, "Подпись не совпадает"));
            }
          
        }
      
      return (array(1, "ошибка с данными"));
    }
  
  public function answer_result($error, $error_text, $data_order = false)
    {
      $t = "";
      
      if ($error == 0) $t = "WMI_RESULT=OK";
      else
        $t = "WMI_RESULT=RETRY&WMI_DESCRIPTION=".urlencode($error_text);
      
      return ($t);
    }
  
  
}


